typedef struct Fitsheader{
	int	nBitsPerPixel;
	int nAxis;
	int nAxis1;
	int nAxis2;
	int nAxis3;
	double dBZero;
	double dBScale;
	int bEnd;
	float ExpTime;
	
	int	nBytesPerPixel;
	int nFitsPixelSize;
	int nFitsDataSize;
	
}FITSHEADER;



void OpenCamera(long camera);
void CloseCamera(long camera);
void GetCameraInfo(char* array);
void SetCameraParam(int acquisition, int readmode, int trigger, int gain, int HBin, int VBin, float exptime, int shutter, int fan, int nFrame,  long camera); 
void DisplayCCDImage(int nWidth, int nHeight, int nFrame, long camera); 
void TakeImage(int nWidth, int nHeight, long camera, int i);


int SaveBitmap(int nWidth, int nHeight, void* pData, char* pFileName, int nMinValue, int nMaxValue);
int SaveFits(int nWidth, int nHeight,int nFrame, float exptime, long camera, char* time1, char* time2, float elapsetime, char* filepath); 
 
void DataDump(int nWidth, int nHeight, long camera, int i);
int	 OpenBitmap(char* filename); 
void ByteDisplay(int axis1, int axis2, void* data, unsigned short minvalue, unsigned short maxvalue);  

void Display3DFits(int axis, int frames, unsigned short* nMinValue, unsigned short* nMaxValue) ;
void Display3D_CCD(int axis, int frames, unsigned short* nMinValue, unsigned short* nMaxValue, long camera) ;

void Display_Line_Profile(int xposition, int yposition, int axis1, int axis2, void* data, int mode); 

void GetMinMax(void* data, int length, unsigned short* nMinValue, unsigned short* nMaxValue);
float DataMean(int axis1, int axis2, void* pData) ;
float DataStdev(int axis1, int axis2, void* pData, float mean); 

int OpenFitsFile(char* filename);
void ByteDisplay_diff(int axis1, int axis2, void* data);

void TakeBiasDark(int gain, int HBin, int VBin, float exptime, long camera, char* filepath);
int SaveBiasDark(int nWidth, int nHeight, int number, float exptime, long camera, char* filepath);

void TakeImage_FTmode(int nWidth, int nHeight, int number, long camera);

void time_start(float* gliStart, char* timestring);

void marktime_start(char* timestring);
void marktime_end(char* timestring);  
float time_difference(void);
int SaveFlatFits(int nWidth, int nHeight, int number, float exptime, long camera, char* time1, char* time2, float elapsetime, char* filepath);

int makefolderscript(char* path); 

int TakingFlat(void) ;
