#include "CCDControl.h"

#include "radioGroup.h"
#include "runtime.h"
#include "FISS.h"
#include <utility.h>  
#include "CCD.h"
#include "Atmcd32d.h"
#include <analysis.h>
#include <ansi_c.h>
#include "scanner.h"
#include "Thread.h" 
#include "TalkClientDLL.h"

extern int mainPanel;
extern int TabPanelHandle;
extern int FISSpanelSetting; 
extern int testpanel;

extern int 	temp_thread, temp_thread_id;  
extern long 	nCameraHandle1;		//camera handle1
extern long 	nCameraHandle2;		//camera handle2
extern int program_off_temp_set; 

int TempSet(int Onoff1, int Onoff2, int Temp1, int Temp2){
	//camera1
	unsigned int errorValue1, errorValue2; 
	temp_thread=1;
	Delay(0.1);
	

		if(!Onoff1){
			SetCurrentCamera(nCameraHandle1); 
			SetTemperature(Temp1);  
			errorValue1=CoolerON(); 
		}
		else
		{
			SetCurrentCamera(nCameraHandle1);
			errorValue1=CoolerOFF();
		}
			
			
		if(!Onoff2){
			
			Lan_SetTemperature(Temp2); 
			errorValue2=Lan_CoolerOn(); 
		}
		else
		{
			errorValue2=Lan_CoolerOff();
		}
		
		
		if(errorValue1!=DRV_SUCCESS || errorValue2!=DRV_SUCCESS)
		{
			temp_thread=0; 
			return 0;
		}

		if(!Onoff1||!Onoff2)
		{
			temp_thread=0;
			CmtScheduleThreadPoolFunction(DEFAULT_THREAD_POOL_HANDLE, setTempThread, NULL, &temp_thread_id);
			CmtWaitForThreadPoolFunctionCompletion(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
			CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id);				
		}
		return 1;	
}


int CameraQuitCooling(void)
{
	int current_ccd_temp1, current_ccd_temp2;
	unsigned int iCoolerStatus1, iCoolerStatus2;
	int errorValue1,errorValue2;
	int CCDTemp1, CCDTemp2;
	char buffer[100]; 
	char CCDTempStr[100]; 
	int tempOn=0;
	temp_thread=1; 
	SetTemperature(10);
	Lan_SetTemperature(10);

	SetCtrlVal(mainPanel,PANEL_CCDTEMPSTATUS, 0);   
	while(!tempOn)
	{
		errorValue1=GetTemperature(&CCDTemp1);
		
		errorValue2=Lan_GetTemperature(&CCDTemp2);
		if((CCDTemp1 >5) &&(CCDTemp2 >5))tempOn=1;
		
		if((errorValue1!=DRV_TEMP_STABILIZED) || (errorValue2!=DRV_TEMP_STABILIZED))
		{
				Delay(1);
				
				errorValue1=GetTemperature(&CCDTemp1);;
				errorValue2=Lan_GetTemperature(&CCDTemp2);
				sprintf(buffer,"CCD1: %d C CCD2: %d C\n", CCDTemp1,CCDTemp2);
				//SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,buffer);
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,buffer);
				
				sprintf(CCDTempStr, "%d %cC", CCDTemp1,176);
				SetCtrlVal(mainPanel, PANEL_CCD1TEMP,CCDTempStr);
				sprintf(CCDTempStr, "%d %cC", CCDTemp2, 176); 
				SetCtrlVal(mainPanel, PANEL_CCD2TEMP,CCDTempStr);
		}
		else
		{
			
			SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Temperature Stabilized!\n");
			SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"Temperature Stabilized!\n"); 
			Lan_CoolerOff();
			CoolerOFF();
			tempOn=1;
		}
	}

	
	return 1; 

}



