#include <userint.h>

/*******************************************************************************
		          A PROGRAM TO CONTROL FISS SCANNER AND CCD CAMERA
      HYUNG-MIN PARK(hmpark@kasi.re.kr), KWANGSU AHN (ksahn@astro.snu.ac.kr)
	  							and HEE-SOO YANG																							  

	  
	  DESCRIPTION : 
	  		1. Scanner (CODED BY KWANG-SOO AHN ORIGINALLY)
	  			-	THIS PROGRAM IS CODED USING LABWINDOWS/CVI.
	  				BUT A DLL LIBRARY TO CONTROL PMAC DEVICE IS PROVIDED
					BASED ON C++ FORMAT. THUS I COMMENTED OUT SOME LINES
					WHICH SHOW MISSING ERRORS WHILE COMPILING.
					THE FOLLOWING LINES ARE COMMENTED OUT.
					Pmacu.h 78-80, 252 , INTR.h 28 , cmplclib.h 33
				-	TO OPERATE SCANNER, IT NEED TO A HEADER FILE, "runtime.h"
				-	YOU HAVE TO CONSIDER THE POSITION OF HEADER LINE.
				-	FIRST "runtime.h", SECOND "utility.h"
				-	THE FUNCTION ASSOCIATED WITH SCANNER OPERATING IS LOCATED IN
					"Scanner.c, Scanner.h"
					
			2. CCD  (CODED BY HYUNGMIN PARK ORIGINALLY)
				-	THIS PROGRAM IS CODED USING LABWINDOWS/CVI.
					IT SUPPORT SDK(Software Development Kit) written C LANGUAGE
					THEN I INCLUDE "Atmcd32d.h" FILE IN THIS PROGRAM.
					CCD NEED TO 3 FILES: Atmcd32d.h, Atmcd32d.dll, Atmcd32m.lib
				-	THE FUNCTION ASSOCIATED WITH CCD OPERATING IS LOCATED IN
					"CCD.c, CCD.h"
					
					
			3. Grating + CCD motors (CODED BY HEE-SOO YANG ORIGINALLY)
				-	THIS PROGRAM IS CODED USING LABWINDOWS/CVI.
	  				BUT A DLL LIBRARY TO CONTROL PMAC DEVICE IS PROVIDED
					BASED ON C++ FORMAT. THEN WE CONVERT C++ CODE WITH DLL TO
					OPERATE ANSI-C OR CVI.
					THIS FILES HAVE TO LOCATE WORKING DIRECTORY AS FOLLOWS:
					DLL6K.dll, DLL6K.h, DLL6K.lib, HOMING.prg, setup.prg,IPAddr.ini,
					Wv.ini, MFC42D.dll, MFCO42D.dll, MSVCRTD.dll
				-	THE FUCTION ASSOCIATED WITH GRATING AND CCD MOTOR CONTROL IS 
					LOCATED IN "grating_focus.c, grating_focus.h"
					
					
					
			
	*REVISION HISTORY
		JUN 17 2008: MENUS ARE REARRANGED TO USER-FRIENDLY INTERFACE
		OCT 30 2008: MAKE THE FILE INCLUDED SCANNER FUNCTION
					  RENAMED ALL FILE NAME 
		JUN 23 2009: RENAMED CALLBACK FUNCTION ID FROM MAIN_PANEL TO PANEL
		JUN 30 2009: START TO ADD GRATING-CCD MOTOR FUNCTION MADE BY HEE-SOO YANG
		SEP 15 2009: MODIFY THREAD FUNCTION TO OPERATE SCANNER WHEN SCANNER TURN ON
		SEP 19 2009: CHANGE GUI INTERFACE MUCH AND ADD VIEWER FUNCTION
		 			LINE PROFILE, VALUE DISPLAY AT SOME POSITIONS	
		SEP 21 2009: FIND FILES TO OPERATE GRATING/CCD MOTOR WELL AND INCLUDE THOSE.
		SEP 22 2009: DEBUG HISTOGRAM DISPLAY AND MENUBAR
		NOV 12 2009: CHANGE FITS SAVE ROUTINE BECAUSE OF LONG PROCESS TIME.
					CHANGE FROM MY ROUTINE TO NASA CFITSIO LIBRARY FOR C++
		NOV 26 2009: CONSIDER AND MODIFY SOURCE PROGRAM FOR 2 CAMERA OBSERVATION.
		 			MEMORY ALLOCATION FOR 1 CAMERA, TAKE-SAVE-TAKE-SAVE
		DEC 07 2009: MODIFY SOME CODES TO CONSIDER USING TWO CAMERA SEQUENTIALLY
					SET1,TAKE,SET2,TAKE,SAVE1,SAVE2 <- THE METHOD AS FAST AS WE CAN 
					CASE OF SELECTION BOTH MODE, OPERATE TWO CAMERAS SEQUENTIALLY
		DEC 14 2009: REARRAGEMENT OF CALLBACK FUNCTION(SORTING FUNCTIONALLY)
		DEC 15 2009: DEBUG PIC_WINDOW CALLBACK FUNCTION
		DEC 17 2009: MODIFY SAVEBITMAP() AND MNUSAVE()
********************************************************************************/

#include "radioGroup.h"
#include "runtime.h"
#include "FISS.h"
#include <utility.h>  
#include "CCD.h"
#include "Atmcd32d.h"
#include <analysis.h>
#include <ansi_c.h>
#include "scanner.h"
#include "CCDControl.h"

#include "DLL6K.h"
#include "grating_focus.h"
#include "graphic.h"
#include "Thread.h"
#include "WvControlDLL.h"
#include "TalkClientDLL.h"   



//panel  
int mainPanel;       //HANDLE OF MAIN PANEL( г ڵ)
int FISSpanelSetting; 
int testpanel;
int TabPanelHandle;			//handle of tab panel     
int	aboutPanel; 
int menubar;

int GraphicPanel ;

int	m_solarxpos,m_solarypos, m_ringvalue;
char m_arnumber[50], m_observername[250];  


//****************************************************
///CCD parameter
//****************************************************

int 	g_nFrameNumber1;//, g_nNumberKinetics1;
int 	DataSource;			//need to distinguish Fits data and Raw data acquired by CCD
							//if DataSource=1, Taking Image by CCD
							//if DataSource=0, Display image by Fits file
//need to realize thread
//for video mode
			//thread parameter
extern int Run_thread_stop; 

///associate with temperature setting
int 	temp_thread, temp_thread_id;
int Run_thread_id; 

float 	g_fExpTime1, g_fExpTime2;			//exposure time
	
long 	nCameraHandle1;		//camera handle1
long 	nCameraHandle2;		//camera handle2
long 	nNumberOfCameras;
long 	nUnknownCameraHandle;	//

int		ccd_HBin, ccd_VBin, ccd_Gain;
int		coolingStatus=-1;

extern int 				nhDim, nvDim;
extern int				nhDim1,nvDim1,nhDim2,nvDim2;

int		sequential_number;

//extern int				framecount;					//define this paramter to apply data dump for allocated memory
extern WORD* 			g_pRawData;			//allocated data dumped real data

extern WORD*			BiasDark1;

extern BYTE* 			pFitsData;  
extern unsigned short* 	pusFitsData; //fits ȭϿ о ϸ  ؼ ȯ  .  
extern FITSHEADER		FitsHeader;  
//extern BYTE* 			planeData;
extern WORD*			planeDataCCD;
extern int				CCD_status; 	//ccd on:1, ccd off:0


float *flatdata1;
float *flatcube1;
float *caldata1;

char data_directory[30]="E:\\BBSO_Data\\";			   //Data path 
char entire_directory[250];


LARGE_INTEGER gliFreq, gliStart, gliEnd;  



//****************************************************
//****************************************************
//****************************************************






//****************************************************
///Viewer parameter
//****************************************************
int 	plotHandle;
int		ccd_camera;
float	stdev,mean;
int		panelwidth,panelheight;
//****************************************************
//****************************************************
//****************************************************




//****************************************************
///Scanner parameter
//****************************************************
int 		scan_mode=-1;  //scanning mode 0: spectrograph, 1: imaging
int 	zerostep=0; 

extern int 	Scanner_status;
extern int 	PmacAccessible;	
extern int 	Scanning;
//extern int 	take;//,both_move;
extern int  Scanner_InPosition;
extern int	Scanpos_CCDframe;
extern float	scanpos;
int 	fiss_take_mode;
int		take;

float scan_duration, scan_size, scan_speed, scan_stroke; 


//****************************************************
//****************************************************
//****************************************************






//****************************************************
///Grating/CCD Motor parameter
//****************************************************
int 		Motor_status;
int			Slit_status;

extern WvSet 		Data[50];
extern int 	SelectMotor;


//====================================
//FILE I/O parameter
FILE* 	FP;
int 	CurrentSelect_Wv;
//****************************************************
//****************************************************
//****************************************************

  












//1. MAIN FUNCTION
int main (int argc, char *argv[])
{
	int i,c;
	char str[250];
	
//	DisableBreakOnLibraryErrors(); //CVI ?? ????? ?? ??
	
	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((mainPanel = LoadPanel (0, "FISS.uir", PANEL)) < 0)
		return -1;
	
	
	if ((FISSpanelSetting = LoadPanel (0, "FISS.uir", SetFISS)) < 0)
		return -1;	
	
	if ((testpanel = LoadPanel (0, "FISS.uir", test_panel)) < 0)
		return -1;	
	
	if ((aboutPanel = LoadPanel (0, "FISS.uir", InfoPanel)) < 0)
		return -1;	
	

	if ((menubar 	= LoadMenuBar (mainPanel, "FISS.uir", MENUBAR)) < 0)
		return -1;
	
	Radio_ConvertFromTree(mainPanel, PANEL_SelectAxis);         

	//SetPanelAttribute(mainPanel,ATTR_TOP,19);
	//SetPanelAttribute(mainPanel,ATTR_LEFT,10);
	//SetPanelAttribute(mainPanel,ATTR_WIDTH,1250);
	//SetPanelAttribute(mainPanel,ATTR_HEIGHT,950);
	
	DisplayPanel(mainPanel);
	  
	GetPanelAttribute(mainPanel, ATTR_WIDTH, &panelwidth);
	GetPanelAttribute(mainPanel, ATTR_HEIGHT,&panelheight);
	
	SetCtrlAttribute(mainPanel, PANEL_IDLDRAWWIDGET,ATTR_VISIBLE,0);
	RunUserInterface ();
	DiscardPanel (mainPanel);
	

	return 0;
}


int CVICALLBACK panel_proc (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			QuitCallback(0, 0, EVENT_COMMIT,NULL, 0, 0);
			break;
	}
	return 0;
}





//2-4. SETUPư  Ǵ Լ
//callback function when you click setup button. display setup pannel
int CVICALLBACK Set_FISS_parameter (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	
	switch (event)
	{
		case EVENT_COMMIT:
			DisplayPanel(FISSpanelSetting);
		 
			// κ ¾â   PIC_WINDOW  ʵ ִ κ.
			
				
			
													
			

			if(CCD_status == 1)
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 0, ATTR_DIMMED, 0);
			}
			else
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 0, ATTR_DIMMED, 1); 
			}
			
			
			if(Scanner_status ==1)
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 1, ATTR_DIMMED, 0); 
			}
			else
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 1, ATTR_DIMMED, 1);
			}
			
			
			if(Motor_status == 1)
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 2, ATTR_DIMMED, 0);  
			}
			else
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 2, ATTR_DIMMED, 1); 
			}
			break;
	}
	return 0;
}


int CVICALLBACK SetFISS_proc (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			HidePanel(FISSpanelSetting);
		case EVENT_DISCARD:
			HidePanel(FISSpanelSetting);
			
			break;
	}
	return 0;
}




//2-5. Obs. Test Button  Ǵ Լ
int CVICALLBACK Obs_Test (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int cooleronoff1,cooleronoff2;

	
	switch (event)
	{
		case EVENT_COMMIT:
			
		
		
			
			Radio_GetMarkedOption(testpanel,test_panel_CoolerOnOff1, &cooleronoff1);
			Radio_GetMarkedOption(testpanel,test_panel_CoolerOnOff2,&cooleronoff2);			

			DisplayPanel(testpanel);  
			
			if(CCD_status == 1)
			{
				//SetCtrlAttribute(testpanel, test_panel_CCD_setCamera, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TEXTMSG, ATTR_DIMMED, 0);
				//SetCtrlAttribute(testpanel, test_panel_CoolerOnOff1,ATTR_DIMMED,0);
				//SetCtrlAttribute(testpanel, test_panel_CoolerOnOff2,ATTR_DIMMED,0);
				//SetCtrlAttribute(testpanel, test_panel_ccdTemp,ATTR_DIMMED,0);
				//SetCtrlAttribute(testpanel, test_panel_ccdTemp2,ATTR_DIMMED,0); 
				SetCtrlAttribute(testpanel, test_panel_setCooler,ATTR_DIMMED,0); 
				SetCtrlAttribute(testpanel, test_panel_TB_Text_Monitor,ATTR_DIMMED,0);
				if(cooleronoff1==1)
				{
					//SetCtrlAttribute(testpanel, test_panel_ccdTemp,ATTR_DIMMED,0);
					SetCtrlAttribute(testpanel, test_panel_setCooler,ATTR_DIMMED,0);
				}
				if(cooleronoff2==1)
				{
					//SetCtrlAttribute(testpanel, test_panel_ccdTemp2,ATTR_DIMMED,0);
					SetCtrlAttribute(testpanel, test_panel_setCooler,ATTR_DIMMED,0); 
				}
				
			}
			
			if(Scanner_status == 1)
			{
				SetCtrlAttribute(testpanel, test_panel_SlitStepDecrease, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_SlitStepSize, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_SlitStepIncrease, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_SetZero, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_upload_data, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TEXTMSG_2, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_radio_scan, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_STR_Command, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TB_Text_Monitor, ATTR_DIMMED, 0);
			}
			
			if(Motor_status == 1)
			{
				ResetPanel();
				OpenFileF(FP);
				InitPanel();
				
				SetCtrlAttribute(testpanel, test_panel_Motor_Device_Select, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Moving_Distance, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Step_Decrease, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Stop, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Step_Increase , ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Position, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TEXTMSG_4, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_radio_motor, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_STR_Command, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TB_Text_Monitor, ATTR_DIMMED, 0);
			}
			

			break;
	}
	return 0;
}


int CVICALLBACK test_panel_proc (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			//SetCtrlAttribute(testpanel, test_panel_CCD_setCamera, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TEXTMSG, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TEXTMSG, ATTR_DIMMED, 1);
			//SetCtrlAttribute(testpanel, test_panel_ccdTemp, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_setCooler,ATTR_DIMMED,1);
			//SetCtrlAttribute(testpanel, test_panel_CoolerOnOff1,ATTR_DIMMED,1);
			//SetCtrlAttribute(testpanel, test_panel_ccdTemp2, ATTR_DIMMED, 1);
			//SetCtrlAttribute(testpanel, test_panel_CoolerOnOff2,ATTR_DIMMED,1);						
				
			SetCtrlAttribute(testpanel, test_panel_SlitStepDecrease, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_SlitStepSize, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_SlitStepIncrease, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_SetZero, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_upload_data, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TEXTMSG_2, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_radio_scan, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_STR_Command, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TB_Text_Monitor, ATTR_DIMMED, 1);
				
			SetCtrlAttribute(testpanel, test_panel_Motor_Device_Select, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Moving_Distance, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Step_Decrease, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Stop, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Step_Increase , ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Position, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TEXTMSG_4, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_radio_motor, ATTR_DIMMED, 1);				

			HidePanel(testpanel);

			break;
	}
	return 0;
}



//2-6. Open ư   Ǵ Լ
int CVICALLBACK cmdOpen (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int ret;
	char Buff[MAX_PATHNAME_LEN];
	char* format=".bmp";
	char* n;
	int radiogroup_index=0;
	char temp[10];
	
	switch (event)
	{
		case EVENT_COMMIT:
			
			SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED, 1); 
			SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED, 1);
			//////////////////
			ret=FileSelectPopup("","*.fts","*.fts;*.bmp;*.fit;*.fits","Load Data File",VAL_LOAD_BUTTON,0,0,1,0,Buff);
			if(ret)
			{
				SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_GRAPH, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_xpos, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_ypos, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_value, ATTR_DIMMED, 0);
			//	SetCtrlAttribute(mainPanel, PANEL_Show_Hist, ATTR_DIMMED, 0);				
				
				n=strstr(Buff,format);
				if(n==NULL)
				{
					OpenFitsFile(Buff);
					
					if(FitsHeader.nAxis==3 && FitsHeader.nAxis3>1)
					{
						SetCtrlAttribute(mainPanel, PANEL_SelectAxis, ATTR_DIMMED, 0);
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_DIMMED, 0);
					}
					
					
					if(FitsHeader.nAxis==3 && FitsHeader.nAxis3==1)
					{
						SetCtrlAttribute(mainPanel, PANEL_SelectAxis, ATTR_DIMMED, 1);
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_DIMMED, 1);
					}
					
					if(FitsHeader.nAxis==2)
					{
						SetCtrlAttribute(mainPanel, PANEL_SelectAxis, ATTR_DIMMED, 1);
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_DIMMED, 1);						
					}
					
					
					sprintf(temp, "%.2f", mean);
					SetCtrlVal(mainPanel, PANEL_datamean, temp);
					sprintf(temp, "%.2f", stdev);
					SetCtrlVal(mainPanel, PANEL_datastdev, temp);
					
					sprintf(temp, "%d", FitsHeader.nAxis1);
					SetCtrlVal(mainPanel, PANEL_nAxis1, temp);
					sprintf(temp,"%d",FitsHeader.nAxis2);
					SetCtrlVal(mainPanel, PANEL_nAxis2, temp);
					
					if(FitsHeader.nAxis==3)
					{
						sprintf(temp, "%d", FitsHeader.nAxis3);
						SetCtrlVal(mainPanel, PANEL_nAxis3, temp);
					}
					
					sprintf(temp, "%.2f",FitsHeader.ExpTime);
					SetCtrlVal(mainPanel, PANEL_ExpTime, temp);
					
				}
				else
				{
					
					OpenBitmap(Buff); 	
				}
				Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);
			}	
			break;
	}
	return 0;
}


//2-7 RUN ư   ϴ Լ
// ϴ κ(CCD or CCD+Scanner )
int CVICALLBACK cmd_Run (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
/*	int 			i;
	char 			temp[50],temp1[50],temp2[50],temp3[50],temp4[50];
	unsigned short 	minvalue,maxvalue;
	int				ccd_acqmode; //ccd acquisition mode(single, video, frame transfer)
	float diff_time1,diff_time2;
	int				ii,j,k,startpoint1,startpoint2;
	int				flatstart1,flatstart2;
	int				shift[7]={-110,-90,-30,0,20,80,115};
	int				id,handle;
*/  int attr_top, attr_width, attr_left;

	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED, 1); 
			SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED, 1);
			SetCtrlAttribute(mainPanel, PANEL_cmd_Run, ATTR_DIMMED, 1); 
			//if(!temp_thread){
			//	MessagePopup("Warning", "CCD Temperature is not stabilized. Please wait");
			//	return 0;
			//}
	
			if(GraphicPanel)DiscardPanel(GraphicPanel);
			
			
			if((CCD_status!=1) || (Scanner_status!=1))return -1;		//case of CCD On, Scanner On     
			if(ccd_camera==4)
				if(TakingFlat()){
					SetCtrlAttribute(mainPanel, PANEL_cmd_Run, ATTR_DIMMED, 0); 
					return 1;
				}
				
				
				
			CmtScheduleThreadPoolFunctionAdv(		DEFAULT_THREAD_POOL_HANDLE,//handle 
													RunThread, 				   //thread function name
													NULL, 					   //thread function data
													THREAD_PRIORITY_HIGHEST,   //priority
													AfterRunThread,					   //callback function
													EVENT_TP_THREAD_FUNCTION_END,					   //callback event mask
													NULL,					   //callback data
													RUN_IN_SCHEDULED_THREAD,   //callback thread ID
													&Run_thread_id  		   //thread function ID 
											);		   
												
			CmtWaitForThreadPoolFunctionCompletion(DEFAULT_THREAD_POOL_HANDLE, Run_thread_id, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
			CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, Run_thread_id);
			
			
			if ((GraphicPanel = LoadPanel (0, "FISS.uir", GRAPHICPNL)) < 0)
								return -1;
			GetPanelAttribute(mainPanel, ATTR_TOP, &attr_top);
			GetPanelAttribute(mainPanel, ATTR_WIDTH, &attr_width);
			GetPanelAttribute(mainPanel, ATTR_LEFT, &attr_left);
	
			SetPanelAttribute(GraphicPanel, ATTR_TOP, attr_top); 
			SetPanelAttribute(GraphicPanel, ATTR_LEFT, attr_left+attr_width+7);
			DisplayPanel(GraphicPanel);
		
				
			if(ccd_camera==1){
				DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);  
			}
			else if(ccd_camera==0) {
				DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);
			}
			else DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1); 
			
			SetCtrlAttribute(mainPanel, PANEL_cmd_Run, ATTR_DIMMED, 0);
			
			break;
	}
	return 0;
}


//2-8. STOP ư   Ǵ Լ
int CVICALLBACK cmdStop (int panel, int control, int event,
			void *callbackData, int eventData1, int eventData2)
{
		switch (event)
		{
			case EVENT_COMMIT:
				     //stop command
				//AbortAcquisition();
				Run_thread_stop=1;
				Lan_Run_thread_stop(1);
				break;
		}
		return 0;
}


//2-9. QUIT ư   Ǵ Լ
int CVICALLBACK QuitCallback (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int current_ccd_temp1;
	char temp[255];
	int errorValue;
	switch (event)
	{
		case EVENT_COMMIT:
			Run_thread_stop=1; //stop thread
			Lan_Run_thread_stop(1);
			
			if(Motor_status==1)
			{
				MotorDisconnect();    
				Motor_status=0;
			}			
			
			if(CCD_status==1)
			{
					if(pFitsData!=NULL)
					{
						free(pFitsData);
						pFitsData=NULL;
					}
			

					if(pusFitsData!=NULL)
					{
						free(pusFitsData);
						pusFitsData=NULL;
					}
					
					if(planeDataCCD!=NULL)
					{
						free(planeDataCCD);
						planeDataCCD=NULL;
					}
					
					if(g_pRawData)
					{
						free(g_pRawData);
						g_pRawData=NULL;
					}
					
					
					
					if(BiasDark1!=NULL)
					{
						free(BiasDark1);
						BiasDark1=NULL;
					}
					
				
					
					
					
				
					
					
					CameraQuitCooling();
					
						CloseCamera(nCameraHandle1)
							;//CLOSE CAMERA    
						CCD_status=0;
				//Lan_QuitCamera();
			}
				
			
			if(Scanner_status==1)
			{
				
				if(Scanning==1)
				{ 
					MessageBox(NULL, "Motor is still running.", "Error", MB_OK | MB_ICONINFORMATION);
				}
				else 
				{
					PmacAccessible=0;	
					CloseDevice();
					Motor_status=0;
				}
			}
			//MessagePopup("", "Before QuitUserInterface");
			sprintf(temp, "FISSFtp.exe");
			LaunchExecutable(temp);
			
			QuitUserInterface (0);
			
			break;
	}
	return 0;
}



//******************************************************************************************
//******************************************************************************************
//*********************************|  Thread Functions  |***********************************
//******************************************************************************************
//******************************************************************************************

//Synchronization between CCD and Scanner
//It operates after Scanner on.
//if take==1, it start to taking image to imaging spectroscopy
/*
int CVICALLBACK MonitoringThreadFunction (void *functionData)
{
	char response[256];
	

	while(PmacAccessible)
	{
		 ReadPosition();
		 Monitor();
//	 	if(take==1)		   //at this part, it operate ccd-scanner synchronization 
//	 	{
//			GetCurrentCamera(&nUnknownCameraHandle); 
//			if(nUnknownCameraHandle==nCameraHandle1)
//			{
//				TakeImage(nhDim1, nvDim1, nCameraHandle1, Scanpos_CCDframe-1);
//				//printf("%d ", Scanpos_CCDframe-1);
//			}	
//			if(nUnknownCameraHandle==nCameraHandle2)
//			{
//				TakeImage(nhDim2, nvDim2, nCameraHandle2, Scanpos_CCDframe-1);
//				//printf("%d ", Scanpos_CCDframe-1);
//			}
//			take=0;
//			//both_move==0;
//	 	}
		
	 }

	 return 1;

}
*/



int CVICALLBACK MonitoringThreadFunction (void *functionData)
{
	char response[256];
	

	while(PmacAccessible)
	{
		 ReadPosition();
		 Monitor();
	 	if(take==1 && fiss_take_mode==0)		   //at this part, it operate ccd-scanner synchronization 
	 	{
			GetCurrentCamera(&nUnknownCameraHandle); 
			if(nUnknownCameraHandle==nCameraHandle1)
			{
				
				TakeImage(nhDim1, nvDim1, nCameraHandle1, Scanpos_CCDframe-1);
			}	
			if(nUnknownCameraHandle==nCameraHandle2)
			{
			//	Lan_GrabImage();
			}
			take=0;
	 	}
		
		if(take==1 && fiss_take_mode==1)  //fiss_take_mode=1:flat, 0:??
		{
		 
			//SetCurrentCamera(nCameraHandle1);
			TakeImage(nhDim1, nvDim1, nCameraHandle1, Scanpos_CCDframe-1);
			
			//GrabFlatnFrame(Scanpos_CCDframe-1);
			take=0;
		}
		
	 }

	 return 1;

}



//video mode thread
int CVICALLBACK setVideoThread(void* functionData)
{
		
		return 0;
	}


//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************





//******************************************************************************************
//******************************************************************************************
//**********************|  CCD control pannel and Callback Function  |**********************
//******************************************************************************************
//******************************************************************************************


int CVICALLBACK setCooler (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char ctemp[250];
	int nTemp1, nTemp2, Onoff1,Onoff2 , errorValue;
	nTemp1=0;
	nTemp2=0;
	
	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlVal(testpanel,test_panel_TB_Text_Monitor,"CCD Cooling Status\n");
			
			GetCtrlVal(testpanel, test_panel_CoolerOnOff1, &Onoff1);
			GetCtrlVal(testpanel, test_panel_CoolerOnOff2, &Onoff2);
			GetCtrlVal(testpanel, test_panel_ccdTemp, &nTemp1);
			GetCtrlVal(testpanel, test_panel_ccdTemp2,&nTemp2);			
			if(Onoff1==0 && Onoff2==0)			   //cooler 1,2,on
			{
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCamera 1, 2 Cooler On!\n");
				sprintf(ctemp,"Cooling Temperature : %d, %d\n",nTemp1, nTemp2);
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, ctemp);
				
				TempSet(Onoff1, Onoff2, nTemp1, nTemp2);
			}
			else if(Onoff1==0 && Onoff2!=0)  //Cooler 1 on
			{
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCamera 1 Cooler On!\n");
				sprintf(ctemp,"Cooling Temperature : %d\n",nTemp1);
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, ctemp);
				TempSet(Onoff1, Onoff2,nTemp1, nTemp2);
			}
			else if(Onoff1!=0 && Onoff2==0)  //cooler 2 on
			{
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCamera 2 Cooler On!\n");
				sprintf(ctemp,"Cooling Temperature : %d\n",nTemp2);
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, ctemp);
				TempSet(Onoff1, Onoff2, nTemp1, nTemp2);
			}
			else if(Onoff1!=0 && Onoff2!=0)  //cooler 1,2 on
			{
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCamera 1,2 off!\n");
				TempSet(Onoff1, Onoff2, nTemp1, nTemp2);
			}
			else 
			{
				sprintf(ctemp, "Error, Occured in Camera Temp Control.");
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,ctemp);
			}
			break;
	}
	return 0;
}


//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************





//******************************************************************************************
//******************************************************************************************
//**********************|  Scanner Control Pannel and Callback Function  |******************
//******************************************************************************************
//******************************************************************************************
int CVICALLBACK Ampon_timer (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	extern int g_nAmpOnSeq; 
	
	switch (event)
	{
		
		case EVENT_TIMER_TICK:
			ampon_timer();
			
			if(g_nAmpOnSeq==30)			 //timer off if g_nAmpOnSeq is 30(but already timer off in scanner.c
				SetCtrlAttribute(mainPanel, PANEL_TIMER, ATTR_ENABLED, 0); 
			
			SetCtrlAttribute(testpanel, test_panel_SlitStepDecrease, ATTR_DIMMED, 0);
			SetCtrlAttribute(testpanel, test_panel_SlitStepIncrease, ATTR_DIMMED, 0);
			SetCtrlAttribute(testpanel, test_panel_SetZero, ATTR_DIMMED, 0);
			break;
	}
	return 0;
}



//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************







//******************************************************************************************************************
//******************************************************************************************************************
//*********************************| Setting Panel Callback Function |**********************************************
//******************************************************************************************************************
//******************************************************************************************************************

//if you clicked ok button on setup pannel, this operates
int CVICALLBACK FISS_setOK (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

	///ccd parameter
	int ccd_Acquisition;
	//int ccd_camera;
	char value[20];
	int ccd_Read, ccd_Trigger, ccd_Shutter, ccd_Fan;
	int ccd_Cooling, ccd_Temp;
	int n;
	int index;		//use setting wavelength to operate grating
	char string[100];
	int current_ccd_temp;
	char temp[100];
	int status,ringvalue;
	
	//making data folder
	char tempdir[150];
	
	struct tm *systime;
	time_t t;

 
	switch (event)
	{
		case EVENT_COMMIT:
			
			if(!temp_thread){
				MessagePopup("Warning", "CCD Temperature is not stabilized. Please wait");
				return 0;
			}
			
			tempdir[0]='\0';
			entire_directory[0]='\0';

			//read each value from ccd tab
			if(CCD_status == 1)
			{
				Run_thread_stop=1;
				Lan_Run_thread_stop(1);
				
				if(g_pRawData!=NULL)
				{
					free(g_pRawData);
					g_pRawData=NULL;
				}
					
			
				
				if(BiasDark1!=NULL)
				{
					free(BiasDark1);
					BiasDark1=NULL;
				}

				
				if(g_nFrameNumber1>1)
				{
					if(planeDataCCD!=NULL)
					{
						free(planeDataCCD);
						planeDataCCD=NULL;
					}
				}
				
				if(pusFitsData!=NULL)
				{
					free(pusFitsData);
					pusFitsData=NULL;
				}
				
				if(pFitsData!=NULL)
				{
					free(pFitsData);
					pFitsData=NULL;
				}
				
				if(flatdata1)
				{
					free(flatdata1);
					flatdata1=NULL;
				}
				

				
				
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle);
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setCamera, &ccd_camera);

				switch(ccd_camera)
				{
					case 0: 
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Set Current Camera 1\n");
							break;
					case 1: 
							
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Set Current Camera 2\n");
							break;
					case 2: 
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Use Both Cameras\n");
							break;
					case 3: 
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Use Both Cameras 2 frame in 1 step\n");
							break;	
					case 4:
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Flat Fielding Mode\n");
							break;
					default:
							SetCurrentCamera(nCameraHandle1);
							break;
				}
			
			
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setAcq, &ccd_Acquisition);
			
				switch(ccd_Acquisition)
				{
					case 1:			//single shot mode
						GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setFrameNumber,value);
						g_nFrameNumber1=atoi(value);
						ccd_Trigger = 0;  //0:Internal    
						break;
					case 0:     //   . ׷ acquisition single  1 ٲپ  .
						ccd_Acquisition		=	1;
						//g_nNumberKinetics1	=	0;
						g_nFrameNumber1		=	0;
						ccd_Trigger = 0;
						break;
					case 6:		   //it's not exist acquisition mode 6. It uses Frame Transfer Mode
						GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setFrameNumber,value);
						g_nFrameNumber1=atoi(value);
						ccd_Trigger = 0;  //0:Internal    						
						break;
					case 5:
						GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setFrameNumber,value);
						g_nFrameNumber1=atoi(value);
						ccd_Trigger = 0;  //0:Internal    												
						break;
					case 8:
						GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setFrameNumber,value);
						g_nFrameNumber1=atoi(value);
						ccd_Trigger = 0;  //0:Internal
					default:
						break;
				}			
			
				ccd_Read =  4;   //4:Imaging mode, 1:Full Vertical Binning
				//ccd_Trigger = 0;  //0:Internal
			
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setExpTime, value);
				g_fExpTime1=atof(value);
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setExpTime2,value);
				g_fExpTime2=atof(value);
			
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setGain, value);
				ccd_Gain=atoi(value);
			
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setBinning, &n);   
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setSequence,&sequential_number); 
			
				switch(n)
				{
					case 1: ccd_HBin=1;
							ccd_VBin=1;
							SetCtrlVal(mainPanel, PANEL_info8,"1 x 1");
							break;
					case 2: ccd_HBin=2;		
							ccd_VBin=2;
							SetCtrlVal(mainPanel, PANEL_info8,"2 x 2");
							break;
					case 3: ccd_HBin=4;
							ccd_VBin=4;
							SetCtrlVal(mainPanel, PANEL_info8,"4 x 4");
							break;
					case 4: 
							GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setHBin, value);
							ccd_HBin=atoi(value);
							GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setVBin, value);
							ccd_VBin=atoi(value);
							
							sprintf(value, "%d x %d",ccd_HBin,ccd_VBin);
							SetCtrlVal(mainPanel, PANEL_info8, value);							
							break;
					default:
							break;
				}	
				
				
				
				
	//////////////////////////////////////////			
				t=time(NULL);   
				systime=gmtime(&t);  
				sprintf(tempdir,"%.2d%.2d%.2d",(*systime).tm_year+1900,(*systime).tm_mon+1,(*systime).tm_mday);
			
				strcat(entire_directory,data_directory);
				strcat(entire_directory,tempdir);
				
				makefolderscript(entire_directory);   
				LaunchExecutableEx("makefolder.bat", LE_HIDE, NULL);
	//////////////////////////////////////////
				//make data folder
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 3, &TabPanelHandle);         
				GetCtrlVal(TabPanelHandle, setMISC_MISC_TargetRing, &ringvalue);
			
				if(ccd_camera==4)
				{
					strcat(entire_directory,"\\cal");
					makefolderscript(entire_directory);   
					LaunchExecutableEx("makefolder.bat", LE_HIDE, NULL);
					//SetCtrlVal(TabPanelHandle,setMISC_MISC_TargetRing, -1); 
					//SetCtrlAttribute(TabPanelHandle,setMISC_MISC_TargetRing,ATTR_DIMMED,1);
				}
				
				else
				{
					//SetCtrlVal(TabPanelHandle, setMISC_MISC_TargetRing, -1);
					//SetCtrlAttribute(TabPanelHandle,setMISC_MISC_TargetRing,ATTR_DIMMED,0);
					switch(ringvalue)
					{
						case -1:	//none
								break;
						case 0: 	//near disk center
								strcat(entire_directory,"\\raw\\dc");
								break;
						case 1:     //close to or on the limb
								strcat(entire_directory,"\\raw\\limb");
								break;
						case 2:    //quiet region
								strcat(entire_directory,"\\raw\\qr");
								break;
						case 3:    //active region
								strcat(entire_directory,"\\raw\\ar");
								break;	
						case 4:	   //corona hole
								strcat(entire_directory,"\\raw\\ch");
								break;
						case 5:	   //sunspot
								strcat(entire_directory,"\\raw\\sunspot");
								break;
						case 6:	   //filament
								strcat(entire_directory,"\\raw\\fil");
								break;
						case 7:	   //prominence
								strcat(entire_directory,"\\raw\\prom");
								break;		
						case 8:     //user defined object
								GetCtrlVal(TabPanelHandle, setMISC_MISC_Target, temp);		 //read user defined object name
								strcat(entire_directory,"\\raw\\");
								strcat(entire_directory,temp);
								break;
						default:
								break;
					}
				}

				makefolderscript(entire_directory);   
				LaunchExecutableEx("makefolder.bat", LE_HIDE, NULL);
				
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle); 
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setShutter, &ccd_Shutter);
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setFan, &ccd_Fan);
				
				//Camera2
				Lan_SetOkButton_FirstPart(ccd_camera, ringvalue, ccd_Acquisition,
						   ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, 
						   ccd_Shutter,ccd_Fan, g_nFrameNumber1);
	/////////////////////////////////////////////		
				

				


				if(ccd_camera == 2 || ccd_camera == 3 || ccd_camera==4)				   //both mode
				{
					SetCurrentCamera(nCameraHandle1); 					
					TakeBiasDark(ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, nCameraHandle1,entire_directory);					
					SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, ccd_Shutter, ccd_Fan, g_nFrameNumber1, nCameraHandle1);

					//Camera2Part					
					Lan_TakeBiasDark(ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime2, entire_directory);					
					Lan_SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime2, ccd_Shutter, ccd_Fan, g_nFrameNumber1);
					
					SetCurrentCamera(nCameraHandle1); 
				}							   


				else if (ccd_camera==0) 		//ccd1, nCameraHandle1					  //single camera
				{   
					SetCurrentCamera(nCameraHandle1); 
					if(g_nFrameNumber1==0)    //video mode
						SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, ccd_Shutter, ccd_Fan, g_nFrameNumber1,  nCameraHandle1);						
					else		//single, fiss, frame transfer mode
					{
						TakeBiasDark(ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, nCameraHandle1,entire_directory);					
						SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, ccd_Shutter, ccd_Fan, g_nFrameNumber1,  nCameraHandle1);
					}
				}
				
				else if(ccd_camera==1)			//ccd2, nCameraHandle2
				{
					//SetCurrentCamera(nCameraHandle2); 
					if(g_nFrameNumber1==0)		//video mode
						Lan_SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime2, ccd_Shutter, ccd_Fan, g_nFrameNumber1);
					else					   //single, fiss, frame transfer mode
					{
						Lan_TakeBiasDark(ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime2, entire_directory);					
						Lan_SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime2, ccd_Shutter, ccd_Fan, g_nFrameNumber1);
					}
				}
				

				
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 1, &TabPanelHandle);    
				SetCtrlVal(TabPanelHandle, setScanTAB_Scan_Step_number,g_nFrameNumber1);
				SetCtrlVal(TabPanelHandle, setScanTAB_Scan_Frames, g_nFrameNumber1);
				
				
				if(ccd_Acquisition!=8)
				{
					if(ccd_camera==3 || ccd_camera==4)   //2 frames in 1 step
							scan_duration=g_fExpTime1*1000+70;//+50;

					else if (ccd_camera==0)
							scan_duration=g_fExpTime1*1000+70;//+20;

					else if (ccd_camera==1)
							scan_duration=g_fExpTime2*1000+70;//+20;
				}
				else
					scan_duration=0.03;
				

				SetCtrlVal(TabPanelHandle, setScanTAB_Scan_Step_duration,scan_duration);
				
				
				sprintf(value,"%.1f",scan_duration*0.001*g_nFrameNumber1);
				SetCtrlVal(mainPanel, PANEL_info10,value);
				
				if(ccd_Acquisition==8)
				{
					if(ccd_camera==3 || ccd_camera==4)
					{
						sprintf(value, "%.1f", (g_fExpTime1+g_fExpTime2)*g_nFrameNumber1);
					}
				    else if (ccd_camera==0)
					{
						sprintf(value, "%.1f", g_fExpTime1*g_nFrameNumber1);
					}
					else if (ccd_camera==1)
					{
						sprintf(value, "%.1f", g_fExpTime2*g_nFrameNumber1);    
					}
					SetCtrlVal(mainPanel, PANEL_info10,value); 
				}
				
				
				
				/////
				//display ccd information to main panel
				/////
				//ccd selection
				switch(ccd_camera)
				{
					case 0: 
							SetCtrlVal(mainPanel, PANEL_info6,"CCD 1");
							sprintf(value,"%.2f",g_fExpTime1); 
							SetCtrlVal(mainPanel, PANEL_info7,value);  
							SetCtrlVal(mainPanel, PANEL_info7_1,"N");
							break;
					case 1: 
							SetCtrlVal(mainPanel, PANEL_info6,"CCD 2");
							SetCtrlVal(mainPanel, PANEL_info7,"N");
							sprintf(value,"%.2f",g_fExpTime2);
							SetCtrlVal(mainPanel, PANEL_info7_1,value);
							break;
					case 2: 
							SetCtrlVal(mainPanel, PANEL_info6,"Both CCDs");
							sprintf(value,"%.2f",g_fExpTime1);
							SetCtrlVal(mainPanel, PANEL_info7,value);							
							sprintf(value,"%.2f",g_fExpTime2);
							SetCtrlVal(mainPanel, PANEL_info7_1,value);														
							break;
					case 3: 
							SetCtrlVal(mainPanel, PANEL_info6,"2CCD in 1 Step");
							sprintf(value,"%.2f",g_fExpTime1);
							SetCtrlVal(mainPanel, PANEL_info7,value);							
							sprintf(value,"%.2f",g_fExpTime2);
							SetCtrlVal(mainPanel, PANEL_info7_1,value);																					
							break;	
					case 4:
						    SetCtrlVal(mainPanel, PANEL_info6, "Flat Fielding");
							sprintf(value,"%.2f",g_fExpTime1);
							SetCtrlVal(mainPanel, PANEL_info7,value);							
							sprintf(value,"%.2f",g_fExpTime2);
							SetCtrlVal(mainPanel, PANEL_info7_1,value);																					
							break;
					default:
							
							break;
				}
				
////				//ccd exposure time
////				sprintf(value,"%.2f",g_fExpTime1);
////				SetCtrlVal(mainPanel, PANEL_info7,value);
				
				//Number of Frame
				sprintf(value,"%d",g_nFrameNumber1);
				SetCtrlVal(mainPanel, PANEL_info4,value);
				
				//Number of Sequence
				//GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setSequence, &nsequence); 
				sprintf(value,"%d",sequential_number);
				SetCtrlVal(mainPanel, PANEL_info5,value);
				
				//sprintf(value,"%f",g_fExpTime1);
				//SetCtrlVal(mainPanel, PANEL_info10,value);
				/////////////////////////////////////////////////
				
				if(ccd_camera==4)
				{
					flatdata1=(float*)malloc(nhDim1*nvDim1*sizeof(float));
					//flatdata2=(float*)malloc(nhDim2*nvDim2*sizeof(float));
					flatcube1=(float*)malloc(nhDim1*nvDim1*7*sizeof(float));
					//flatcube2=(float*)malloc(nhDim2*nvDim2*7*sizeof(float));
					caldata1=(float*)malloc(nhDim1*nvDim1*sizeof(float));
					//caldata2=(float*)malloc(nhDim2*nvDim2*sizeof(float));
					Lan_CAllocFlatData();
				}
			}
			
			
			if(Scanner_status == 1)
			{
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 1, &TabPanelHandle);
				GetCtrlAttribute (TabPanelHandle, setScanTAB_Scan_Mode, ATTR_CTRL_INDEX, &scan_mode);          
				

				if(scan_mode == 0)	  //spectrograph mode
				{
					GetCtrlVal(TabPanelHandle, setScanTAB_Scan_Step_duration, &scan_duration);
					GetCtrlVal(TabPanelHandle, setScanTAB_Scan_Step_size, &scan_size);
					scan_size=scan_size/2;		   // ⿡ ԷµǴ    ݰ Ѵ.!!!
					
					if((CCD_status == 1)&& (g_nFrameNumber1>1) && (ccd_Acquisition!=8))
					{
						ScanCommandWrite(g_nFrameNumber1,scan_duration, scan_size, 0., 0.);	  //make script to operate scanner
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Spectrograph mode script of Scanner generated\n");
					}
				}
				
				if(scan_mode == 1)	  //imaging mode
				{
					GetCtrlVal(TabPanelHandle, setScanTAB_Scan_speed, &scan_speed);
					GetCtrlVal(TabPanelHandle, setScanTAB_Scan_stroke, &scan_stroke);
					if((CCD_status == 1)&& (g_nFrameNumber1>1) && (ccd_Acquisition!=8))
					{
						ScanCommandWrite(g_nFrameNumber1,0.,0., scan_speed, scan_stroke);		 //make script to operate scanner 
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nImaging mode script of Scanner generated\n");					
					}
				}													   
				
				sprintf(temp,"Scanner_status is %d\n", Scanner_status);
				SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, temp);

				
				//////////////////////////////////////////////
				///display scanner information to main panel
				//FISS mode
				if(scan_mode==0)	   //spectrograph mode
				{
					SetCtrlVal(mainPanel, PANEL_info1,"Spectrograph");
					//SetCtrlAttribute(mainPanel, PANEL_strScanTime, ATTR_LABEL_TEXT, "1 Step Scantime :"); 
					//SetCtrlAttribute(mainPanel, PANEL_strStepSize, ATTR_LABEL_TEXT, "1 Step Size :");	
					//SetCtrlAttribute(mainPanel, PANEL_unit1, ATTR_LABEL_TEXT, "ms");	
					//SetCtrlAttribute(mainPanel, PANEL_unit2, ATTR_LABEL_TEXT, "um");	  
					
					///step duration
					sprintf(value,"%.1f", scan_duration);
					SetCtrlVal(mainPanel, PANEL_info2,value);					
					
					///step size
					sprintf(value,"%.1f",scan_size*2);
					SetCtrlVal(mainPanel, PANEL_info3,value);
					
					///1 sequence time
					if(g_nFrameNumber1==0)
					{
						//g_nFrameNumber1=1;
						sprintf(value,"%.1f", scan_duration*0.001*1);
						SetCtrlVal(mainPanel, PANEL_info10, value);
					}
					
					///calculate FOV in x-direction
					sprintf(value, "%f",scan_size*2*g_nFrameNumber1*0.08/16);		//FOV=scan_stepsize(um)*framenumber*0.08"/16(um)
					SetCtrlVal(mainPanel, PANEL_info11, value);
				}
			
				if(scan_mode==1)	   //imaging mode
				{
					SetCtrlVal(mainPanel, PANEL_info1,"Imaging");
					//SetCtrlAttribute(mainPanel, PANEL_strScanTime, ATTR_LABEL_TEXT, "Scan Speed :"); 
					//SetCtrlAttribute(mainPanel, PANEL_strStepSize, ATTR_LABEL_TEXT, "Scan Stroke :");
					//SetCtrlAttribute(mainPanel, PANEL_unit1, ATTR_LABEL_TEXT, "um/s");	
					//SetCtrlAttribute(mainPanel, PANEL_unit2, ATTR_LABEL_TEXT, "um");
					
					///scan speed
					sprintf(value, "%.1f",scan_speed);
					SetCtrlVal(mainPanel, PANEL_info2,value);
					
					///scan stroke
					sprintf(value,"%.1f",scan_stroke);
					SetCtrlVal(mainPanel, PANEL_info2,value);
					
					///1 sequence time
					sprintf(value,"%.1f", scan_stroke/scan_speed);
					SetCtrlVal(mainPanel, PANEL_info10,value);
					
					///calculate FOV in x-direction
					sprintf(value,"%d",(int)(scan_stroke*0.002));
				}
				

				////////////////////////////////////////////////
			}
				

			if(Motor_status == 1)
			{
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 2, &TabPanelHandle);
				GetCtrlIndex(TabPanelHandle, setMotoTAB_Motor_Wavelength, &index);
				CurrentSelect_Wv=index;
				Gratingtracking(2, Data[index].Step);  //move motor at specific wavelength by using absolute position value(2)
				//WriteFileF(FP);
				
				///display grating wavelength to main panel
				sprintf(value,"%.2f",Data[index].Wv);
				SetCtrlVal(mainPanel, PANEL_info9,value);				
			}
			
			
			SetCtrlAttribute(mainPanel, PANEL_cmd_Run, ATTR_DIMMED, 0);
			SetCtrlAttribute(mainPanel, PANEL_FISS_cmdStop,  ATTR_DIMMED, 0);
			
			SetMenuBarAttribute(menubar,MENUBAR_Test,ATTR_DIMMED, 0); 
			SetMenuBarAttribute(menubar,MENUBAR_Test_Test,ATTR_DIMMED, 0); 
			
//////////////////////////////////////////
			
		//Scanner Parameter Set	via Lan : Just for fits file header.
		Lan_SetScannerParam(scan_size, Scanner_status, scan_mode, scan_duration, scan_speed, scan_stroke);
		GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 3, &TabPanelHandle); 
		GetCtrlVal(TabPanelHandle, setMISC_MISC_Observer, m_observername);	
		GetCtrlVal(TabPanelHandle, setMISC_sunXpos,&m_solarxpos);
		GetCtrlVal(TabPanelHandle, setMISC_sunYpos,&m_solarypos);
		GetCtrlVal(TabPanelHandle, setMISC_MISC_TargetRing,&m_ringvalue);   
		GetCtrlVal(TabPanelHandle, setMISC_MISC_ARNumber, m_arnumber);   
		Lan_SetObserverParam(m_observername, m_arnumber, m_solarxpos, m_solarypos, m_ringvalue);
	//	int scansize	=*(intRecvBuffer+2);
	//	int Scanner_status=*(intRecvBuffer+3);
	//	int scanmode=*(intRecvBuffer+4);
	//	int scan_duration=*(intrecvBuffer+5);
	//	int scan_speed=*(intRecvBuffer+6);
	//	int scan_Stroke=*(intRecvBuffer+7)

///////////////////////////////////////////			

			HidePanel(FISSpanelSetting);
			break;
	}
	
	return 0;
}


int CVICALLBACK FISS_setCancel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			HidePanel(FISSpanelSetting); 
			break;
	}
	return 0;
}


int CVICALLBACK Scan_Mode (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			
			
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 1, &TabPanelHandle);
				GetCtrlAttribute (TabPanelHandle, setScanTAB_Scan_Mode, ATTR_CTRL_INDEX, &scan_mode);      
			
			
				switch (scan_mode)
				{
					case 0:		   //spectrograph mode
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "Spectrograph mode");
					
						//activate spectrograph mode
						SetCtrlAttribute(TabPanelHandle, setScanTAB_TEXTMSG_1, ATTR_DIMMED, 0);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_duration, ATTR_DIMMED, 0);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_size, ATTR_DIMMED, 0);  
					
						//deactivate step number because it is equal to g_nFrameNumber
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_number, ATTR_DIMMED, 1);

						
						//deactivate imaging mode
						SetCtrlAttribute(TabPanelHandle, setScanTAB_TEXTMSG_2, ATTR_DIMMED, 1);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_speed, ATTR_DIMMED, 1); 
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_stroke, ATTR_DIMMED, 1); 
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Frames, ATTR_DIMMED, 1);
						break;
					case 1:		   //imaging mode
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "Imaging mode"); 
					
						//deactivate spectrograph mode
						SetCtrlAttribute(TabPanelHandle, setScanTAB_TEXTMSG_1, ATTR_DIMMED, 1);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_duration, ATTR_DIMMED, 1);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_size, ATTR_DIMMED, 1);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_number, ATTR_DIMMED, 1);  
					
						//activate imaging mode
						SetCtrlAttribute(TabPanelHandle, setScanTAB_TEXTMSG_2, ATTR_DIMMED, 0);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_speed, ATTR_DIMMED, 0); 
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_stroke, ATTR_DIMMED, 0); 
					
						//deactivate camera exposures because it is equal to g_nFrameNumber1
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Frames, ATTR_DIMMED, 1);
					
						break;
				}				
				////

			break;
	}
	return 0;
}

int CVICALLBACK CCD_setBinning (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int n;
	switch (event)
	{
		case EVENT_COMMIT:
			
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle);
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setBinning, &n);
				if (n==4)
				{
					SetCtrlAttribute(TabPanelHandle, setCCDTAB_CCD_setHBin, ATTR_DIMMED, 0);	//Hbin Էâ Ȱȭ
					SetCtrlAttribute(TabPanelHandle, setCCDTAB_CCD_setVBin, ATTR_DIMMED, 0);   //VBin Էâ Ȱȭ
				}
				else
				{
					SetCtrlAttribute(TabPanelHandle, setCCDTAB_CCD_setHBin, ATTR_DIMMED, 1);
					SetCtrlAttribute(TabPanelHandle, setCCDTAB_CCD_setVBin, ATTR_DIMMED, 1);
				}			

			break;
	}
	return 0;
}



//******************************************************************************************************************
//****************************************************************************************************************** 
//******************************************************************************************************************
//******************************************************************************************************************









//******************************************************************************************
//******************************************************************************************
//*************************|  Viewer Pannel and Callback Function  |************************
//******************************************************************************************
//******************************************************************************************

int CVICALLBACK SetSelectFrame (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int frames, axisvalue;
	signed short*	psFitsData;
	int				nStartPoint;
	
	unsigned short	nMinValue, nMaxValue;
	int				i,j,k;
	int				nIndex1, nIndex2;
	char		temp[10];
	int			k1,k2;
	int			viewccd1,viewccd2;

	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(mainPanel, PANEL_set_Select_Frame, &frames);
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);	   //read radio group index(0-based)  
			
			GetCtrlVal(mainPanel, PANEL_viewCCD1,&viewccd1);
			GetCtrlVal(mainPanel, PANEL_viewCCD2,&viewccd2);
			

//			if(planeData)
//			{
//				free(planeData);
//				planeData=NULL;
//			}
			
			if(planeDataCCD)
			{
				free(planeDataCCD);
				planeDataCCD=NULL;
			}
			
			
			if(DataSource ==0 )  	//fits file ͸ о Ѹ 
			{
				Display3DFits(axisvalue, frames, &nMinValue, &nMaxValue);
			}
			
			if(DataSource == 1) 	//CCD  ͸ ȭ鿡 Ѹ 
			{
//				if(ccd_camera!=1)	//ccd1
//				{
//					Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle1);
//				}
//				else  //ccd2
//				{
//					Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle2);
//				}
				
				if(viewccd1==1 && viewccd2==0)  //ccd1
					Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle1); 
				if(viewccd1==0 && viewccd2==1)  //ccd2
					Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle2); 
					
			}
			
			sprintf(temp, "%.2f", mean);
			SetCtrlVal(mainPanel, PANEL_datamean, temp);
			sprintf(temp, "%.2f", stdev);
			SetCtrlVal(mainPanel, PANEL_datastdev, temp);			


			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MIN_VALUE, nMinValue);
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MAX_VALUE, nMaxValue);
			
			if(nMinValue>(int)(mean-3*stdev))
				k1=nMinValue;
			else
				k1=(int)(mean-3*stdev);
			SetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, k1); 	
			
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MIN_VALUE, nMinValue);
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MAX_VALUE, nMaxValue);
			
			if(nMaxValue<(int)(mean+3*stdev))
				k2=nMaxValue;
			else
				k2=(int)(mean+3*stdev);
			SetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, k2);
			break;
	}
	return 0;
}


int CVICALLBACK SetBytsclMin (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int minvalue, maxvalue;
	int axisvalue;
	//int ccd_camera;
	int viewccd1, viewccd2;

	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, &minvalue);
			GetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, &maxvalue);	
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);	   //read radio group index(0-based)  
			GetCtrlVal(mainPanel, PANEL_viewCCD1, &viewccd1);
			GetCtrlVal(mainPanel, PANEL_viewCCD2, &viewccd2);
			
			
			if(DataSource ==0)		//fits file   ȭ鿡 Ѹ 
			{
				if(FitsHeader.nAxis==2)			  	//Fits  Ͱ 2D  
					ByteDisplay(FitsHeader.nAxis1, FitsHeader.nAxis2, pFitsData, minvalue, maxvalue);  

				if(FitsHeader.nAxis==3)				//Fits  Ͱ 3D  
				{
					if(axisvalue == 0)				//X-Y plane
						ByteDisplay(FitsHeader.nAxis1,FitsHeader.nAxis2,pusFitsData,minvalue,maxvalue);
					if(axisvalue == 1)				//Z-Y plane
						ByteDisplay(FitsHeader.nAxis3,FitsHeader.nAxis2,pusFitsData,minvalue,maxvalue); 
				}
			}
			
			if(DataSource ==1)		//CCD  ͸ ȭ鿡 Ѹ 
			{   
				if(g_nFrameNumber1==1)
				{
//					if(ccd_camera!=1)	//ccd1
//						ByteDisplay(nhDim1,nvDim1,g_pRawData,minvalue,maxvalue); 
//					else  //ccd2
//						ByteDisplay(nhDim2,nvDim2,g_pRawData2,minvalue,maxvalue); 
				
					if(viewccd1==1 && viewccd2==0)
						ByteDisplay(nhDim1,nvDim1,g_pRawData,minvalue,maxvalue);
				//	if(viewccd1==0 && viewccd2==1)
						
				}
				
				if(g_nFrameNumber1>1)
				{
					Radio_GetMarkedOption(mainPanel,PANEL_SelectAxis,&axisvalue);
					
					if(axisvalue == 0)				//X-Y plane
					{
//						if(ccd_camera!=1) //ccd1
//							ByteDisplay(nhDim1,nvDim1,planeDataCCD,minvalue,maxvalue); 
//						else  //ccd2
//							ByteDisplay(nhDim2,nvDim2,planeDataCCD,minvalue,maxvalue);
						
						if(viewccd1==1 && viewccd2==0)
							ByteDisplay(nhDim1,nvDim1,planeDataCCD,minvalue,maxvalue);  
						if(viewccd1==0 && viewccd2==1)
							ByteDisplay(nhDim2,nvDim2,planeDataCCD,minvalue,maxvalue); 
							
					}
					if(axisvalue == 1)				//Z-Y plane
					{
//						if(ccd_camera!=1)	//ccd1  
//							ByteDisplay(g_nFrameNumber1,nvDim1,planeDataCCD,minvalue,maxvalue); 
//						else //ccd2
//							ByteDisplay(g_nFrameNumber1,nvDim2,planeDataCCD,minvalue,maxvalue); 
						if(viewccd1==1 && viewccd2==0)
							ByteDisplay(g_nFrameNumber1,nvDim1,planeDataCCD,minvalue,maxvalue);    
						if(viewccd1==0 && viewccd2==1)
							ByteDisplay(g_nFrameNumber1,nvDim2,planeDataCCD,minvalue,maxvalue); 
					}
				}
			}
			break;
	}
	return 0;
}


int CVICALLBACK SetBytsclMax (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			SetBytsclMin(0, 0, EVENT_COMMIT, NULL, 0, 0);

			break;
	}
	return 0;
}


int CVICALLBACK setFrameAxis (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int axisvalue, frames;
	int i, j, k, nStartPoint, nIndex1, nIndex2;
	signed short* psFitsData;
	unsigned short nMinValue, nMaxValue;
	int	k1,k2;
	char temp[10];
	int  viewccd1,viewccd2;

	
//	Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);	   //read radio group index(0-based)  
//	GetCtrlVal(mainPanel, PANEL_set_Select_Frame, &frames);   
	
//	GetCtrlVal(mainPanel, PANEL_viewCCD1,&viewccd1);
//	GetCtrlVal(mainPanel, PANEL_viewCCD2,&viewccd2);
	
	switch (event)
	{
		case EVENT_COMMIT:
			
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);	   //read radio group index(0-based)  
			GetCtrlVal(mainPanel, PANEL_set_Select_Frame, &frames);   
	
			GetCtrlVal(mainPanel, PANEL_viewCCD1,&viewccd1);
			GetCtrlVal(mainPanel, PANEL_viewCCD2,&viewccd2);			
			

			if(DataSource == 0 ) //fits file о Ѹ 
			{
				if(pusFitsData)
				{
					free(pusFitsData);
					pusFitsData=NULL;
				}				
				
				if(axisvalue == 0)		//X-Y plane
				{
					if(frames>FitsHeader.nAxis3)
						frames=FitsHeader.nAxis3-1;
					
					/*
					if(FitsHeader.nAxis1<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis1>512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+FitsHeader.nAxis1-512); 
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2>512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+FitsHeader.nAxis2-512);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}					
					*/
					Display3DFits(axisvalue, frames, &nMinValue, &nMaxValue);	 // ϸ ʿ min, max  .

					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, FitsHeader.nAxis3-1);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, frames);				
				}

				if(axisvalue == 1)				//Z-Y plane
				{
					if(frames>FitsHeader.nAxis1)
						frames=FitsHeader.nAxis1-1;
					/*
					if(FitsHeader.nAxis3<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis3>512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+FitsHeader.nAxis3-512);
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);						
					}
					
					if(FitsHeader.nAxis2>512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+FitsHeader.nAxis2-512);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);						
					}
					*/
					Display3DFits(axisvalue, frames, &nMinValue, &nMaxValue);   // ϸ ʿ min, max  . 

					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, FitsHeader.nAxis1-1);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, frames);								
				}
			}
			
			
			
			if(DataSource == 1)	//CCD  о Ѹ 
			{
				if(planeDataCCD)
				{
					free(planeDataCCD);
					planeDataCCD=NULL;
				}				

				if(axisvalue == 0 )		//X-Y plane
				{
					if(frames>g_nFrameNumber1)
						frames=g_nFrameNumber1-1;
					
//					if(ccd_camera!=1) //ccd1
					if(viewccd1==1 && viewccd2==0) //ccd1
					{
						/*
						if(nhDim1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(nhDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+nhDim1-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim1-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}

						*/
						Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue, nCameraHandle1);						
					}

//					else //ccd2
					if(viewccd1==0 && viewccd2==1)
					{
						/*
						if(nhDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);      							
						}
						if(nvDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(nhDim2>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+nhDim2-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim2-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						*/
						Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue, nCameraHandle2);
					}

					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, g_nFrameNumber1-1);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, frames);								
				}
				
				if(axisvalue == 1)				//Z-Y plane
				{
//					if(ccd_camera!=1)  //ccd1
					if(viewccd1==1 && viewccd2==0)
					{
						if(frames>nhDim1)
							frames=nhDim1-1;
						/*
						if(g_nFrameNumber1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(g_nFrameNumber1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+g_nFrameNumber1-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim1-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}						
						*/
						Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue, nCameraHandle1);   // ϸ ʿ min, max  . 
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, nhDim1-1);
					}
					
//					else  //ccd2
					if(viewccd1==0 && viewccd2==1)
					{
						if(frames>nhDim2)
							frames=nhDim2-1;
						/*
						if(g_nFrameNumber1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(g_nFrameNumber1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+g_nFrameNumber1-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim2>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim2-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}						
						*/
						Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle2);   // ϸ ʿ min, max  . 
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, nhDim2-1);
					}
					
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, frames);								
				}				
			}
			
			
			sprintf(temp, "%.2f", mean);
			SetCtrlVal(mainPanel, PANEL_datamean, temp);
			sprintf(temp, "%.2f", stdev);
			SetCtrlVal(mainPanel, PANEL_datastdev, temp);						

			//Display3DFits()  min, max  Ϲٿ 
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MIN_VALUE, nMinValue);
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MAX_VALUE, nMaxValue);
			
			if(nMinValue>(int)(mean-3*stdev))
				k1=nMinValue;
			else
				k1=(int)(mean-3*stdev);
			SetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, k1); 	
			
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MIN_VALUE, nMinValue);
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MAX_VALUE, nMaxValue);
			
			if(nMaxValue<(int)(mean+3*stdev))
				k2=nMaxValue;
			else
				k2=(int)(mean+3*stdev);
			SetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, k2);

			break;
	}
	return 0;
}




///Picture Window  Լ

int CVICALLBACK pic_window (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int x;
	int y;
	int axis;
	int picTop, picLeft;
	long camera;
	char temp[10];
	unsigned short	nMinValue, nMaxValue;   
	int	k1,k2;
	
	//int onhist, onprofile;  //radio button value
	GetCtrlAttribute(GraphicPanel,GRAPHICPNL_PIC_WINDOW,ATTR_TOP,&picTop);  //y-position
	GetCtrlAttribute(GraphicPanel,GRAPHICPNL_PIC_WINDOW,ATTR_LEFT,&picLeft); //x-position
	
	switch(event)
	{	
		case EVENT_CLOSE:
			GraphicPanel=0;
			
			break;
		case EVENT_DISCARD:
			GraphicPanel=0;
			
			break;
		case EVENT_MOUSE_POINTER_MOVE:
			//SetMouseCursor(VAL_CROSS_HAIR_CURSOR);

			if (Run_thread_stop==0) return 0;
			x=eventData2-picLeft;// 147;
			y=eventData1-picTop;//41;

			sprintf(temp,"%d",x);
			SetCtrlVal(mainPanel, PANEL_xpos,temp);
			sprintf(temp,"%d",y);
			SetCtrlVal(mainPanel, PANEL_ypos,temp);
			

			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axis);	   //read radio group index(0-based)
			

			if(DataSource==0)	 //display data come from Fits file
			{
				if( (FitsHeader.nAxis==2) && (axis == 0 ))  //2D, x-y axis
					Display_Line_Profile(x, y, FitsHeader.nAxis1, FitsHeader.nAxis2, pFitsData, 0);				
				if( (FitsHeader.nAxis==3) && (axis == 0 ))  //3D, x-y axis
					Display_Line_Profile(x, y, FitsHeader.nAxis1, FitsHeader.nAxis2, pusFitsData, 0);
				if( (FitsHeader.nAxis==3) && (axis == 1 ))  //3D, z-y axis
				{
					Display_Line_Profile(x, y, FitsHeader.nAxis3, FitsHeader.nAxis2, pusFitsData, 0);
				}
			}
			
			if(DataSource==1)	 //display data come from CCD memory
			{   
				if(!planeDataCCD)return 0;
			
				if( (g_nFrameNumber1<=1) && (axis == 0 ))  //2D, x-y axis
				{
					if(ccd_camera!=1)		  //ccd1
						Display_Line_Profile(x, y, nhDim1, nvDim1, planeDataCCD, 0);
						//Display_Line_Profile(x, y, nhDim1, nvDim1, g_pRawData, 0);
					else					 //ccd2
						Display_Line_Profile(x, y, nhDim2, nvDim2, planeDataCCD, 0);
						//Display_Line_Profile(x, y, nhDim2, nvDim2, g_pRawData2, 0); 
				}
				
				if( (g_nFrameNumber1>1) && (axis == 0 ))  //3D, x-y axis
				{
					if(ccd_camera!=1)
						Display_Line_Profile(x, y, nhDim1, nvDim1, planeDataCCD, 0);										

					else
						Display_Line_Profile(x, y, nhDim2, nvDim2, planeDataCCD, 0);
				}
				
				if( (g_nFrameNumber1>1) && (axis == 1 ))  //3D, z-y axis
				{
					if(ccd_camera!=1)
						Display_Line_Profile(x, y, g_nFrameNumber1, nvDim1, planeDataCCD, 0);
					
					else
						Display_Line_Profile(x, y, g_nFrameNumber1, nvDim2, planeDataCCD, 0);				
				}
			}
			break;	
			
	case EVENT_LEFT_CLICK:
			if (Run_thread_stop==0) return 0;   
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axis);	   //read radio group index(0-based)  
			x=eventData2-picLeft;// 147; 

			if(DataSource==0)		 //display from fits file
			{
				if( (FitsHeader.nAxis==3) && (axis == 1 ))  //3D, z-y axis
				{
					
					if(FitsHeader.nAxis1<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
						//SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
						//SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis1>512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+FitsHeader.nAxis1-512);
						//SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);						
					}
					
					if(FitsHeader.nAxis2>512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+FitsHeader.nAxis2-512);
						//SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);						
					}										

					Display3DFits(0, x, &nMinValue, &nMaxValue); 
					
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, FitsHeader.nAxis3-1);					
				
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MIN_VALUE, nMinValue);
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MAX_VALUE, nMaxValue);
			
					if(nMinValue>(int)(mean-3*stdev))
						k1=nMinValue;
					else
						k1=(int)(mean-3*stdev);
					SetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, k1); 	
			
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MIN_VALUE, nMinValue);
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MAX_VALUE, nMaxValue);
			
					if(nMaxValue<(int)(mean+3*stdev))
						k2=nMaxValue;
					else
						k2=(int)(mean+3*stdev);
					SetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, k2);
			
					Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);	   //read radio group index(0-based)  
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, x);
				}
								
			}
			if(DataSource==1)		 //display from ccd
			{
				if( (g_nFrameNumber1>1) && (axis == 1 ))  //3D, z-y axis    				
				{
					if(ccd_camera!=1) //camera1
					{
						if(g_nFrameNumber1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							//SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							//SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(g_nFrameNumber1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+g_nFrameNumber1-512);
							//SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim1-512);
							//SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}						
						
						Display3D_CCD(0, x, &nMinValue, &nMaxValue, nCameraHandle1); 									
					}
					
					else   //ccd2
					{
						if(nhDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							//SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							//SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(nhDim2>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+nhDim2-512);
							//SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim2-512);
							//SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}						

						Display3D_CCD(0, x, &nMinValue, &nMaxValue, nCameraHandle2); 
					}
					
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, g_nFrameNumber1-1);										
					
					
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MIN_VALUE, nMinValue);
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MAX_VALUE, nMaxValue);
			
					if(nMinValue>(int)(mean-3*stdev))
						k1=nMinValue;
					else
						k1=(int)(mean-3*stdev);
					SetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, k1); 	
			
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MIN_VALUE, nMinValue);
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MAX_VALUE, nMaxValue);
			
					if(nMaxValue<(int)(mean+3*stdev))
						k2=nMaxValue;
					else
						k2=(int)(mean+3*stdev);
					SetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, k2);
					
					Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);	   //read radio group index(0-based)  
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, x); 
				}
			}

			break; 
			
	}

	//SetMouseCursor(VAL_DEFAULT_CURSOR);

	return 0;
}



//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************

 





//******************************************************************************************************************
//******************************************************************************************************************
//********************************Test Panel Callback Functions ****************************************************
//******************************************************************************************************************
//******************************************************************************************************************


// 2. Scanner 
int CVICALLBACK SlitStepDecrease (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char target[50];
	char strSend[30];
	int	 stepsize;
	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel, test_panel_SlitStepSize, &stepsize); 
			stepsize=stepsize*10;
			zerostep-=stepsize;
			sprintf(target,"#1J=%d",zerostep);
			getresponse(target);
			
			break;
	}
	return 0;
}

int CVICALLBACK SlitStepIncrease (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char target[50];
	char strSend[30];
	int  stepsize;

	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel, test_panel_SlitStepSize, &stepsize);
			stepsize=stepsize*10;
			zerostep+=stepsize;
			sprintf(target,"#1J=%d",zerostep);
			getresponse(target);

			break;
	}
	return 0;
}

int CVICALLBACK SetZero (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			zerostep=0;
			getresponse("HMZ");

			break;
	}
	return 0;
}


int CVICALLBACK upload_data (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			UploadQuickGather(1); // '0' for avoiding file saving temporarily______________      
			break;
	}
	return 0;
}






// 3. Grating Motor/ CCD Motor 

int CVICALLBACK Motor_Stop (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char motor_str[256];
	switch (event)
	{
		case EVENT_COMMIT:
			sprintf(motor_str,"!S:");    
			Write_6KE(motor_str);
			sprintf(motor_str,"MC0000:");  			
			Write_6KE(motor_str);       			

			break;
	}
	return 0;
}

int CVICALLBACK motor_device_select (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel, test_panel_Motor_Device_Select, &SelectMotor);

			break;
	}
	return 0;
}

int CVICALLBACK motor_step_increase (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int motor_step;
		
	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel,test_panel_Motor_Moving_Distance, &motor_step);
			MotorMove(1, motor_step);
			
			break;
	}
	return 0;
}

int CVICALLBACK motor_step_decrease (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int motor_step;
	
	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel,test_panel_Motor_Moving_Distance, &motor_step);
			MotorMove(2, motor_step);			

			break;
	}
	return 0;
}






// 4. Scanner, Grating/CCD Motor Command input window 
int CVICALLBACK radio_scan (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:

			SetCtrlVal(testpanel, test_panel_radio_scan,1);
			SetCtrlVal(testpanel, test_panel_radio_motor,0);			
			break;
	}
	return 0;
}

int CVICALLBACK radio_motor (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlVal(testpanel, test_panel_radio_scan,0);
			SetCtrlVal(testpanel, test_panel_radio_motor,1);
			break;
	}
	return 0;
}


int CVICALLBACK STR_Command (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int ch;
	char command[30];
	char cmdline[100];
	static lamp=0;
	int radio_scan, radio_motor;
	
	
	long numchar;
	char motorResponse[1024];
	
	memset(cmdline, 0,sizeof(char)*100);
	
	switch (event)
	{
		//case EVENT_COMMIT:
		//	break;
			
		case EVENT_KEYPRESS:
			ch=GetKeyPressEventVirtualKey(eventData2);
			if(ch==VAL_ENTER_VKEY)
			{
				GetCtrlVal(testpanel, test_panel_radio_scan, &radio_scan);
				GetCtrlVal(testpanel, test_panel_radio_motor,&radio_motor);				
				GetCtrlVal(testpanel, test_panel_STR_Command, command);
				SetCtrlVal(testpanel, test_panel_STR_Command, "");
				
				
				if((radio_scan==1) && (radio_motor==0))		//choose scanner command mode
				{
					strcat(cmdline,"Scanner> ");
					strcat(cmdline, command);
					strcat(cmdline,"\n");
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, cmdline);					
					
					getresponse(command); 
				}
				
				if((radio_scan==0) && (radio_motor==1))		//choose Motor command mode
				{
					strcat(cmdline,"6K_Motor> ");
					strcat(cmdline, command);
					strcat(cmdline,"\n");
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, cmdline);					
					 
					numchar=Write_6KE(command);
					Delay(0.05);
					Read_HS(motorResponse);
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, motorResponse);
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, "\n");
				}
			}
			break;
			
	}
	return 0;
}

//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************
//****************************************************************************************************************** 





//******************************************************************************************************************
//******************************************************************************************************************
//********************************Information Panel Callback Functions *********************************************
//******************************************************************************************************************
//******************************************************************************************************************
int CVICALLBACK InfoPanel_proc (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			HidePanel(aboutPanel);

			break;
	}
	return 0;
}
//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************






//******************************************************************************************************************
//******************************************************************************************************************
//*************************************Menu Bar Callback Functions *************************************************
//******************************************************************************************************************
//******************************************************************************************************************

void CVICALLBACK mnuOpen (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	cmdOpen(0,0,EVENT_COMMIT,NULL, 0, 0);
}

void CVICALLBACK mnuSave (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	char Buff[MAX_PATHNAME_LEN];
	int ret;
	int axisvalue, minvalue, maxvalue;
	
	GetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, &minvalue);
	GetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, &maxvalue);	
	Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);   

	ret=FileSelectPopup("","*.bmp","*.fts;*.bmp;*.fit;*.fits","Save As BMP File",VAL_SAVE_BUTTON,0,0,1,0,Buff);
	if(ret>0)
	{
		if(DataSource==0) //from fits file
		{
			if(FitsHeader.nAxis==2)					//2d data
			{
				SaveBitmap(FitsHeader.nAxis1,FitsHeader.nAxis2,pFitsData, Buff, minvalue, maxvalue);
			}
			if(FitsHeader.nAxis==3 && axisvalue==0) //3d data and x-y plane
			{
				SaveBitmap(FitsHeader.nAxis1,FitsHeader.nAxis2,pusFitsData, Buff, minvalue, maxvalue);
			}
			if(FitsHeader.nAxis==3 && axisvalue==1) //3d data and z-y plane
			{
				SaveBitmap(FitsHeader.nAxis3,FitsHeader.nAxis2,pusFitsData, Buff, minvalue, maxvalue);
			}
		}
		else	//from CCD data
		{
			if(g_nFrameNumber1<=1)					//2d data
			{
				SaveBitmap(nhDim, nvDim, planeDataCCD, Buff, minvalue, maxvalue);
			}
			if(g_nFrameNumber1>1 && axisvalue==0)	//3d data and x-y plane
			{
				SaveBitmap(nhDim, nvDim, planeDataCCD, Buff, minvalue, maxvalue);
			}
			if(g_nFrameNumber1>1 && axisvalue==1)
			{
				SaveBitmap(g_nFrameNumber1, nvDim, planeDataCCD, Buff, minvalue, maxvalue);
			}
		}
	}

	
}

void CVICALLBACK mnuExit (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	QuitCallback (0, 0, EVENT_COMMIT, NULL, 0, 0);
}

void CVICALLBACK mnuSetup (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	Set_FISS_parameter(0,0,EVENT_COMMIT,NULL,0,0);
	SetMenuBarAttribute(menubar,MENUBAR_Test,ATTR_DIMMED, 0); 
	SetMenuBarAttribute(menubar,MENUBAR_About,ATTR_DIMMED, 0); 
	SetMenuBarAttribute(menubar,MENUBAR_About_About,ATTR_DIMMED, 0);  
}

void CVICALLBACK mnuTest (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	Obs_Test(0,0,EVENT_COMMIT,NULL,0,0);
}

void CVICALLBACK mnuAbout (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	char InfoArray[4096];   
	DisplayPanel(aboutPanel);
	SetCurrentCamera(nCameraHandle1);
	GetCameraInfo(InfoArray);
	SetCtrlVal(aboutPanel, InfoPanel_textBox, "============CCD1===========\n");
	SetCtrlVal(aboutPanel, InfoPanel_textBox, InfoArray);
	SetCurrentCamera(nCameraHandle2);
	GetCameraInfo(InfoArray);
	SetCtrlVal(aboutPanel, InfoPanel_textBox, "============CCD2===========\n");
	SetCtrlVal(aboutPanel, InfoPanel_textBox, InfoArray);

	//SetCtrlVal(aboutPanel, InfoPanel_textBox, "umhahahahah\n");
}

//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************



int CVICALLBACK drawHistogram (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int hist_array[100];
	double xarray[100];
	double* hist_data;
	unsigned short* imsi;

	int i;	
	int axis;	//the parameter which read select axis(X-Y or Z-Y)
				//-1 means we can think default data is 2 D.
	
	unsigned short minvalue, maxvalue;
	int length;

	switch (event)
	{
		case EVENT_LEFT_CLICK:

//			GetCtrlVal(mainPanel, PANEL_SelectAxis, &axis); //if undimming, it read axis either 4 or 5. 
//															//otherwise axis=0
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axis);   

			if(DataSource==0)	//Reading Fits File
			{
				if( (FitsHeader.nAxis==2) && (axis==0))  //2D data, X-Y plane
				{
					length=FitsHeader.nAxis1*FitsHeader.nAxis2;
					hist_data=malloc(length*sizeof(double));
					GetMinMax(pFitsData, length, &minvalue, &maxvalue);
					imsi=(unsigned short*)pFitsData;
					for(i=0;i<length;i++) hist_data[i]=imsi[i];
				}				

				if( (FitsHeader.nAxis==3) &&  (axis == 0)) //3D data, X-Y plane
				{
					length=FitsHeader.nAxis1*FitsHeader.nAxis2;
					hist_data=malloc(length*sizeof(double));
					GetMinMax(pusFitsData, length, &minvalue, &maxvalue);
					for (i=0;i<length;i++) hist_data[i]=pusFitsData[i];					
				}
				
				if( (FitsHeader.nAxis==3) && (axis == 1)) //3D data, Z-Y plane
				{
					length=FitsHeader.nAxis3*FitsHeader.nAxis2;
					hist_data=malloc(length*sizeof(double)); 
					GetMinMax(pusFitsData, length, &minvalue, &maxvalue);
					for (i=0;i<length;i++) hist_data[i]=pusFitsData[i];					
				}

				//GetMinMax(pusFitsData, length, &minvalue, &maxvalue);
				//for (i=0;i<length;i++) hist_data[i]=pusFitsData[i];
			}
				
			
			
			if(DataSource==1) //reading CCD memory
			{
				GetCurrentCamera(&nUnknownCameraHandle);
				if( (g_nFrameNumber1<=1) && (axis == 0 ) )//2D data, X-Y plane
				{
					if(nUnknownCameraHandle==nCameraHandle1)
						length=nhDim1*nvDim1;
					if(nUnknownCameraHandle==nCameraHandle2)
						length=nhDim2*nvDim2;
					
					hist_data=malloc(length*sizeof(double));
				}				
				if( (g_nFrameNumber1>1) && (axis == 0 ) )//3D data, X-Y plane
				{
					if(nUnknownCameraHandle==nCameraHandle1)
						length=nhDim1*nvDim1;
					if(nUnknownCameraHandle==nCameraHandle2)
						length=nhDim2*nvDim2;					
					
					hist_data=malloc(length*sizeof(double));
				}
				
				if( (g_nFrameNumber1>1) && (axis == 1)) //3D data, Z-Y plane
				{
					if(nUnknownCameraHandle==nCameraHandle1)
						length=g_nFrameNumber1*nvDim1;
					if(nUnknownCameraHandle==nCameraHandle2)
						length=g_nFrameNumber1*nvDim2;					
					
					hist_data=malloc(length*sizeof(double));
				}				

				GetMinMax(planeDataCCD, length, &minvalue, &maxvalue);
				for (i=0;i<length;i++) hist_data[i]=planeDataCCD[i];
			}

			
			Histogram(hist_data, length, minvalue, maxvalue, hist_array, xarray, 100);							
			if(plotHandle)
				DeleteGraphPlot(mainPanel, PANEL_GRAPH, plotHandle, VAL_IMMEDIATE_DRAW);
			plotHandle=PlotXY(mainPanel, PANEL_GRAPH, xarray, hist_array, 100, VAL_DOUBLE, VAL_INTEGER, VAL_VERTICAL_BAR, VAL_EMPTY_SQUARE, VAL_SOLID, 1, VAL_BLUE);
			
			free(hist_data);
			break;
	}
	return 0;
}


int CVICALLBACK viewCCD1 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
			SetCtrlVal(mainPanel, PANEL_viewCCD2,0);	
			DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);

			break;
	}
	return 0;
}

int CVICALLBACK viewCCD2 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlVal(mainPanel, PANEL_viewCCD1,0);
			SetCtrlVal(mainPanel, PANEL_viewCCD2,1);					
			DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);   
			break;
	}
	return 0;
}

int CVICALLBACK make_foldert_arget (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int value;
	switch (event)
	{
		case EVENT_COMMIT:

			GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 3, &TabPanelHandle);         
			GetCtrlVal(TabPanelHandle, setMISC_MISC_TargetRing, &value);			
			
			if(value==8)
				SetCtrlAttribute(TabPanelHandle,setMISC_MISC_Target,ATTR_DIMMED,0);
			else
				SetCtrlAttribute(TabPanelHandle,setMISC_MISC_Target,ATTR_DIMMED,1);
			
			if(value==3)
				SetCtrlAttribute(TabPanelHandle,setMISC_MISC_ARNumber,ATTR_DIMMED,0);
			else
				SetCtrlAttribute(TabPanelHandle,setMISC_MISC_ARNumber,ATTR_DIMMED,1);
			

			break;
	}
	return 0;
}

int CVICALLBACK CCD_setCamera (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int tabpanel;
	switch (event)
	{
		case EVENT_COMMIT:
			
/*			GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle);
			GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setCamera, &ccd_camera);			
			
			if(ccd_camera== 4) //flat fielding mode
			{
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 3, &tabpanel);         
				SetCtrlVal(tabpanel,setMISC_MISC_TargetRing, -1); 
				SetCtrlAttribute(tabpanel,setMISC_MISC_TargetRing,ATTR_DIMMED,1);		
			}
			else
			{
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 3, &tabpanel);         				
				//SetCtrlVal(tabpanel,setMISC_MISC_TargetRing, -1); 
				SetCtrlAttribute(tabpanel,setMISC_MISC_TargetRing,ATTR_DIMMED,0);						
			}
*/
			break;
	}
	return 0;
}

int CVICALLBACK PowerOn (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		//ccd variable
		long nCameraIndex;
		int nTemp1, nTemp2;
		char str[200];
		char LanStr[1024];
		//scanner variable
		int functionID;
		int TabPanelHandle;
		int	errorValue;
		
		case EVENT_COMMIT:
			
			
				////////////////////////////////////////////////////////////
				//////////Beginning Of CCD Parts///////////////////////////////////
				////////////////////////////////////////////////////////////
				if(CCD_status==1)return 0;
				
				////////////////////////////////////////////
				///CameraConnection via Lan/////////////////
				//errorValue=Lan_Test();
				
				errorValue=Lan_OnConnect();
				if(errorValue==0)MessagePopup("Error", "Lan cannot connect");
				
				GetAvailableCameras(&nNumberOfCameras);
				nNumberOfCameras=nNumberOfCameras+Lan_GetAvailableCameras();
			
				
				if(nNumberOfCameras ==0)return 0;
				
				if(nNumberOfCameras == 1)
				{
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\n1 Camera Detected!!\n");
					nCameraIndex=0;
					GetCameraHandle(nCameraIndex,&nCameraHandle1);	//find camera handle;
				
					SetCurrentCamera(nCameraHandle1);				//set to 1st Camera as default setting
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nCamera1 is Opening\n"); 
					OpenCamera(nCameraHandle1);									//set                                       
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nCamera1 Open Complete!!\n");	
					
				}
			
				if(nNumberOfCameras == 2)
				{
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\n2 Two Cameras Detected!!\n");   
					nCameraIndex=0;
					GetCameraHandle(nCameraIndex,&nCameraHandle1);	//find camera handle;
					nCameraIndex=1;
					
					nCameraHandle2=2;  //abiltrarily set the camerahandle number;camera2
					
					SetCurrentCamera(nCameraHandle1);				//set to 1st Camera as default setting
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nCamera1 is Opening\n"); 
					OpenCamera(nCameraHandle1);									//set                                       
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nCamera1 Open Complete!!\n");

					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nCamera2 is Opening\n"); 
					OpenCamera(nCameraHandle2);									//set                                       
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nCamera2 Open Complete!!\n");	

					//SetCurrentCamera(nCameraHandle1);				//set to 1st Camera as default setting
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nSet to Current Camera1\n");	

				}
				
			
				SetCtrlVal(mainPanel, PANEL_CCD_Status, 1); 		//turn on ccd status lamp   
				SetMenuBarAttribute(menubar,MENUBAR_Setup,ATTR_DIMMED, 0); 
				SetMenuBarAttribute(menubar,MENUBAR_About,ATTR_DIMMED, 0);
				
				////////////////////////////////////////////////////////////
				//////////Camera Cooling////////////////////////////////////
				//SetCtrlVal(testpanel,test_panel_coolerOnOff1,ATTR_VAL,1);
				//GetCtrlVal(testpanel, test_panel_CoolerOnOff1, &Onoff1);
				//GetCtrlVal(testpanel, test_panel_CoolerOnOff2, &Onoff2);
				//need more consideration now i'm hungry. i'm going for dinner.
				
				GetCtrlVal(testpanel, test_panel_ccdTemp, &nTemp1);
				GetCtrlVal(testpanel, test_panel_ccdTemp2,&nTemp2);	
				
			
				
				////Init Setting/////
				SetCtrlAttribute(mainPanel,PANEL_CCDTEMPSTATUS,ATTR_ON_COLOR,VAL_GREEN); 
				
				////////////////////////////////////////////////////////////
				//////////End Of CCD Parts///////////////////////////////////
				////////////////////////////////////////////////////////////
				
				
				
				
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////Beginning of Grating Parts/////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
				
				SetCtrlVal(mainPanel, PANEL_Motor_Status, 1);
		
				if(!MotorConnect())return 0;
				//SlitHatchOpen();
				Motor_status=1; 
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////End of Grating Parts/////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////

								
				
				
				
				////////////////////////////////////////////////////////////
				//////////Beginning Of Scanner Part///////////////////////////////////
				////////////////////////////////////////////////////////////				
				
		
			 	if(!ScanOpen())return 0;
				SetCtrlVal(mainPanel, PANEL_Scan_Status, 1); 
			
				SetCtrlAttribute(mainPanel, PANEL_TIMER, ATTR_ENABLED, 1); 	 //activate timer   
			
				
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 1, &TabPanelHandle);        
		
				SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Mode,ATTR_DIMMED,0);
				SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_size,ATTR_DIMMED,0);
				SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_duration,ATTR_DIMMED,0); 
				Delay(1);
			
				CmtScheduleThreadPoolFunction (DEFAULT_THREAD_POOL_HANDLE, MonitoringThreadFunction, NULL, &functionID);
				
				//CCD TempSet
				//TempSet(0,0,nTemp1,nTemp2);  
				temp_thread=1;
				
				CmtWaitForThreadPoolFunctionCompletion (DEFAULT_THREAD_POOL_HANDLE, functionID, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
				CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, functionID);  				
				
				////////////////////////////////////////////////////////////
				//////////End Of Scanner Parts///////////////////////////////////
				////////////////////////////////////////////////////////////
				
				
				
				
				


			break;
	}
	return 0;
}

int CVICALLBACK PowerOff (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	//ccd variable
	long nCameraIndex;
	int nTemp1, nTemp2;
	char str[200];
	
	//scanner variable
	int functionID;
	int TabPanelHandle;
	switch (event)
	{
		case EVENT_COMMIT:

				
				
				
				
				
				
				
				
				
				
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////Bigining of Scanner Parts/////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	
				if(Scanning==1)
				{ 
					MessageBox(NULL, "Motor is still running.", "Error", MB_OK | MB_ICONINFORMATION);
				}
				else 
				{
					
					PmacAccessible=0;	

					CloseDevice();
					SetCtrlVal(mainPanel, PANEL_Scan_Status, 0); 
				
					//display motor status(by lamp)
					//SetCtrlVal(mainPanel, PANEL_AMPON, 0);   
					SetCtrlVal(mainPanel, PANEL_INPOSITION, 0);
					SetCtrlVal(mainPanel, PANEL_MOTORRUN, 0);
					//SetCtrlVal(mainPanel, PANEL_AMPFAULTERR, 0);  
					SetCtrlVal(mainPanel, PANEL_PLIMIT, 0);
					SetCtrlVal(mainPanel, PANEL_NLIMIT, 0); 
					//SetCtrlVal(mainPanel, PANEL_OPENLOOP, 0); 
				}
				
				
				
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////End of Scanner Parts/////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	
				
				
				
				
				
			
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////Beginning of Grating Parts/////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
				if(Motor_status){
					SetCtrlVal(mainPanel, PANEL_Motor_Status, 0);  

					//SlitHatchClose();
					MotorDisconnect();   
					Motor_status=0; 
				}
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////End of Grating Parts/////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////

				
				
				
				
			
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////Start of CCD Parts/////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////			
			if(CCD_status){
				//SetCtrlAttribute(mainPanel, PANEL_Show_Hist, ATTR_DIMMED, 1);
				if(pFitsData)
				{
					free(pFitsData);
					pFitsData=NULL;
				}
				
				if(pusFitsData)
				{
					free(pusFitsData);
					pusFitsData=NULL;
				}
				
			
				if(planeDataCCD)
				{
					free(planeDataCCD);
					planeDataCCD=NULL;
				}
				
				
				if(BiasDark1)
				{
					free(BiasDark1);
					BiasDark1=NULL;
				}
				
				
				CameraQuitCooling();     
			
				if (nNumberOfCameras == 1)
				{
					CloseCamera(nCameraHandle1);//CLOSE CAMERA       
				}
 
				if (nNumberOfCameras == 2)
				{
					SetCurrentCamera(nCameraHandle1);
					CloseCamera(nCameraHandle1);//CLOSE CAMERA
					//SetCurrentCamera(nCameraHandle2);
					Lan_QuitCamera();
				}
				
				
				SetMenuBarAttribute(menubar,MENUBAR_Setup,ATTR_DIMMED, 1); 
				SetMenuBarAttribute(menubar,MENUBAR_About,ATTR_DIMMED, 1);				
	 			SetCtrlVal(mainPanel, PANEL_CCD_Status, 0); 		//turn off ccd status lamp     
			SetCtrlAttribute(mainPanel, PANEL_cmd_Run, ATTR_DIMMED, 0);  
			}
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////End of CCD Parts/////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	

				
				

			break;
	}
	return 0;
}

int CVICALLBACK Graphicpnl_proc (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			DiscardPanel(GraphicPanel); 
			break;
		case EVENT_PANEL_MOVE:
			MagnetMoving(GraphicPanel, eventData2);
	}
	return 0;
}

int CVICALLBACK AddWvField (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			ShowPanel();//WaveControlFunction.
			OpenFileF(FP);
			ResetPanel();
			InitPanel();
			break;
	}
	return 0;
}

int CVICALLBACK CCD_setExpTime (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{  
		
		
		
		case EVENT_COMMIT:
	
			
			break;
	}
	return 0;
}

int CVICALLBACK setTAB (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{   	
	int tabpanel;
	char value[20];
	int ccd_camera_temp;
	
			GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle);    
			GetCtrlVal(TabPanelHandle,  setCCDTAB_CCD_setCamera,&ccd_camera_temp);
			
			GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setExpTime, value);
			g_fExpTime1=atof(value);	
				
			if(ccd_camera_temp==3 || ccd_camera_temp==4)   //2 frames in 1 step
				scan_duration=g_fExpTime1*1000+70;//+50;
			else
				scan_duration=g_fExpTime1*1000+70;//+20;
			
			GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 1, &tabpanel);         				
			SetCtrlVal(tabpanel, setScanTAB_Scan_Step_duration,(float)scan_duration);
		
	
	return 0;
}
