/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2011. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  GRAPHICPNL                       1       /* callback function: Graphicpnl_proc */
#define  GRAPHICPNL_PIC_WINDOW            2       /* callback function: pic_window */

#define  InfoPanel                        2       /* callback function: InfoPanel_proc */
#define  InfoPanel_textBox                2

#define  PANEL                            3       /* callback function: panel_proc */
#define  PANEL_POWERON                    2       /* callback function: PowerOn */
#define  PANEL_POWEROFF                   3       /* callback function: PowerOff */
#define  PANEL_DECORATION_6               4
#define  PANEL_Set_FISS_parameter         5       /* callback function: Set_FISS_parameter */
#define  PANEL_Obs_Test                   6       /* callback function: Obs_Test */
#define  PANEL_FISS_FileOpen              7       /* callback function: cmdOpen */
#define  PANEL_DECORATION                 8
#define  PANEL_FISS_cmdStop               9       /* callback function: cmdStop */
#define  PANEL_viewCCD1                   10      /* callback function: viewCCD1 */
#define  PANEL_viewCCD2                   11      /* callback function: viewCCD2 */
#define  PANEL_QUITBUTTON                 12      /* callback function: QuitCallback */
#define  PANEL_TB_Text_Monitor            13
#define  PANEL_cmd_Run                    14      /* callback function: cmd_Run */
#define  PANEL_TEXTMSG_8                  15
#define  PANEL_TEXTMSG                    16
#define  PANEL_DECORATION_10              17
#define  PANEL_TEXTMSG_5                  18
#define  PANEL_TEXTMSG_6                  19
#define  PANEL_GRAPH                      20      /* callback function: drawHistogram */
#define  PANEL_Position                   21
#define  PANEL_Motor_Status               22
#define  PANEL_Scan_Status                23
#define  PANEL_CCD_Status                 24
#define  PANEL_INPOSITION                 25
#define  PANEL_MOTORRUN                   26
#define  PANEL_NLIMIT                     27
#define  PANEL_CCDTEMPSTATUS              28
#define  PANEL_PLIMIT                     29
#define  PANEL_S1                         30
#define  PANEL_P1                         31
#define  PANEL_TIMER                      32      /* callback function: Ampon_timer */
#define  PANEL_TEXTMSG_7                  33
#define  PANEL_set_Select_Frame           34      /* callback function: SetSelectFrame */
#define  PANEL_COM6SRVR6KNET              35
#define  PANEL_BYTSCL_MAX                 36      /* callback function: SetBytsclMax */
#define  PANEL_BYTSCL_MIN                 37      /* callback function: SetBytsclMin */
#define  PANEL_SelectAxis                 38      /* callback function: setFrameAxis */
#define  PANEL_DECORATION_7               39
#define  PANEL_strMean                    40
#define  PANEL_IDLDRAWWIDGET              41
#define  PANEL_strStdev                   42
#define  PANEL_xpos                       43
#define  PANEL_ypos                       44
#define  PANEL_value                      45
#define  PANEL_TEXTMSG_12                 46
#define  PANEL_TEXTMSG_11                 47
#define  PANEL_TEXTMSG_9                  48
#define  PANEL_datamean                   49
#define  PANEL_datastdev                  50
#define  PANEL_TEXTMSG_2                  51
#define  PANEL_strScanTime                52
#define  PANEL_strStepSize                53
#define  PANEL_TEXTMSG_17                 54
#define  PANEL_TEXTMSG_18                 55
#define  PANEL_TEXTMSG_19                 56
#define  PANEL_TEXTMSG_31                 57
#define  PANEL_TEXTMSG_30                 58
#define  PANEL_TEXTMSG_35                 59
#define  PANEL_TEXTMSG_20                 60
#define  PANEL_TEXTMSG_22                 61
#define  PANEL_TEXTMSG_21                 62
#define  PANEL_nAxis1                     63
#define  PANEL_info2                      64
#define  PANEL_info3                      65
#define  PANEL_info4                      66
#define  PANEL_info11                     67
#define  PANEL_info5                      68
#define  PANEL_info10                     69
#define  PANEL_info7_1                    70
#define  PANEL_info6                      71
#define  PANEL_info7                      72
#define  PANEL_info8                      73
#define  PANEL_info1_7                    74
#define  PANEL_unit1                      75
#define  PANEL_unit2                      76
#define  PANEL_info1_4                    77
#define  PANEL_info9                      78
#define  PANEL_TEXTMSG_23                 79
#define  PANEL_DECORATION_12              80
#define  PANEL_TEXTMSG_24                 81
#define  PANEL_DECORATION_13              82
#define  PANEL_TEXTMSG_25                 83
#define  PANEL_TEXTMSG_26                 84
#define  PANEL_TEXTMSG_29                 85
#define  PANEL_TEXTMSG_28                 86
#define  PANEL_TEXTMSG_27                 87
#define  PANEL_nAxis2                     88
#define  PANEL_nAxis3                     89
#define  PANEL_info1                      90
#define  PANEL_ExpTime                    91
#define  PANEL_DECORATION_11              92
#define  PANEL_info1_5                    93
#define  PANEL_info1_6                    94
#define  PANEL_TEXTMSG_32                 95
#define  PANEL_TEXTMSG_3                  96
#define  PANEL_TEXTMSG_33                 97
#define  PANEL_TEXTMSG_4                  98
#define  PANEL_TEXTMSG_34                 99
#define  PANEL_CCD2TEMP                   100
#define  PANEL_CCD1TEMP                   101
#define  PANEL_P1_2                       102

#define  SetFISS                          4       /* callback function: SetFISS_proc */
#define  SetFISS_FISS_setCancel           2       /* callback function: FISS_setCancel */
#define  SetFISS_setTAB                   3       /* callback function: setTAB */
#define  SetFISS_FISS_setOK               4       /* callback function: FISS_setOK */

#define  test_panel                       5       /* callback function: test_panel_proc */
#define  test_panel_CoolerOnOff1          2
#define  test_panel_CoolerOnOff2          3
#define  test_panel_ccdTemp               4
#define  test_panel_ccdTemp2              5
#define  test_panel_setCooler             6       /* callback function: setCooler */
#define  test_panel_Motor_Device_Select   7       /* callback function: motor_device_select */
#define  test_panel_Motor_Moving_Distance 8
#define  test_panel_Motor_Position        9
#define  test_panel_ADDWVFIELDBTN         10      /* callback function: AddWvField */
#define  test_panel_SlitStepSize          11
#define  test_panel_DECORATION_2          12
#define  test_panel_upload_data           13      /* callback function: upload_data */
#define  test_panel_radio_scan            14      /* callback function: radio_scan */
#define  test_panel_radio_motor           15      /* callback function: radio_motor */
#define  test_panel_STR_Command           16      /* callback function: STR_Command */
#define  test_panel_Motor_Step_Increase   17      /* callback function: motor_step_increase */
#define  test_panel_TB_Text_Monitor       18
#define  test_panel_Motor_Step_Decrease   19      /* callback function: motor_step_decrease */
#define  test_panel_SlitStepIncrease      20      /* callback function: SlitStepIncrease */
#define  test_panel_SlitStepDecrease      21      /* callback function: SlitStepDecrease */
#define  test_panel_SetZero               22      /* callback function: SetZero */
#define  test_panel_DECORATION            23
#define  test_panel_TEXTMSG               24
#define  test_panel_DECORATION_4          25
#define  test_panel_TEXTMSG_4             26
#define  test_panel_TEXTMSG_2             27
#define  test_panel_Motor_Stop            28      /* callback function: Motor_Stop */

     /* tab page panel controls */
#define  setCCDTAB_DECORATION_5           2
#define  setCCDTAB_CCD_setAcq             3
#define  setCCDTAB_CCD_setFrameNumber     4
#define  setCCDTAB_CCD_setGain            5
#define  setCCDTAB_DECORATION             6
#define  setCCDTAB_DECORATION_4           7
#define  setCCDTAB_CCD_setFan             8
#define  setCCDTAB_CCD_setExpTime2        9       /* callback function: CCD_setExpTime */
#define  setCCDTAB_CCD_setExpTime         10      /* callback function: CCD_setExpTime */
#define  setCCDTAB_CCD_setBinning         11      /* callback function: CCD_setBinning */
#define  setCCDTAB_DECORATION_2           12
#define  setCCDTAB_CCD_setSequence        13
#define  setCCDTAB_CCD_setVBin            14
#define  setCCDTAB_CCD_setHBin            15
#define  setCCDTAB_TEXTMSG                16
#define  setCCDTAB_CCD_setShutter         17
#define  setCCDTAB_DECORATION_3           18
#define  setCCDTAB_CCD_setCamera          19      /* callback function: CCD_setCamera */
#define  setCCDTAB_SPLITTER               20

     /* tab page panel controls */
#define  setMISC_MISC_Observer            2
#define  setMISC_MISC_TargetRing          3       /* callback function: make_foldert_arget */
#define  setMISC_MISC_Target              4
#define  setMISC_MISC_ARNumber            5
#define  setMISC_sunXpos                  6
#define  setMISC_sunYpos                  7
#define  setMISC_TEXTMSG                  8
#define  setMISC_TEXTMSG_7                9
#define  setMISC_TEXTMSG_6                10
#define  setMISC_TEXTMSG_8                11
#define  setMISC_TEXTMSG_5                12
#define  setMISC_TEXTMSG_4                13
#define  setMISC_TEXTMSG_2                14
#define  setMISC_TEXTMSG_3                15

     /* tab page panel controls */
#define  setMotoTAB_Motor_Wavelength      2

     /* tab page panel controls */
#define  setScanTAB_Scan_Mode             2       /* callback function: Scan_Mode */
#define  setScanTAB_Scan_Step_size        3
#define  setScanTAB_Scan_Step_number      4
#define  setScanTAB_Scan_speed            5
#define  setScanTAB_DECORATION_2          6
#define  setScanTAB_TEXTMSG_1             7
#define  setScanTAB_Scan_Frames           8
#define  setScanTAB_Scan_stroke           9
#define  setScanTAB_TEXTMSG_2             10
#define  setScanTAB_DECORATION_3          11
#define  setScanTAB_Scan_Step_duration    12
#define  setScanTAB_SPLITTER              13


     /* Menu Bars, Menus, and Menu Items: */

#define  MENUBAR                          1
#define  MENUBAR_File                     2
#define  MENUBAR_File_Open                3       /* callback function: mnuOpen */
#define  MENUBAR_File_Save                4       /* callback function: mnuSave */
#define  MENUBAR_File_Exit                5       /* callback function: mnuExit */
#define  MENUBAR_Setup                    6
#define  MENUBAR_Setup_Setup              7       /* callback function: mnuSetup */
#define  MENUBAR_Test                     8
#define  MENUBAR_Test_Test                9       /* callback function: mnuTest */
#define  MENUBAR_About                    10
#define  MENUBAR_About_About              11      /* callback function: mnuAbout */


     /* Callback Prototypes: */ 

int  CVICALLBACK AddWvField(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Ampon_timer(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK CCD_setBinning(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK CCD_setCamera(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK CCD_setExpTime(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cmd_Run(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cmdOpen(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cmdStop(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK drawHistogram(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK FISS_setCancel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK FISS_setOK(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Graphicpnl_proc(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK InfoPanel_proc(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK make_foldert_arget(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
void CVICALLBACK mnuAbout(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mnuExit(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mnuOpen(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mnuSave(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mnuSetup(int menubar, int menuItem, void *callbackData, int panel);
void CVICALLBACK mnuTest(int menubar, int menuItem, void *callbackData, int panel);
int  CVICALLBACK motor_device_select(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK motor_step_decrease(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK motor_step_increase(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Motor_Stop(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Obs_Test(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK panel_proc(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK pic_window(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PowerOff(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PowerOn(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK QuitCallback(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK radio_motor(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK radio_scan(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Scan_Mode(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Set_FISS_parameter(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetBytsclMax(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetBytsclMin(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK setCooler(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetFISS_proc(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK setFrameAxis(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetSelectFrame(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK setTAB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetZero(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SlitStepDecrease(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SlitStepIncrease(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK STR_Command(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK test_panel_proc(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK upload_data(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK viewCCD1(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK viewCCD2(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
