#include <userint.h>

/*******************************************************************************
		          A PROGRAM TO CONTROL FISS SCANNER AND CCD CAMERA
      HYUNG-MIN PARK(hmpark@kasi.re.kr), KWANGSU AHN (ksahn@astro.snu.ac.kr)
	  							and HEE-SOO YANG																							  

	  
	  DESCRIPTION : 
	  		1. Scanner (CODED BY KWANG-SOO AHN ORIGINALLY)
	  			-	THIS PROGRAM IS CODED USING LABWINDOWS/CVI.
	  				BUT A DLL LIBRARY TO CONTROL PMAC DEVICE IS PROVIDED
					BASED ON C++ FORMAT. THUS I COMMENTED OUT SOME LINES
					WHICH SHOW MISSING ERRORS WHILE COMPILING.
					THE FOLLOWING LINES ARE COMMENTED OUT.
					Pmacu.h 78-80, 252 , INTR.h 28 , cmplclib.h 33
				-	TO OPERATE SCANNER, IT NEED TO A HEADER FILE, "runtime.h"
				-	YOU HAVE TO CONSIDER THE POSITION OF HEADER LINE.
				-	FIRST "runtime.h", SECOND "utility.h"
				-	THE FUNCTION ASSOCIATED WITH SCANNER OPERATING IS LOCATED IN
					"Scanner.c, Scanner.h"
					
			2. CCD  (CODED BY HYUNGMIN PARK ORIGINALLY)
				-	THIS PROGRAM IS CODED USING LABWINDOWS/CVI.
					IT SUPPORT SDK(Software Development Kit) written C LANGUAGE
					THEN I INCLUDE "Atmcd32d.h" FILE IN THIS PROGRAM.
					CCD NEED TO 3 FILES: Atmcd32d.h, Atmcd32d.dll, Atmcd32m.lib
				-	THE FUNCTION ASSOCIATED WITH CCD OPERATING IS LOCATED IN
					"CCD.c, CCD.h"
					
					
			3. Grating + CCD motors (CODED BY HEE-SOO YANG ORIGINALLY)
				-	THIS PROGRAM IS CODED USING LABWINDOWS/CVI.
	  				BUT A DLL LIBRARY TO CONTROL PMAC DEVICE IS PROVIDED
					BASED ON C++ FORMAT. THEN WE CONVERT C++ CODE WITH DLL TO
					OPERATE ANSI-C OR CVI.
					THIS FILES HAVE TO LOCATE WORKING DIRECTORY AS FOLLOWS:
					DLL6K.dll, DLL6K.h, DLL6K.lib, HOMING.prg, setup.prg,IPAddr.ini,
					Wv.ini, MFC42D.dll, MFCO42D.dll, MSVCRTD.dll
				-	THE FUCTION ASSOCIATED WITH GRATING AND CCD MOTOR CONTROL IS 
					LOCATED IN "grating_focus.c, grating_focus.h"
					
					
					
			
	*REVISION HISTORY
		JUN 17 2008: MENUS ARE REARRANGED TO USER-FRIENDLY INTERFACE
		OCT 30 2008: MAKE THE FILE INCLUDED SCANNER FUNCTION
					  RENAMED ALL FILE NAME 
		JUN 23 2009: RENAMED CALLBACK FUNCTION ID FROM MAIN_PANEL TO PANEL
		JUN 30 2009: START TO ADD GRATING-CCD MOTOR FUNCTION MADE BY HEE-SOO YANG
		SEP 15 2009: MODIFY THREAD FUNCTION TO OPERATE SCANNER WHEN SCANNER TURN ON
		SEP 19 2009: CHANGE GUI INTERFACE MUCH AND ADD VIEWER FUNCTION
		 			LINE PROFILE, VALUE DISPLAY AT SOME POSITIONS	
		SEP 21 2009: FIND FILES TO OPERATE GRATING/CCD MOTOR WELL AND INCLUDE THOSE.
		SEP 22 2009: DEBUG HISTOGRAM DISPLAY AND MENUBAR
		NOV 12 2009: CHANGE FITS SAVE ROUTINE BECAUSE OF LONG PROCESS TIME.
					CHANGE FROM MY ROUTINE TO NASA CFITSIO LIBRARY FOR C++
		NOV 26 2009: CONSIDER AND MODIFY SOURCE PROGRAM FOR 2 CAMERA OBSERVATION.
		 			MEMORY ALLOCATION FOR 1 CAMERA, TAKE-SAVE-TAKE-SAVE
		DEC 07 2009: MODIFY SOME CODES TO CONSIDER USING TWO CAMERA SEQUENTIALLY
					SET1,TAKE,SET2,TAKE,SAVE1,SAVE2 <- THE METHOD AS FAST AS WE CAN 
					CASE OF SELECTION BOTH MODE, OPERATE TWO CAMERAS SEQUENTIALLY
		DEC 14 2009: REARRAGEMENT OF CALLBACK FUNCTION(SORTING FUNCTIONALLY)
		DEC 15 2009: DEBUG PIC_WINDOW CALLBACK FUNCTION
		DEC 17 2009: MODIFY SAVEBITMAP() AND MNUSAVE()
********************************************************************************/

#include "radioGroup.h"
#include "runtime.h"
#include "FISS.h"
#include <utility.h>  
#include "CCD.h"
#include "Atmcd32d.h"
#include <analysis.h>
#include <ansi_c.h>
#include "scanner.h"

#include "DLL6K.h"
#include "grating_focus.h"


//panel  
int mainPanel;       //HANDLE OF MAIN PANEL( г ڵ)
int FISSpanelSetting; 
int testpanel;
int TabPanelHandle;			//handle of tab panel     
int	aboutPanel; 
int menubar;





//****************************************************
///CCD parameter
//****************************************************

int 	g_nFrameNumber1;//, g_nNumberKinetics1;
int 	DataSource;			//need to distinguish Fits data and Raw data acquired by CCD
							//if DataSource=1, Taking Image by CCD
							//if DataSource=0, Display image by Fits file
//need to realize thread
//for video mode
int 	threadparam = -1;			//thread parameter
int 	threadfunctionID;

///associate with temperature setting
int 	temp_thread, temp_thread_id;

float 	g_fExpTime1;			//exposure time
	
long 	nCameraHandle1;		//camera handle1
long 	nCameraHandle2;		//camera handle2
long 	nNumberOfCameras;
long 	nUnknownCameraHandle;	//

int		ccd_HBin, ccd_VBin, ccd_Gain;
int		coolingStatus=-1;

extern int 				nhDim, nvDim;
extern int				nhDim1,nvDim1,nhDim2,nvDim2;

int		sequential_number;

//extern int				framecount;					//define this paramter to apply data dump for allocated memory
extern WORD* 			g_pRawData;			//allocated data dumped real data
extern WORD* 			g_pRawData2;			//allocated data dumped real data 
extern WORD*			BiasDark1;
extern WORD*			BiasDark2;

extern BYTE* 			pFitsData;  
extern unsigned short* 	pusFitsData; //fits ȭϿ о ϸ  ؼ ȯ  .  
extern FITSHEADER		FitsHeader;  
//extern BYTE* 			planeData;
extern WORD*			planeDataCCD;
extern int				CCD_status; 	//ccd on:1, ccd off:0


float *flatdata1, *flatdata2;
float *flatcube1, *flatcube2;
float *caldata1, *caldata2;

char data_directory[30]="E:\\BBSO_Data\\";			   //Data path 
char entire_directory[250];


LARGE_INTEGER gliFreq, gliStart, gliEnd;  

static int CVICALLBACK setVideoThread(void* functionData);		//define thread function
static int CVICALLBACK setTempThread(void* functionData);
//****************************************************
//****************************************************
//****************************************************






//****************************************************
///Viewer parameter
//****************************************************
int 	plotHandle;
int		ccd_camera;
float	stdev,mean;
int		panelwidth,panelheight;
//****************************************************
//****************************************************
//****************************************************




//****************************************************
///Scanner parameter
//****************************************************
int 		scan_mode=-1;  //scanning mode 0: spectrograph, 1: imaging
static int 	zerostep=0; 

extern int 	Scanner_status;
extern int 	PmacAccessible;	
extern int 	Scanning;
//extern int 	take;//,both_move;
extern int  Scanner_InPosition;
extern int	Scanpos_CCDframe;
extern float	scanpos;
int 	fiss_take_mode;
int		take;

float scan_duration, scan_size, scan_speed, scan_stroke; 

int CVICALLBACK MonitoringThreadFunction (void *functionData);  
//****************************************************
//****************************************************
//****************************************************






//****************************************************
///Grating/CCD Motor parameter
//****************************************************
int 		Motor_status;
int			Slit_status;

extern WvSet 		Data[10];
extern int 	SelectMotor;


//====================================
//FILE I/O parameter
FILE* 	FP;
int 	CurrentSelect_Wv;
//****************************************************
//****************************************************
//****************************************************

  












//1. MAIN FUNCTION
int main (int argc, char *argv[])
{
	int i,c;
	char str[250];
	
//	DisableBreakOnLibraryErrors(); //CVI ?? ????? ?? ??
	
	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((mainPanel = LoadPanel (0, "FISS.uir", PANEL)) < 0)
		return -1;
	
	
	if ((FISSpanelSetting = LoadPanel (0, "FISS.uir", SetFISS)) < 0)
		return -1;	
	
	if ((testpanel = LoadPanel (0, "FISS.uir", test_panel)) < 0)
		return -1;	
	
	if ((aboutPanel = LoadPanel (0, "FISS.uir", InfoPanel)) < 0)
		return -1;		
	
	if ((menubar 	= LoadMenuBar (mainPanel, "FISS.uir", MENUBAR)) < 0)
		return -1;
	
	Radio_ConvertFromTree(mainPanel, PANEL_SelectAxis);         

	//SetPanelAttribute(mainPanel,ATTR_TOP,19);
	//SetPanelAttribute(mainPanel,ATTR_LEFT,10);
	//SetPanelAttribute(mainPanel,ATTR_WIDTH,1250);
	//SetPanelAttribute(mainPanel,ATTR_HEIGHT,950);

	DisplayPanel (mainPanel);
	
	GetPanelAttribute(mainPanel, ATTR_WIDTH, &panelwidth);
	GetPanelAttribute(mainPanel, ATTR_HEIGHT,&panelheight);
	
	SetCtrlAttribute(mainPanel, PANEL_IDLDRAWWIDGET,ATTR_VISIBLE,0);
	RunUserInterface ();
	DiscardPanel (mainPanel);
	

	return 0;
}


int CVICALLBACK panel_proc (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			QuitCallback(0, 0, EVENT_COMMIT,NULL, 0, 0);
			break;
	}
	return 0;
}



//2. ư  Ǵ callback function
//2-1. CCD ON/OFF
int CVICALLBACK CCD_TurnOnOff (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	long nCameraIndex;

	switch (event)
	{
		case EVENT_COMMIT:

			if(CCD_status !=1)
			{
				SetCtrlAttribute(mainPanel, PANEL_CCD_TurnOnOff, ATTR_LABEL_TEXT, "CCD On");
				GetAvailableCameras(&nNumberOfCameras);
			
				if(nNumberOfCameras == 1)
				{
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\n1 Camera Detected!!\n");
					nCameraIndex=0;
					GetCameraHandle(nCameraIndex,&nCameraHandle1);	//find camera handle;
				
					SetCurrentCamera(nCameraHandle1);				//set to 1st Camera as default setting
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nCamera1 is Opening\n"); 
					OpenCamera(nCameraHandle1);									//set                                       
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nCamera1 Open Complete!!\n");	
				}
			
				if(nNumberOfCameras == 2)
				{
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\n2 Two Cameras Detected!!\n");   
					nCameraIndex=0;
					GetCameraHandle(nCameraIndex,&nCameraHandle1);	//find camera handle;
					nCameraIndex=1;
					GetCameraHandle(nCameraIndex,&nCameraHandle2);  //find camera handle;			
				
					SetCurrentCamera(nCameraHandle1);				//set to 1st Camera as default setting
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nCamera1 is Opening\n"); 
					OpenCamera(nCameraHandle1);									//set                                       
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nCamera1 Open Complete!!\n");

					SetCurrentCamera(nCameraHandle2);				//set to 1st Camera as default setting
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nCamera2 is Opening\n"); 
					OpenCamera(nCameraHandle2);									//set                                       
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nCamera2 Open Complete!!\n");	

					SetCurrentCamera(nCameraHandle1);				//set to 1st Camera as default setting
					SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "\nSet to Current Camera1\n");	

				}
			
				SetCtrlVal(mainPanel, PANEL_CCD_Status, 1); 		//turn on ccd status lamp   
				SetMenuBarAttribute(menubar,MENUBAR_Setup,ATTR_DIMMED, 0); 
				SetMenuBarAttribute(menubar,MENUBAR_About,ATTR_DIMMED, 0);
				
			}
			
			
			else
			{
				SetCtrlAttribute(mainPanel, PANEL_CCD_TurnOnOff, ATTR_LABEL_TEXT, "CCD Off"); 
				SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 1);
				//SetCtrlAttribute(mainPanel, PANEL_Show_Hist, ATTR_DIMMED, 1);
				if(pFitsData)
				{
					free(pFitsData);
					pFitsData=NULL;
				}
				
				if(pusFitsData)
				{
					free(pusFitsData);
					pusFitsData=NULL;
				}
				
			
				if(planeDataCCD)
				{
					free(planeDataCCD);
					planeDataCCD=NULL;
				}
				
				
				if(BiasDark1)
				{
					free(BiasDark1);
					BiasDark1=NULL;
				}
				
				if(BiasDark2)
				{
					free(BiasDark2);
					BiasDark2=NULL;
				}
				

			
				if (nNumberOfCameras == 1)
				{
					CloseCamera(nCameraHandle1);//CLOSE CAMERA       
				}
 
				if (nNumberOfCameras == 2)
				{
					SetCurrentCamera(nCameraHandle1);
					CloseCamera(nCameraHandle1);//CLOSE CAMERA
					SetCurrentCamera(nCameraHandle2);
					CloseCamera(nCameraHandle2);
				}
				
				
				SetMenuBarAttribute(menubar,MENUBAR_Setup,ATTR_DIMMED, 1); 
				SetMenuBarAttribute(menubar,MENUBAR_About,ATTR_DIMMED, 1);				
	 			SetCtrlVal(mainPanel, PANEL_CCD_Status, 0); 		//turn off ccd status lamp     
			}

			break;
	}
	return 0;
}



//2-2 Scan ON/OFF
int CVICALLBACK Scan_TurnOnOff (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int functionID;
	switch (event)
	{
		case EVENT_COMMIT:
			
			if(Scanner_status !=1)
			{
				SetCtrlAttribute(mainPanel, PANEL_Scan_TurnOnOff, ATTR_LABEL_TEXT, "Scan On");
			 	ScanOpen();
				SetCtrlVal(mainPanel, PANEL_Scan_Status, 1); 
			
				//SetCtrlAttribute(mainPanel, PANEL_TIMER, ATTR_ENABLED, 1); 	 //activate timer   
				SetCtrlAttribute(mainPanel, PANEL_cmd_Run, ATTR_DIMMED, 0);   //undimming RUN Button

				Delay(1);
			
				CmtScheduleThreadPoolFunction (DEFAULT_THREAD_POOL_HANDLE, MonitoringThreadFunction, NULL, &functionID);
				CmtWaitForThreadPoolFunctionCompletion (DEFAULT_THREAD_POOL_HANDLE, functionID, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
				CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, functionID);  		
			}
			
			else
			{
				
				if(Scanning==1)
				{ 
					MessageBox(NULL, "Motor is still running.", "Error", MB_OK | MB_ICONINFORMATION);
				}
				else 
				{
					SetCtrlAttribute(mainPanel, PANEL_Scan_TurnOnOff, ATTR_LABEL_TEXT, "Scan Off");
					PmacAccessible=0;	

					CloseDevice();
					SetCtrlVal(mainPanel, PANEL_Scan_Status, 0); 
				
					//display motor status(by lamp)
					//SetCtrlVal(mainPanel, PANEL_AMPON, 0);   
					SetCtrlVal(mainPanel, PANEL_INPOSITION, 0);
					SetCtrlVal(mainPanel, PANEL_MOTORRUN, 0);
					//SetCtrlVal(mainPanel, PANEL_AMPFAULTERR, 0);  
					SetCtrlVal(mainPanel, PANEL_PLIMIT, 0);
					SetCtrlVal(mainPanel, PANEL_NLIMIT, 0); 
					//SetCtrlVal(mainPanel, PANEL_OPENLOOP, 0); 
				}
			}
			break;
	}
	return 0;
}



//2-3 Grating/CCD ON/OFF
int CVICALLBACK Motor_TurnOnOff (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			if(Motor_status!=1)
			{
				SetCtrlAttribute(mainPanel, PANEL_Motor_TurnOnOff, ATTR_LABEL_TEXT, "Motor On");
				SetCtrlVal(mainPanel, PANEL_Motor_Status, 1);
		
				MotorConnect();
				//SlitHatchOpen();
				Motor_status=1; 
			}
				
								  
			else
			{
				SetCtrlAttribute(mainPanel, PANEL_Motor_TurnOnOff, ATTR_LABEL_TEXT, "Motor Off");
				SetCtrlVal(mainPanel, PANEL_Motor_Status, 0);  

				//SlitHatchClose();
				MotorDisconnect();   
				Motor_status=0;
			}

			break;
	}
	return 0;
}


//2-4. SETUPư  Ǵ Լ
//callback function when you click setup button. display setup pannel
int CVICALLBACK Set_FISS_parameter (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			DisplayPanel(FISSpanelSetting);
			SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 1);  //dimming picture window 
			// κ ¾â   PIC_WINDOW  ʵ ִ κ.
			
			SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,1);
			SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,1);			
			
			if(BiasDark1)
			{
				free(BiasDark1);
				BiasDark1=NULL;
			}
			if(BiasDark2)
			{
				free(BiasDark2);
				BiasDark2=NULL;
			}										
			

			if(CCD_status == 1)
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 0, ATTR_DIMMED, 0);
			}
			else
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 0, ATTR_DIMMED, 1); 
			}
			
			
			if(Scanner_status ==1)
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 1, ATTR_DIMMED, 0); 
			}
			else
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 1, ATTR_DIMMED, 1);
			}
			
			
			if(Motor_status == 1)
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 2, ATTR_DIMMED, 0);  
			}
			else
			{
				SetTabPageAttribute(FISSpanelSetting, SetFISS_setTAB, 2, ATTR_DIMMED, 1); 
			}
			break;
	}
	return 0;
}


int CVICALLBACK SetFISS_proc (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			HidePanel(FISSpanelSetting);

			break;
	}
	return 0;
}




//2-5. Obs. Test Button  Ǵ Լ
int CVICALLBACK Obs_Test (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int cooleronoff1,cooleronoff2;

	
	switch (event)
	{
		case EVENT_COMMIT:
			Radio_GetMarkedOption(testpanel,test_panel_CoolerOnOff, &cooleronoff1);
			Radio_GetMarkedOption(testpanel,test_panel_CoolerOnOff2,&cooleronoff2);			

			DisplayPanel(testpanel);  
			
			if(CCD_status == 1)
			{
				//SetCtrlAttribute(testpanel, test_panel_CCD_setCamera, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TEXTMSG, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_CoolerOnOff,ATTR_DIMMED,0);
				SetCtrlAttribute(testpanel, test_panel_CoolerOnOff2,ATTR_DIMMED,0);
				SetCtrlAttribute(testpanel, test_panel_TB_Text_Monitor,ATTR_DIMMED,0);
				if(cooleronoff1==1)
				{
					SetCtrlAttribute(testpanel, test_panel_ccdTemp,ATTR_DIMMED,0);
					SetCtrlAttribute(testpanel, test_panel_setCooler,ATTR_DIMMED,0);
				}
				if(cooleronoff2==1)
				{
					SetCtrlAttribute(testpanel, test_panel_ccdTemp2,ATTR_DIMMED,0);
					SetCtrlAttribute(testpanel, test_panel_setCooler2,ATTR_DIMMED,0);					
				}
				
			}
			
			if(Scanner_status == 1)
			{
				SetCtrlAttribute(testpanel, test_panel_SlitStepDecrease, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_SlitStepSize, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_SlitStepIncrease, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_SetZero, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_upload_data, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TEXTMSG_2, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_radio_scan, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_STR_Command, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TB_Text_Monitor, ATTR_DIMMED, 0);
			}
			
			if(Motor_status == 1)
			{
				ResetPanel();
				OpenFileF(FP);
				InitPanel();
				
				SetCtrlAttribute(testpanel, test_panel_Motor_Device_Select, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Moving_Distance, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Step_Decrease, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Stop, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Step_Increase , ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_Motor_Position, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TEXTMSG_4, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TEXTMSG_5, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_NUMOFWV, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_CSELLECTWV, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_STARTPOSITION, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_WVLISTBOX, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_NUMERICWV, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_NUMERICSTEP, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_NUMERICANGLE, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_INSERTBUTTON , ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_DELBTN, ATTR_DIMMED, 0);
			//	SetCtrlAttribute(testpanel, test_panel_WRITEBTN, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_radio_motor, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_STR_Command, ATTR_DIMMED, 0);
				SetCtrlAttribute(testpanel, test_panel_TB_Text_Monitor, ATTR_DIMMED, 0);
			}
			

			break;
	}
	return 0;
}


int CVICALLBACK test_panel_proc (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			//SetCtrlAttribute(testpanel, test_panel_CCD_setCamera, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TEXTMSG, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TEXTMSG, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_ccdTemp, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_setCooler,ATTR_DIMMED,1);
			SetCtrlAttribute(testpanel, test_panel_CoolerOnOff,ATTR_DIMMED,1);
			SetCtrlAttribute(testpanel, test_panel_ccdTemp2, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_setCooler2,ATTR_DIMMED,1);
			SetCtrlAttribute(testpanel, test_panel_CoolerOnOff2,ATTR_DIMMED,1);						
				
			SetCtrlAttribute(testpanel, test_panel_SlitStepDecrease, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_SlitStepSize, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_SlitStepIncrease, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_SetZero, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_upload_data, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TEXTMSG_2, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_radio_scan, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_STR_Command, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TB_Text_Monitor, ATTR_DIMMED, 1);
				
			SetCtrlAttribute(testpanel, test_panel_Motor_Device_Select, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Moving_Distance, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Step_Decrease, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Stop, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Step_Increase , ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_Motor_Position, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TEXTMSG_4, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_TEXTMSG_5, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_NUMOFWV, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_CSELLECTWV, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_STARTPOSITION, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_WVLISTBOX, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_NUMERICWV, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_NUMERICSTEP, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_NUMERICANGLE, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_INSERTBUTTON , ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_DELBTN, ATTR_DIMMED, 1);
		//	SetCtrlAttribute(testpanel, test_panel_WRITEBTN, ATTR_DIMMED, 1);
			SetCtrlAttribute(testpanel, test_panel_radio_motor, ATTR_DIMMED, 1);				

			HidePanel(testpanel);

			break;
	}
	return 0;
}



//2-6. Open ư   Ǵ Լ
int CVICALLBACK cmdOpen (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int ret;
	char Buff[MAX_PATHNAME_LEN];
	char* format=".bmp";
	char* n;
	int radiogroup_index=0;
	char temp[10];
	
	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 1);  //dimming picture window 
		
			//////////////////
			ret=FileSelectPopup("","*.fts","*.fts;*.bmp;*.fit;*.fits","Load Data File",VAL_LOAD_BUTTON,0,0,1,0,Buff);
			if(ret)
			{
				SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0); 
				SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_GRAPH, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_xpos, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_ypos, ATTR_DIMMED, 0);
				SetCtrlAttribute(mainPanel, PANEL_value, ATTR_DIMMED, 0);
			//	SetCtrlAttribute(mainPanel, PANEL_Show_Hist, ATTR_DIMMED, 0);				
				
				n=strstr(Buff,format);
				if(n==NULL)
				{
					OpenFitsFile(Buff);
					
					if(FitsHeader.nAxis1<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis1>512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+FitsHeader.nAxis1-512);  						
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2>512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+FitsHeader.nAxis2-512);     
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis==3 && FitsHeader.nAxis3>1)
					{
						SetCtrlAttribute(mainPanel, PANEL_SelectAxis, ATTR_DIMMED, 0);
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_DIMMED, 0);
					}
					
					
					if(FitsHeader.nAxis==3 && FitsHeader.nAxis3==1)
					{
						SetCtrlAttribute(mainPanel, PANEL_SelectAxis, ATTR_DIMMED, 1);
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_DIMMED, 1);
					}
					
					if(FitsHeader.nAxis==2)
					{
						SetCtrlAttribute(mainPanel, PANEL_SelectAxis, ATTR_DIMMED, 1);
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_DIMMED, 1);						
					}
					
					
					sprintf(temp, "%.2f", mean);
					SetCtrlVal(mainPanel, PANEL_datamean, temp);
					sprintf(temp, "%.2f", stdev);
					SetCtrlVal(mainPanel, PANEL_datastdev, temp);
					
					sprintf(temp, "%d", FitsHeader.nAxis1);
					SetCtrlVal(mainPanel, PANEL_nAxis1, temp);
					sprintf(temp,"%d",FitsHeader.nAxis2);
					SetCtrlVal(mainPanel, PANEL_nAxis2, temp);
					
					if(FitsHeader.nAxis==3)
					{
						sprintf(temp, "%d", FitsHeader.nAxis3);
						SetCtrlVal(mainPanel, PANEL_nAxis3, temp);
					}
					
					sprintf(temp, "%.2f",FitsHeader.ExpTime);
					SetCtrlVal(mainPanel, PANEL_ExpTime, temp);
					
				}
				else
				{
					OpenBitmap(Buff);
					SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 1);  //dimming picture window
				}

				Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);
			}	
			break;
	}
	return 0;
}


//2-7 RUN ư   ϴ Լ
// ϴ κ(CCD or CCD+Scanner )
int CVICALLBACK cmd_Run (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int 			i;
	char 			temp[50],temp1[50],temp2[50],temp3[50],temp4[50];
	unsigned short 	minvalue,maxvalue;
	int				ccd_acqmode; //ccd acquisition mode(single, video, frame transfer)
	float diff_time1,diff_time2;
	int				ii,j,k,startpoint1,startpoint2;
	int				flatstart1,flatstart2;
	int				shift[7]={-110,-90,-30,0,20,80,115};
	int				id,handle;


	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 1);  //dimming picture window   
			
			SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,1);
			SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,1);						

			GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle);
			GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setAcq, &ccd_acqmode);
			
			if(!QueryPerformanceFrequency(&gliFreq))
				MessagePopup("Error","Cannot support the timer of high resolution");
			
			Sleep(500);
			
			if((CCD_status==1) && (Scanner_status!=1))		//case of CCD On, Scanner Off
			{
					if( g_nFrameNumber1==1 )	  //single mode ,    1 .
					{													      //ܼ single mode
						SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
						
						if(ccd_camera==2 || ccd_camera==3)					//both mode
						{
							for(i=0;i<sequential_number;i++)
							{
								memset(g_pRawData ,0,nhDim1*nvDim1*sizeof(WORD));
								memset(g_pRawData2,0,nhDim2*nvDim2*sizeof(WORD));								
								
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);

								marktime_start(temp1);
								SetCurrentCamera(nCameraHandle1);
								TakeImage(nhDim1, nvDim1, nCameraHandle1, 0);
								marktime_end(temp2);
								diff_time1=time_difference();
								
								marktime_start(temp3);
								SetCurrentCamera(nCameraHandle2);
								TakeImage(nhDim2, nvDim2, nCameraHandle2, 0);
								marktime_end(temp4);
								diff_time2=time_difference();

								//BiasDarkCorrection(nhDim1, nvDim1, nCameraHandle1, g_nFrameNumber1-1);
								//BiasDarkCorrection(nhDim2, nvDim2, nCameraHandle2, g_nFrameNumber1-1);
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);
								SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime1, nCameraHandle2, temp3, temp4, diff_time2, entire_directory); 
								Sleep(1000);
								
								GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
								if(id==PANEL_FISS_cmdStop)//STOPư  
									break;
							}

							SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window   
							
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);  
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
							SetCtrlVal(mainPanel, PANEL_viewCCD2,0);
						}

				
						else if(ccd_camera==0)			//ccd1,nCameraHandle1				  //use single camera
						{
							SetCurrentCamera(nCameraHandle1);
							for(i=0;i<sequential_number;i++)
							{
								memset(g_pRawData ,0,nhDim1*nvDim1*sizeof(WORD));
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);									

								marktime_start(temp1);
								TakeImage(nhDim1, nvDim1, nCameraHandle1, 0);
								marktime_end(temp2);
								diff_time1=time_difference();
								
								//BiasDarkCorrection(nhDim1,nvDim1,nCameraHandle1,g_nFrameNumber1-1);
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);
								Sleep(1000);
								
								GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
								if(id==PANEL_FISS_cmdStop)//STOPư  
									break;								
							}
							SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);	
							SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
							SetCtrlVal(mainPanel, PANEL_viewCCD2,0);
						}
						
						else if(ccd_camera==1)		//ccd2,nCameraHandle2
						{
							SetCurrentCamera(nCameraHandle2);
							for(i=0;i<sequential_number;i++)
							{
								memset(g_pRawData2 ,0,nhDim2*nvDim2*sizeof(WORD));  
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);									

								marktime_start(temp1);
								TakeImage(nhDim2, nvDim2, nCameraHandle2, 0);
								marktime_end(temp2);
								diff_time1=time_difference();

								//BiasDarkCorrection(nhDim2,nvDim2,nCameraHandle2,g_nFrameNumber1-1);
								SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime1, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);	
								Sleep(1000);
								
								GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
								if(id==PANEL_FISS_cmdStop)//STOPư  
									break;								
							}
							SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);	
							SetCtrlVal(mainPanel, PANEL_viewCCD1, 0);
							SetCtrlVal(mainPanel, PANEL_viewCCD2, 1);
						}   						
					}			
			

					if( g_nFrameNumber1 == 0)      //video(focus) mode
					{															 // ,  ȭ鿡  ϱ⿡ thread Ѵ.
						if(ccd_camera==0)	//ccd1
							SetCurrentCamera(nCameraHandle1); 
						
						else if(ccd_camera==1)	  //ccd2
							SetCurrentCamera(nCameraHandle2);
			
						SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 						
						threadparam=0;
						CmtScheduleThreadPoolFunction(DEFAULT_THREAD_POOL_HANDLE, setVideoThread, NULL, &threadfunctionID);
						CmtWaitForThreadPoolFunctionCompletion(DEFAULT_THREAD_POOL_HANDLE, threadfunctionID, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
						CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, threadfunctionID);
					}
					
					
					if((g_nFrameNumber1>1) && (ccd_acqmode==6))			  //frame transfer mode
					{
						for(i=0;i<sequential_number;i++)
						{
							sprintf(temp,"%d",i+1);
							SetCtrlVal(mainPanel,PANEL_S1,temp);
							sprintf(temp,"%d",i);							
							
							if(ccd_camera==0)	//ccd1
							{
								memset(g_pRawData ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));
								
								marktime_start(temp1);
								TakeImage_FTmode(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);
								marktime_end(temp2);
								diff_time1=time_difference();
								
								//BiasDarkCorrection(nhDim1,nvDim1,nCameraHandle1,g_nFrameNumber1-1);
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);	
								DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);
								SetCtrlVal(mainPanel, PANEL_viewCCD1, 1);
								SetCtrlVal(mainPanel, PANEL_viewCCD2, 0);
								
							}
							if(ccd_camera==1)	//ccd2
							{
								memset(g_pRawData2,0,nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD));

								marktime_start(temp1);
								TakeImage_FTmode(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);
								marktime_end(temp2);
								diff_time1=time_difference();

								//BiasDarkCorrection(nhDim2,nvDim2,nCameraHandle2,g_nFrameNumber1-1);
								SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime1, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);
								DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);
								SetCtrlVal(mainPanel, PANEL_viewCCD1, 0);
								SetCtrlVal(mainPanel, PANEL_viewCCD2, 1);
								
							}
							
							
							GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
							if(id==PANEL_FISS_cmdStop)//STOPư  
								break;							
							
						}  //sequential loop
					}  //g_nFrameNumber>1
			}	   //ccd on, scan off
			

			if((CCD_status==1) && (Scanner_status==1))		//case of CCD On, Scanner On
			{
				if(g_nFrameNumber1 <= 1)								//1 frame ,   CCD Ѵ°  Ȳ.
				{
					if(g_nFrameNumber1==1)	  //single mode ,    1 .
					{													      //ܼ single mode
						SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
						
						if(ccd_camera==2 || ccd_camera==3)				   //both mode
						{
							for(i=0;i<sequential_number;i++)
							{
								memset(g_pRawData  ,0,nhDim1*nvDim1*sizeof(WORD));  								
								memset(g_pRawData2 ,0,nhDim2*nvDim2*sizeof(WORD));  								
								
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
								
								marktime_start(temp1);
								SetCurrentCamera(nCameraHandle1);
								TakeImage(nhDim1, nvDim1, nCameraHandle1, 0);
								marktime_end(temp2);
								diff_time1=time_difference();

								marktime_start(temp3);
								SetCurrentCamera(nCameraHandle2);
								TakeImage(nhDim1, nvDim1, nCameraHandle2, 0);
								marktime_end(temp4);
								diff_time2=time_difference();
								
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);
								SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime1, nCameraHandle2, temp3, temp4, diff_time2, entire_directory);
								Sleep(1000);
								
								GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
								if(id==PANEL_FISS_cmdStop)//STOPư  
									break;								
							}
							SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							
							DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);
							SetCurrentCamera(nCameraHandle1);
							
							SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
							SetCtrlVal(mainPanel, PANEL_viewCCD2,0);							
						}
						

						else if (ccd_camera==0)		//ccd1, nCameraHandle1					  //use single camera
						{
							SetCurrentCamera(nCameraHandle1);
							for(i=0;i<sequential_number;i++)
							{
								memset(g_pRawData  ,0,nhDim1*nvDim1*sizeof(WORD));  
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
								
								marktime_start(temp1);
								TakeImage(nhDim1, nvDim1, nCameraHandle1, 0);
								marktime_end(temp2);
								diff_time1=time_difference();

								//BiasDarkCorrection(nhDim1,nvDim1,nCameraHandle1,g_nFrameNumber1-1);
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);
								Sleep(1000);
								
								GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
								if(id==PANEL_FISS_cmdStop)//STOPư  
									break;								
							}
							SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);	
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_viewCCD1, 1);
							SetCtrlVal(mainPanel, PANEL_viewCCD2, 0);
						}
						
						else if(ccd_camera==1)		//ccd2, nCameraHandle2
						{
							SetCurrentCamera(nCameraHandle2);
							for(i=0;i<sequential_number;i++)
							{
								memset(g_pRawData2  ,0,nhDim2*nvDim2*sizeof(WORD));  
								sprintf(temp,"%d",i+1);
								SetCtrlVal(mainPanel,PANEL_S1,temp);
									
								marktime_start(temp1);
								TakeImage(nhDim2, nvDim2, nCameraHandle2, 0);
								marktime_end(temp2);
								diff_time1=time_difference();
								
								//BiasDarkCorrection(nhDim2,nvDim2,nCameraHandle2,g_nFrameNumber1-1);
								SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime1, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);
								Sleep(1000);
								
								GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
								if(id==PANEL_FISS_cmdStop)//STOPư  
									break;								
							}
							SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);
							SetCurrentCamera(nCameraHandle2);
							SetCtrlVal(mainPanel, PANEL_viewCCD1, 0);
							SetCtrlVal(mainPanel, PANEL_viewCCD2, 1);
						}						
					}			
			

					if(g_nFrameNumber1 == 0)      //video(focus) mode
					{															 // ,  ȭ鿡  ϱ⿡ thread Ѵ.
						threadparam=0;
						SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 												

						CmtScheduleThreadPoolFunction(DEFAULT_THREAD_POOL_HANDLE, setVideoThread, NULL, &threadfunctionID);
						CmtWaitForThreadPoolFunctionCompletion(DEFAULT_THREAD_POOL_HANDLE, threadfunctionID, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
						CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, threadfunctionID);
					}	
				}
				
			
				
				//Most Important Part!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
				if(g_nFrameNumber1 >1)		// CCD Scanner Ǿ  κ.
				{

					if(ccd_camera==2 || ccd_camera==3)				   //both mode
					{
						//printf("ccd_camera=%d\n",ccd_camera);
						for(i=0;i<sequential_number;i++)
						{
							memset(g_pRawData  ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));  
							memset(g_pRawData2 ,0,nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD));  
							sprintf(temp,"%d",i+1);
							SetCtrlVal(mainPanel,PANEL_S1,temp);
							
							if(ccd_camera==2)
							{   
								fiss_take_mode=0;
								do
								{
								}while(!((scanpos<0.3) && (scanpos>-0.3) && (Scanner_InPosition==1))) ;								
							
								marktime_start(temp1);
								SetCurrentCamera(nCameraHandle1);
								ExecuteProgram(nCameraHandle1,0);
								marktime_end(temp2);
								diff_time1=time_difference();

								do
								{
								}while(!((scanpos<0.3) && (scanpos>-0.3) && (Scanner_InPosition==1))) ;
					

								marktime_start(temp3);
								SetCurrentCamera(nCameraHandle2);
								ExecuteProgram(nCameraHandle2,0);	
								marktime_end(temp4);
								diff_time2=time_difference();
								
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory); 
								SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime1, nCameraHandle2, temp3, temp4, diff_time2, entire_directory);								
							}
					
							
							if(ccd_camera==3)
							{
								fiss_take_mode=1;
								do
								{
								}while(!((scanpos<0.3) && (scanpos>-0.3) && (Scanner_InPosition==1))) ;

								marktime_start(temp1);
								SetCurrentCamera(nCameraHandle1);
								ExecuteProgram(nCameraHandle1,1);
								marktime_end(temp2);
								diff_time1=time_difference();
								
								SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory); 
								SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime1, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);								
							}

							
							SetCurrentCamera(nCameraHandle1);
							Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
							Display3D_CCD(1,nhDim1/2,&minvalue,&maxvalue,nCameraHandle1);
							
							GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
							if(id==PANEL_FISS_cmdStop)//STOPư  
								break;							
							
						}
						
						SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
						
						SetCurrentCamera(nCameraHandle1);
						DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1); 
						SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
						SetCtrlVal(mainPanel, PANEL_viewCCD2,0);
						
					}	
					
					else if(ccd_camera==4)		 //flat fileding, important!!!
					{
						SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW,ATTR_DIMMED,1);   
						for(ii=0;ii<7;ii++)			   //number of moving grating
						{
							Gratingtracking(2, Data[0].Step+shift[ii]); 
							sprintf(temp, "%d th Grating Position : %d\n", ii+1, Data[0].Step+shift[ii]);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, temp);
							
							sprintf(temp,"%d",ii+1);
							SetCtrlVal(mainPanel, PANEL_S1, temp);
							fiss_take_mode=1;
							memset(g_pRawData  ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));  
							memset(g_pRawData2 ,0,nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD));  
							memset(flatdata1,0,nhDim1*nvDim1*sizeof(float));
							memset(flatdata2,0,nhDim2*nvDim2*sizeof(float));
							//Gratingtracking(2, Data[0].Step+shift[ii]);  //move motor at specific angle by using absolute position value(2) 
							
							do
							{
							}while(!((scanpos<0.3) && (scanpos>-0.3) && (Scanner_InPosition==1))) ;

							marktime_start(temp1);
							SetCurrentCamera(nCameraHandle1);
							ExecuteProgram(nCameraHandle1,1);
							marktime_end(temp2);
							diff_time1=time_difference();
							
							for(k=0;k<g_nFrameNumber1;k++) //number of frame
							{
								startpoint1=nhDim1*nvDim1*k;
								for(j=0;j<nhDim1*nvDim1;j++)
									flatdata1[j]=flatdata1[j]+g_pRawData[j+startpoint1];//-BiasDark1[j];
									
								startpoint2=nhDim2*nvDim2*k;
								for(j=0;j<nhDim2*nvDim2;j++)
									flatdata2[j]=flatdata2[j]+g_pRawData2[j+startpoint2];//-BiasDark2[j];
							}
							
							flatstart1=nhDim1*nvDim1*ii;
							flatstart2=nhDim2*nvDim2*ii;
							
							for(k=0;k<nhDim1*nvDim1;k++)
							{
								flatdata1[k]=flatdata1[k]/(float)g_nFrameNumber1-(float)BiasDark1[k];
								flatcube1[k+flatstart1]=flatdata1[k];
							}
							for(k=0;k<nhDim2*nvDim2;k++)
							{
								flatdata2[k]=flatdata2[k]/(float)g_nFrameNumber1-(float)BiasDark2[k];
								flatcube2[k+flatstart2]=flatdata2[k];
							}
							
							DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);	
						}
						
						SaveFlatFits(nhDim1, nvDim1, 7, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1,entire_directory); 
						SaveFlatFits(nhDim2, nvDim2, 7, g_fExpTime1, nCameraHandle2, temp1, temp2, diff_time1,entire_directory);	
						
						//free(flatdata1);
						//free(flatdata2);
						//free(flatcube1);
						//free(flatcube2);

						//the process calibration files   
						Gratingtracking(2, Data[0].Step); 	   //return original position
						
//						do
//						{
//						}while(!((scanpos<0.3) && (scanpos>-0.3) && (Scanner_InPosition==1))) ;						
						
//						memset(g_pRawData  ,0,nhDim1*nvDim1*g_nFrameNumber1*sizeof(WORD));  
//						memset(g_pRawData2 ,0,nhDim2*nvDim2*g_nFrameNumber1*sizeof(WORD));
//						memset(caldata1,0,nhDim1*nvDim1*sizeof(float));
//						memset(caldata2,0,nhDim2*nvDim2*sizeof(float));
						
//						marktime_start(temp1);
//						SetCurrentCamera(nCameraHandle1);
//						ExecuteProgram(nCameraHandle1,1);
//						marktime_end(temp2);
//						diff_time1=time_difference();	
						
//						for(k=0;k<g_nFrameNumber1;k++) //number of frame
//						{
//							startpoint1=nhDim1*nvDim1*k;
//							for(j=0;j<nhDim1*nvDim1;j++)
//								caldata1[j]=caldata1[j]+g_pRawData[j+startpoint1];//-BiasDark1[j];
//								
//							startpoint2=nhDim2*nvDim2*k;
//							for(j=0;j<nhDim2*nvDim2;j++)
//								caldata2[j]=caldata2[j]+g_pRawData2[j+startpoint2];//-BiasDark2[j];
//						}
//						
//						
//						for(k=0;k<nhDim1*nvDim1;k++)
//							caldata1[k]=caldata1[k]/(float)g_nFrameNumber1-(float)BiasDark1[k];
  //
	//					for(k=0;k<nhDim2*nvDim2;k++)
//							caldata2[k]=caldata2[k]/(float)g_nFrameNumber1-(float)BiasDark2[k];

//						SaveCalibFits(nhDim1, nvDim1, 7, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1,entire_directory); 
//						SaveCalibFits(nhDim2, nvDim2, 7, g_fExpTime1, nCameraHandle2, temp1, temp2, diff_time1,entire_directory);							
					}



					else if(ccd_camera==0)				//ccd1,nCameraHandle1			 //single camera
					{  
						fiss_take_mode=0;
						SetCurrentCamera(nCameraHandle1);
						for(i=0;i<sequential_number;i++) 
						{
							memset(g_pRawData  ,0,nhDim1*nvDim1*sizeof(WORD));  
							sprintf(temp,"%d",i+1);
							SetCtrlVal(mainPanel,PANEL_S1,temp);
								
							do
							{
							}while(!((scanpos<0.3) && (scanpos>-0.3) && (Scanner_InPosition==1))) ;	
							
							marktime_start(temp1);
							ExecuteProgram(nCameraHandle1,0);
							marktime_end(temp2);
							diff_time1=time_difference();
							
							SaveFits(nhDim1, nvDim1, g_nFrameNumber1, g_fExpTime1, nCameraHandle1, temp1, temp2, diff_time1, entire_directory);	
								
							Display3D_CCD(1,nhDim1/2,&minvalue,&maxvalue, nCameraHandle1);
							
							GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
							if(id==PANEL_FISS_cmdStop)//STOPư  
								break;							
						}
						SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
						Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
						DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1); 		
						SetCurrentCamera(nCameraHandle1);
						SetCtrlVal(mainPanel, PANEL_viewCCD1, 1);
						SetCtrlVal(mainPanel, PANEL_viewCCD2, 0);
					}
					
					else if(ccd_camera==1)		   //ccd2, nCameraHandle2
					{
						fiss_take_mode=0;
						SetCurrentCamera(nCameraHandle2);
						for(i=0;i<sequential_number;i++) 
						{
							memset(g_pRawData2  ,0,nhDim2*nvDim2*sizeof(WORD));  
							sprintf(temp,"%d",i+1);
							SetCtrlVal(mainPanel,PANEL_S1,temp);
								
							do
							{
							}while(!((scanpos<0.3) && (scanpos>-0.3) && (Scanner_InPosition==1))) ;	
							
							marktime_start(temp1);
							ExecuteProgram(nCameraHandle2,0);
							marktime_end(temp2);
							diff_time1=time_difference();
							
							SaveFits(nhDim2, nvDim2, g_nFrameNumber1, g_fExpTime1, nCameraHandle2, temp1, temp2, diff_time1, entire_directory);
								
							Display3D_CCD(1,nhDim2/2,&minvalue,&maxvalue, nCameraHandle2);
							
							GetUserEvent(1,&handle,&id);//Ű峪 콺 ̺Ʈ ־?
							if(id==PANEL_FISS_cmdStop)//STOPư  
								break;							
						}
						SetCtrlAttribute(mainPanel, PANEL_PIC_WINDOW, ATTR_DIMMED, 0);  //undimming picture window 
						Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);   
						DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2); 	
						SetCurrentCamera(nCameraHandle2);
						SetCtrlVal(mainPanel, PANEL_viewCCD1, 0);
						SetCtrlVal(mainPanel, PANEL_viewCCD2, 1);
					}						

					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_DIMMED, 0); //undim Frame Slide 
					SetCtrlAttribute(mainPanel, PANEL_SelectAxis, ATTR_DIMMED, 0); //undim Frame Slide         
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, g_nFrameNumber1-1);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, 0);						
				}
			}
			DataSource=1;
			if(ccd_camera==2 || ccd_camera==3)
			{
				SetCtrlAttribute(mainPanel, PANEL_viewCCD1,ATTR_DIMMED,0);
				SetCtrlAttribute(mainPanel, PANEL_viewCCD2,ATTR_DIMMED,0);
				SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
			}
			
			break;
	}
	return 0;
}


//2-8. STOP ư   Ǵ Լ
int CVICALLBACK cmdStop (int panel, int control, int event,
			void *callbackData, int eventData1, int eventData2)
{
		switch (event)
		{
			case EVENT_COMMIT:
				threadparam=1;     //stop command
				//AbortAcquisition();
				break;
		}
		return 0;
}


//2-9. QUIT ư   Ǵ Լ
int CVICALLBACK QuitCallback (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int current_ccd_temp;
	char temp[255];
	int errorValue;
	switch (event)
	{
		case EVENT_COMMIT:
			threadparam=1; //stop thread
			
			if(Motor_status==1)
			{
				MotorDisconnect();    
				Motor_status=0;
			}			
			
			if(CCD_status==1)
			{
					if(pFitsData!=NULL)
					{
						free(pFitsData);
						pFitsData=NULL;
					}
			

					if(pusFitsData!=NULL)
					{
						free(pusFitsData);
						pusFitsData=NULL;
					}
					
					if(planeDataCCD!=NULL)
					{
						free(planeDataCCD);
						planeDataCCD=NULL;
					}
					
					if(g_pRawData)
					{
						free(g_pRawData);
						g_pRawData=NULL;
					}
					
					if(g_pRawData2)
					{
						free(g_pRawData2);
						g_pRawData2=NULL;
					}
					
					if(BiasDark1!=NULL)
					{
						free(BiasDark1);
						BiasDark1=NULL;
					}
					
					if(BiasDark2!=NULL)
					{
						free(BiasDark2);
						BiasDark2=NULL;
					}
					
					
					
					if(coolingStatus)
					{
					
						GetTemperature(&current_ccd_temp);
				
						while(current_ccd_temp<0)
						{
							SetTemperature(10);
							GetTemperature(&current_ccd_temp);
							sprintf(temp,"Current Temperature on CCD is %d\n", current_ccd_temp);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,temp);
						}
						//SetCtrlAttribute(mainPanel, PANEL_ccdTemp,ATTR_DIMMED,1); 
						errorValue=CoolerOFF();
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nCooler Off!\n");  
						if(errorValue!=DRV_SUCCESS)
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nError Switching Cooler Off!\n");						
					}


				
				
					if(nNumberOfCameras == 1)
					{
						CloseCamera(nCameraHandle1)
							;//CLOSE CAMERA    
						CCD_status=0;
					}
					if(nNumberOfCameras == 2)
					{
						SetCurrentCamera(nCameraHandle1);
						CloseCamera(nCameraHandle1);//CLOSE CAMERA
						SetCurrentCamera(nCameraHandle2);
						CloseCamera(nCameraHandle2);
						CCD_status=0;
					}
			}
				
			
			if(Scanner_status==1)
			{
				
				if(Scanning==1)
				{ 
					MessageBox(NULL, "Motor is still running.", "Error", MB_OK | MB_ICONINFORMATION);
				}
				else 
				{
					PmacAccessible=0;	
					CloseDevice();
					Motor_status=0;
				}
			}

			QuitUserInterface (0);
			
			break;
	}
	return 0;
}



//******************************************************************************************
//******************************************************************************************
//*********************************|  Thread Functions  |***********************************
//******************************************************************************************
//******************************************************************************************

//Synchronization between CCD and Scanner
//It operates after Scanner on.
//if take==1, it start to taking image to imaging spectroscopy
/*
int CVICALLBACK MonitoringThreadFunction (void *functionData)
{
	char response[256];
	

	while(PmacAccessible)
	{
		 ReadPosition();
		 Monitor();
//	 	if(take==1)		   //at this part, it operate ccd-scanner synchronization 
//	 	{
//			GetCurrentCamera(&nUnknownCameraHandle); 
//			if(nUnknownCameraHandle==nCameraHandle1)
//			{
//				TakeImage(nhDim1, nvDim1, nCameraHandle1, Scanpos_CCDframe-1);
//				//printf("%d ", Scanpos_CCDframe-1);
//			}	
//			if(nUnknownCameraHandle==nCameraHandle2)
//			{
//				TakeImage(nhDim2, nvDim2, nCameraHandle2, Scanpos_CCDframe-1);
//				//printf("%d ", Scanpos_CCDframe-1);
//			}
//			take=0;
//			//both_move==0;
//	 	}
		
	 }

	 return 1;

}
*/



int CVICALLBACK MonitoringThreadFunction (void *functionData)
{
	char response[256];
	

	while(PmacAccessible)
	{
		 ReadPosition();
		 Monitor();
	 	if(take==1 && fiss_take_mode==0)		   //at this part, it operate ccd-scanner synchronization 
	 	{
			GetCurrentCamera(&nUnknownCameraHandle); 
			if(nUnknownCameraHandle==nCameraHandle1)
			{
				TakeImage(nhDim1, nvDim1, nCameraHandle1, Scanpos_CCDframe-1);
			}	
			if(nUnknownCameraHandle==nCameraHandle2)
			{
				TakeImage(nhDim2, nvDim2, nCameraHandle2, Scanpos_CCDframe-1);
			}
			take=0;
	 	}
		
		if(take==1 && fiss_take_mode==1)
		{
			SetCurrentCamera(nCameraHandle1);
			TakeImage(nhDim1, nvDim1, nCameraHandle1, Scanpos_CCDframe-1);
			SetCurrentCamera(nCameraHandle2);
			TakeImage(nhDim2, nvDim2, nCameraHandle2, Scanpos_CCDframe-1);
			take=0;
		}
		
	 }

	 return 1;

}



//video mode thread
static int CVICALLBACK setVideoThread(void* functionData)
{
		GetCurrentCamera(&nUnknownCameraHandle);
		while(!threadparam)
		{
			if(nUnknownCameraHandle==nCameraHandle1)
			{
				TakeImage(nhDim1, nvDim1, nCameraHandle1, 0);
				DisplayCCDImage(nhDim1, nvDim1, 1, nCameraHandle1);				
			}
			if(nUnknownCameraHandle==nCameraHandle2)
			{
				TakeImage(nhDim2, nvDim2, nCameraHandle2, 0);
				DisplayCCDImage(nhDim2, nvDim2, 1, nCameraHandle2);
			}
		}
		return 0;
	}


static int CVICALLBACK setTempThread(void* functionData)
{
	int errorValue1,errorValue2;
	int CCDTemp1, CCDTemp2;
	int i=0;
	char buffer[100];
	
	while(!temp_thread)
	{
		SetCurrentCamera(nCameraHandle1);
		errorValue1=GetTemperature(&CCDTemp1);
		SetCurrentCamera(nCameraHandle2);
		errorValue2=GetTemperature(&CCDTemp2);
		
		if((errorValue!=DRV_TEMP_STABILIZED) ||errorValue!=DRV_TEMP_STABILIZED)
		{
				Delay(1);
				SetCurrentCamera(nCameraHandle1);
				errorValue1=GetTemperature(&CCDTemp1);
				SetCurrentCamera(nCameraHandle2);
				errorValue2=GetTemperature(&CCDTemp2);
				sprintf(buffer,"CCD1: %d C\n CCD2: %d C\n", CCDTemp1,CCDTemp2);
				SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,buffer);
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,buffer);
		}
		else
		{
			temp_thread=1;
			SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Temperature Stabilized!\n");
			SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"Temperature Stabilized!\n");
		}
	}
	return 0;
}

//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************





//******************************************************************************************
//******************************************************************************************
//**********************|  CCD control pannel and Callback Function  |**********************
//******************************************************************************************
//******************************************************************************************
int CVICALLBACK CoolerOnOff (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int n, errorValue;
	int current_ccd_temp;
	int i=0;
	char temp[50];
	int camera;
	
	switch (event)
	{
		case EVENT_COMMIT:
			SetCurrentCamera(nCameraHandle1);
			GetCtrlVal(testpanel, test_panel_CoolerOnOff, &n);

			if(n==0)			   //cooler on
			{
				temp_thread=1;	   //stop thread
				SetCtrlAttribute(testpanel, test_panel_ccdTemp,ATTR_DIMMED,0);
				SetCtrlAttribute(testpanel, test_panel_setCooler,ATTR_DIMMED,0);
				errorValu=CoolerON();
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCooler On!\n");
				
				if(errorValue!=DRV_SUCCESS)
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCould not switch cooler On!\n");
			}
			
			else				  //cooler off
			{
				temp_thread=1;	//stop thread
				
				GetTemperature(&current_ccd_temp);
				
				if(current_ccd_temp<0)
				{
					SetTemperature(0); 
					temp_thread=0;
					CmtScheduleThreadPoolFunction(DEFAULT_THREAD_POOL_HANDLE, setTempThread, NULL, &temp_thread_id);
					CmtWaitForThreadPoolFunctionCompletion(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
					CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id);							
				}

				
				SetCtrlAttribute(testpanel, test_panel_ccdTemp,ATTR_DIMMED,1); 
				SetCtrlAttribute(testpanel, test_panel_setCooler,ATTR_DIMMED,0); 
				
				errorValue=CoolerOFF();
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCooler Off!\n");  
				if(errorValue!=DRV_SUCCESS)
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nError Switching Cooler Off!\n");
			}

			break;
	}
	return 0;
}



int CVICALLBACK setCooler (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char ctemp[250];
	int nTemp, n , errorValue;

	switch (event)
	{
		case EVENT_COMMIT:
			SetCurrentCamera(nCameraHandle1);
			SetCtrlVal(testpanel,test_panel_TB_Text_Monitor,"CCD1 Cooling Status\n");
			
			GetCtrlVal(testpanel, test_panel_CoolerOnOff, &n);
			if(n==0)			   //cooler on
			{
				temp_thread=1;
				SetCtrlAttribute(testpanel, test_panel_ccdTemp,ATTR_DIMMED,0);
				errorValue=CoolerON();
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCooler On!\n");
				GetCtrlVal(testpanel, test_panel_ccdTemp, &nTemp);
				sprintf(ctemp,"Cooling Temperature you want is %d\n",nTemp);
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, ctemp);
				
				coolingStatus=SetTemperature(nTemp);

				if(errorValue!=DRV_SUCCESS)
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCould not switch cooler On!\n");
				
				
				//starting thread
				temp_thread=0;
				CmtScheduleThreadPoolFunction(DEFAULT_THREAD_POOL_HANDLE, setTempThread, NULL, &temp_thread_id);
				CmtWaitForThreadPoolFunctionCompletion(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
				CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id);				
			
			}
			else				  //cooler off
			{
				temp_thread=1;
				errorValue=CoolerOFF();
			}			
			break;
	}
	return 0;
}

int CVICALLBACK CoolerOnOff2 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int n, errorValue;
	int current_ccd_temp;
	int i=0;
	char temp[50];
	int camera;
	
	switch (event)
	{
		case EVENT_COMMIT:
			SetCurrentCamera(nCameraHandle2);
			GetCtrlVal(testpanel, test_panel_CoolerOnOff2, &n);

			if(n==0)			   //cooler on
			{
				temp_thread=1;	   //stop thread
				SetCtrlAttribute(testpanel, test_panel_ccdTemp2,ATTR_DIMMED,0);
				SetCtrlAttribute(testpanel, test_panel_setCooler2,ATTR_DIMMED,0);
				errorValue=CoolerON();
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCooler On!\n");
				
				if(errorValue!=DRV_SUCCESS)
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCould not switch cooler On!\n");
			}
			
			else				  //cooler off
			{
				temp_thread=1;	//stop thread
				
				GetTemperature(&current_ccd_temp);
				
				if(current_ccd_temp<0)
				{
					SetTemperature(0); 
					temp_thread=0;
					CmtScheduleThreadPoolFunction(DEFAULT_THREAD_POOL_HANDLE, setTempThread, NULL, &temp_thread_id);
					CmtWaitForThreadPoolFunctionCompletion(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
					CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id);							
				}

				
				SetCtrlAttribute(testpanel, test_panel_ccdTemp2,ATTR_DIMMED,1); 
				SetCtrlAttribute(testpanel, test_panel_setCooler2,ATTR_DIMMED,0); 
				
				errorValue=CoolerOFF();
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCooler Off!\n");  
				if(errorValue!=DRV_SUCCESS)
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nError Switching Cooler Off!\n");
			}

			break;
	}
	return 0;
}

int CVICALLBACK setCooler2 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char temp[10],ctemp[250];
	int nTemp, n , errorValue;

	switch (event)
	{
		case EVENT_COMMIT:
			SetCurrentCamera(nCameraHandle2);
			SetCtrlVal(testpanel,test_panel_TB_Text_Monitor,"CCD2 Cooling Status\n"); 
			
			GetCtrlVal(testpanel, test_panel_CoolerOnOff2, &n);
			if(n==0)			   //cooler on
			{
				temp_thread=1;
				SetCtrlAttribute(testpanel, test_panel_ccdTemp2,ATTR_DIMMED,0);
				errorValue=CoolerON();
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCooler On!\n");
				GetCtrlVal(testpanel, test_panel_ccdTemp2, &nTemp);
				sprintf(ctemp,"Cooling Temperature you want is %d\n",nTemp);
				SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, ctemp);
				coolingStatus=SetTemperature(nTemp);

				if(errorValue!=DRV_SUCCESS)
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor,"\nCould not switch cooler On!\n");
				
				
				//starting thread
				temp_thread=0;
				CmtScheduleThreadPoolFunction(DEFAULT_THREAD_POOL_HANDLE, setTempThread, NULL, &temp_thread_id);
				CmtWaitForThreadPoolFunctionCompletion(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id, OPT_TP_PROCESS_EVENTS_WHILE_WAITING);
				CmtReleaseThreadPoolFunctionID(DEFAULT_THREAD_POOL_HANDLE, temp_thread_id);				
			}
			else				  //cooler off
			{
				temp_thread=1;
				errorValue=CoolerOFF();
			}			
			break;
	}
	return 0;
}
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************





//******************************************************************************************
//******************************************************************************************
//**********************|  Scanner Control Pannel and Callback Function  |******************
//******************************************************************************************
//******************************************************************************************
int CVICALLBACK Ampon_timer (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	extern int g_nAmpOnSeq; 
	
	switch (event)
	{
		
		case EVENT_TIMER_TICK:
			ampon_timer();
			
			if(g_nAmpOnSeq==30)			 //timer off if g_nAmpOnSeq is 30(but already timer off in scanner.c
				SetCtrlAttribute(mainPanel, PANEL_TIMER, ATTR_ENABLED, 0); 
			
			SetCtrlAttribute(testpanel, test_panel_SlitStepDecrease, ATTR_DIMMED, 0);
			SetCtrlAttribute(testpanel, test_panel_SlitStepIncrease, ATTR_DIMMED, 0);
			SetCtrlAttribute(testpanel, test_panel_SetZero, ATTR_DIMMED, 0);
			break;
	}
	return 0;
}



//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************







//******************************************************************************************************************
//******************************************************************************************************************
//*********************************| Setting Panel Callback Function |**********************************************
//******************************************************************************************************************
//******************************************************************************************************************

//if you clicked ok button on setup pannel, this operates
int CVICALLBACK FISS_setOK (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{

	///ccd parameter
	int ccd_Acquisition;
	//int ccd_camera;
	char value[20];
	int ccd_Read, ccd_Trigger, ccd_Shutter, ccd_Fan;
	int ccd_Cooling, ccd_Temp;
	int n;
	int index;		//use setting wavelength to operate grating
	char string[100];
	int current_ccd_temp;
	char temp[100];
	int status,ringvalue;
	
	//making data folder
	char tempdir[150];
	
	struct tm *systime;
	time_t t;

 
	switch (event)
	{
		case EVENT_COMMIT:
			tempdir[0]='\0';
			entire_directory[0]='\0';

			//read each value from ccd tab
			if(CCD_status == 1)
			{
				threadparam=1;
				
				if(g_pRawData!=NULL)
				{
					free(g_pRawData);
					g_pRawData=NULL;
				}
					
				if(g_pRawData2!=NULL)
				{
					free(g_pRawData2);
					g_pRawData2=NULL;
				}				
				
				if(BiasDark1!=NULL)
				{
					free(BiasDark1);
					BiasDark1=NULL;
				}
				if(BiasDark2!=NULL)
				{
					free(BiasDark2);
					BiasDark2=NULL;
				}
				
				if(g_nFrameNumber1>1)
				{
					if(planeDataCCD!=NULL)
					{
						free(planeDataCCD);
						planeDataCCD=NULL;
					}
				}
				
				if(pusFitsData!=NULL)
				{
					free(pusFitsData);
					pusFitsData=NULL;
				}
				
				if(pFitsData!=NULL)
				{
					free(pFitsData);
					pFitsData=NULL;
				}
				
				if(flatdata1)
				{
					free(flatdata1);
					flatdata1=NULL;
				}
				
				if(flatdata2)
				{
					free(flatdata2);
					flatdata2=NULL;
				}
				
				
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle);
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setCamera, &ccd_camera);

				switch(ccd_camera)
				{
					case 0: 
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Set Current Camera 1\n");
							break;
					case 1: 
							SetCurrentCamera(nCameraHandle2);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Set Current Camera 2\n");
							break;
					case 2: 
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Use Both Cameras\n");
							break;
					case 3: 
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Use Both Cameras 2 frame in 1 step\n");
							break;	
					case 4:
							SetCurrentCamera(nCameraHandle1);
							SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Flat Fielding Mode\n");
							break;
					default:
							SetCurrentCamera(nCameraHandle1);
							break;
				}
			
			
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setAcq, &ccd_Acquisition);
			
				switch(ccd_Acquisition)
				{
					case 1:			//single shot mode
						GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setFrameNumber,value);
						g_nFrameNumber1=atoi(value);
						ccd_Trigger = 0;  //0:Internal    
						break;
					case 0:     //   . ׷ acquisition single  1 ٲپ  .
						ccd_Acquisition		=	1;
						//g_nNumberKinetics1	=	0;
						g_nFrameNumber1		=	0;
						ccd_Trigger = 0;
						break;
					case 6:		   //it's not exist acquisition mode 6. It uses Frame Transfer Mode
						GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setFrameNumber,value);
						g_nFrameNumber1=atoi(value);
						ccd_Trigger = 0;  //0:Internal    						
						break;
					case 5:
						GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setFrameNumber,value);
						g_nFrameNumber1=atoi(value);
						ccd_Trigger = 0;  //0:Internal    												
						break;
					default:
						break;
				}			
			
				ccd_Read =  4;   //4:Imaging mode, 1:Full Vertical Binning
				//ccd_Trigger = 0;  //0:Internal
			
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setExpTime, value);
				g_fExpTime1=atof(value);
			
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setGain, value);
				ccd_Gain=atoi(value);
			
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setBinning, &n);   
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setSequence,&sequential_number); 
			
				switch(n)
				{
					case 1: ccd_HBin=1;
							ccd_VBin=1;
							SetCtrlVal(mainPanel, PANEL_info8,"1 x 1");
							break;
					case 2: ccd_HBin=2;		
							ccd_VBin=2;
							SetCtrlVal(mainPanel, PANEL_info8,"2 x 2");
							break;
					case 3: ccd_HBin=4;
							ccd_VBin=4;
							SetCtrlVal(mainPanel, PANEL_info8,"4 x 4");
							break;
					case 4: 
							GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setHBin, value);
							ccd_HBin=atoi(value);
							GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setVBin, value);
							ccd_VBin=atoi(value);
							
							sprintf(value, "%d x %d",ccd_HBin,ccd_VBin);
							SetCtrlVal(mainPanel, PANEL_info8, value);							
							break;
					default:
							break;
				}	
				
				
				
				
	//////////////////////////////////////////			
				t=time(NULL);   
				systime=gmtime(&t);  
				sprintf(tempdir,"%.2d%.2d%.2d",(*systime).tm_year+1900,(*systime).tm_mon+1,(*systime).tm_mday);
			
				strcat(entire_directory,data_directory);
				strcat(entire_directory,tempdir);
				
				makefolderscript(entire_directory);   
				LaunchExecutableEx("makefolder.bat", LE_HIDE, NULL);
///////////////////////////////
				//make data folder
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 3, &TabPanelHandle);         
				GetCtrlVal(TabPanelHandle, setMISC_MISC_TargetRing, &ringvalue);
			
				if(ccd_camera==4)
				{
					strcat(entire_directory,"\\cal");
					makefolderscript(entire_directory);   
					LaunchExecutableEx("makefolder.bat", LE_HIDE, NULL);
					//SetCtrlVal(TabPanelHandle,setMISC_MISC_TargetRing, -1); 
					//SetCtrlAttribute(TabPanelHandle,setMISC_MISC_TargetRing,ATTR_DIMMED,1);
				}
				
				else
				{
					//SetCtrlVal(TabPanelHandle, setMISC_MISC_TargetRing, -1);
					//SetCtrlAttribute(TabPanelHandle,setMISC_MISC_TargetRing,ATTR_DIMMED,0);
					switch(ringvalue)
					{
						case -1:	//none
								break;
						case 0: 	//near disk center
								strcat(entire_directory,"\\raw\\dc");
								break;
						case 1:     //close to or on the limb
								strcat(entire_directory,"\\raw\\limb");
								break;
						case 2:    //quiet region
								strcat(entire_directory,"\\raw\\qr");
								break;
						case 3:    //active region
								strcat(entire_directory,"\\raw\\ar");
								break;	
						case 4:	   //corona hole
								strcat(entire_directory,"\\raw\\ch");
								break;
						case 5:	   //sunspot
								strcat(entire_directory,"\\raw\\sunspot");
								break;
						case 6:	   //filament
								strcat(entire_directory,"\\raw\\fil");
								break;
						case 7:	   //prominence
								strcat(entire_directory,"\\raw\\prom");
								break;		
						case 8:     //user defined object
								GetCtrlVal(TabPanelHandle, setMISC_MISC_Target, temp);		 //read user defined object name
								strcat(entire_directory,"\\raw\\");
								strcat(entire_directory,temp);
								break;
						default:
								break;
					}
				}

				makefolderscript(entire_directory);   
				LaunchExecutableEx("makefolder.bat", LE_HIDE, NULL);
	/////////////////////////////////////////////		
				

				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle); 
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setShutter, &ccd_Shutter);
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setFan, &ccd_Fan);


				if(ccd_camera == 2 || ccd_camera == 3 || ccd_camera==4)				   //both mode
				{
					SetCurrentCamera(nCameraHandle1); 					
					TakeBiasDark(ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, nCameraHandle1,entire_directory);					
					SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, ccd_Shutter, ccd_Fan, g_nFrameNumber1, nCameraHandle1);

					SetCurrentCamera(nCameraHandle2); 					
					TakeBiasDark(ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, nCameraHandle2,entire_directory);					
					SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, ccd_Shutter, ccd_Fan, g_nFrameNumber1, nCameraHandle2);
					
					SetCurrentCamera(nCameraHandle1); 
				}


				else if (ccd_camera==0) 		//ccd1, nCameraHandle1					  //single camera
				{   
					SetCurrentCamera(nCameraHandle1); 
					if(g_nFrameNumber1==0)    //video mode
						SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, ccd_Shutter, ccd_Fan, g_nFrameNumber1,  nCameraHandle1);						
					else		//single, fiss, frame transfer mode
					{
						TakeBiasDark(ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, nCameraHandle1,entire_directory);					
						SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, ccd_Shutter, ccd_Fan, g_nFrameNumber1,  nCameraHandle1);
					}
				}
				
				else if(ccd_camera==1)			//ccd2, nCameraHandle2
				{
					SetCurrentCamera(nCameraHandle2); 
					if(g_nFrameNumber1==0)		//video mode
						SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, ccd_Shutter, ccd_Fan, g_nFrameNumber1,  nCameraHandle2);
					else					   //single, fiss, frame transfer mode
					{
						TakeBiasDark(ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, nCameraHandle2, entire_directory);					
						SetCameraParam(ccd_Acquisition, ccd_Read, ccd_Trigger, ccd_Gain, ccd_HBin, ccd_VBin, g_fExpTime1, ccd_Shutter, ccd_Fan, g_nFrameNumber1,  nCameraHandle2);
					}
				}
				

				
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 1, &TabPanelHandle);    
				SetCtrlVal(TabPanelHandle, setScanTAB_Scan_Step_number,g_nFrameNumber1);
				SetCtrlVal(TabPanelHandle, setScanTAB_Scan_Frames, g_nFrameNumber1);
				
				
				if(ccd_camera==3 || ccd_camera==4)   //2 frames in 1 step
					scan_duration=g_fExpTime1*1000*2+70;//+50;
				else
					scan_duration=g_fExpTime1*1000+70;//+20;

				SetCtrlVal(TabPanelHandle, setScanTAB_Scan_Step_duration,scan_duration);
				
				
				sprintf(value,"%.1f",scan_duration*0.001*g_nFrameNumber1);
				SetCtrlVal(mainPanel, PANEL_info10,value);
				
				
				
				/////
				//display ccd information to main panel
				/////
				//ccd selection
				switch(ccd_camera)
				{
					case 0: 
							SetCtrlVal(mainPanel, PANEL_info6,"CCD 1");
							break;
					case 1: 
							SetCtrlVal(mainPanel, PANEL_info6,"CCD 2");
							break;
					case 2: 
							SetCtrlVal(mainPanel, PANEL_info6,"Both CCDs");
							break;
					case 3: 
							SetCtrlVal(mainPanel, PANEL_info6,"Both CCDs(2CCD in 1 Step)");
							break;	
					case 4:
						    SetCtrlVal(mainPanel, PANEL_info6, "Flat Fielding");
							break;
					default:
							
							break;
				}
				
				//ccd exposure time
				sprintf(value,"%.2f",g_fExpTime1);
				SetCtrlVal(mainPanel, PANEL_info7,value);
				
				//Number of Frame
				sprintf(value,"%d",g_nFrameNumber1);
				SetCtrlVal(mainPanel, PANEL_info4,value);
				
				//Number of Sequence
				//GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setSequence, &nsequence); 
				sprintf(value,"%d",sequential_number);
				SetCtrlVal(mainPanel, PANEL_info5,value);
				
				//sprintf(value,"%f",g_fExpTime1);
				//SetCtrlVal(mainPanel, PANEL_info10,value);
				/////////////////////////////////////////////////
				
				if(ccd_camera==4)
				{
					flatdata1=(float*)malloc(nhDim1*nvDim1*sizeof(float));
					flatdata2=(float*)malloc(nhDim2*nvDim2*sizeof(float));
					flatcube1=(float*)malloc(nhDim1*nvDim1*7*sizeof(float));
					flatcube2=(float*)malloc(nhDim2*nvDim2*7*sizeof(float));
					caldata1=(float*)malloc(nhDim1*nvDim1*sizeof(float));
					caldata2=(float*)malloc(nhDim2*nvDim2*sizeof(float));
				}
			}
			
			
			if(Scanner_status == 1)
			{
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 1, &TabPanelHandle);
				GetCtrlAttribute (TabPanelHandle, setScanTAB_Scan_Mode, ATTR_CTRL_INDEX, &scan_mode);          
				

				if(scan_mode == 0)	  //spectrograph mode
				{
					GetCtrlVal(TabPanelHandle, setScanTAB_Scan_Step_duration, &scan_duration);
					GetCtrlVal(TabPanelHandle, setScanTAB_Scan_Step_size, &scan_size);
					scan_size=scan_size/2;		   // ⿡ ԷµǴ    ݰ Ѵ.!!!
					
					if((CCD_status == 1)&& (g_nFrameNumber1>1))
					{
						ScanCommandWrite(g_nFrameNumber1,scan_duration, scan_size, 0., 0.);	  //make script to operate scanner
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"Spectrograph mode script of Scanner generated\n");
					}
				}
				
				if(scan_mode == 1)	  //imaging mode
				{
					GetCtrlVal(TabPanelHandle, setScanTAB_Scan_speed, &scan_speed);
					GetCtrlVal(TabPanelHandle, setScanTAB_Scan_stroke, &scan_stroke);
					if((CCD_status == 1)&& (g_nFrameNumber1>1))
					{
						ScanCommandWrite(g_nFrameNumber1,0.,0., scan_speed, scan_stroke);		 //make script to operate scanner 
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor,"\nImaging mode script of Scanner generated\n");					
					}
				}													   
				
				sprintf(temp,"Scanner_status is %d\n", Scanner_status);
				SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, temp);

				
				//////////////////////////////////////////////
				///display scanner information to main panel
				//FISS mode
				if(scan_mode==0)	   //spectrograph mode
				{
					SetCtrlVal(mainPanel, PANEL_info1,"Spectrograph");
					//SetCtrlAttribute(mainPanel, PANEL_strScanTime, ATTR_LABEL_TEXT, "1 Step Scantime :"); 
					//SetCtrlAttribute(mainPanel, PANEL_strStepSize, ATTR_LABEL_TEXT, "1 Step Size :");	
					//SetCtrlAttribute(mainPanel, PANEL_unit1, ATTR_LABEL_TEXT, "ms");	
					//SetCtrlAttribute(mainPanel, PANEL_unit2, ATTR_LABEL_TEXT, "um");	  
					
					///step duration
					sprintf(value,"%.1f", scan_duration);
					SetCtrlVal(mainPanel, PANEL_info2,value);					
					
					///step size
					sprintf(value,"%.1f",scan_size*2);
					SetCtrlVal(mainPanel, PANEL_info3,value);
					
					///1 sequence time
					if(g_nFrameNumber1==0)
					{
						//g_nFrameNumber1=1;
						sprintf(value,"%.1f", scan_duration*0.001*1);
						SetCtrlVal(mainPanel, PANEL_info10, value);
					}
					
					///calculate FOV in x-direction
					sprintf(value, "%f",scan_size*2*g_nFrameNumber1*0.08/16);		//FOV=scan_stepsize(um)*framenumber*0.08"/16(um)
					SetCtrlVal(mainPanel, PANEL_info11, value);
				}
			
				if(scan_mode==1)	   //imaging mode
				{
					SetCtrlVal(mainPanel, PANEL_info1,"Imaging");
					//SetCtrlAttribute(mainPanel, PANEL_strScanTime, ATTR_LABEL_TEXT, "Scan Speed :"); 
					//SetCtrlAttribute(mainPanel, PANEL_strStepSize, ATTR_LABEL_TEXT, "Scan Stroke :");
					//SetCtrlAttribute(mainPanel, PANEL_unit1, ATTR_LABEL_TEXT, "um/s");	
					//SetCtrlAttribute(mainPanel, PANEL_unit2, ATTR_LABEL_TEXT, "um");
					
					///scan speed
					sprintf(value, "%.1f",scan_speed);
					SetCtrlVal(mainPanel, PANEL_info2,value);
					
					///scan stroke
					sprintf(value,"%.1f",scan_stroke);
					SetCtrlVal(mainPanel, PANEL_info2,value);
					
					///1 sequence time
					sprintf(value,"%.1f", scan_stroke/scan_speed);
					SetCtrlVal(mainPanel, PANEL_info10,value);
					
					///calculate FOV in x-direction
					sprintf(value,"%d",scan_stroke*0.08/16);
				}
				

				////////////////////////////////////////////////
			}
				

			if(Motor_status == 1)
			{
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 2, &TabPanelHandle);
				GetCtrlIndex(TabPanelHandle, setMotoTAB_Motor_Wavelength, &index);
				CurrentSelect_Wv=index;
				Gratingtracking(2, Data[index].Step);  //move motor at specific wavelength by using absolute position value(2)
				WriteFileF(FP);
				
				///display grating wavelength to main panel
				sprintf(value,"%.2f",Data[index].Wv);
				SetCtrlVal(mainPanel, PANEL_info9,value);				
			}
			
			
			SetCtrlAttribute(mainPanel, PANEL_cmd_Run, ATTR_DIMMED, 0);
			SetCtrlAttribute(mainPanel, PANEL_FISS_cmdStop,  ATTR_DIMMED, 0);
			
			SetMenuBarAttribute(menubar,MENUBAR_Test,ATTR_DIMMED, 0); 
			SetMenuBarAttribute(menubar,MENUBAR_Test_Test,ATTR_DIMMED, 0); 
			
//////////////////////////////////////////

///////////////////////////////////////////			

			HidePanel(FISSpanelSetting);
			break;
	}
	
	return 0;
}


int CVICALLBACK FISS_setCancel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			HidePanel(FISSpanelSetting); 
			break;
	}
	return 0;
}


int CVICALLBACK Scan_Mode (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			
			
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 1, &TabPanelHandle);
				GetCtrlAttribute (TabPanelHandle, setScanTAB_Scan_Mode, ATTR_CTRL_INDEX, &scan_mode);      
			
			
				switch (scan_mode)
				{
					case 0:		   //spectrograph mode
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "Spectrograph mode");
					
						//activate spectrograph mode
						SetCtrlAttribute(TabPanelHandle, setScanTAB_TEXTMSG_1, ATTR_DIMMED, 0);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_duration, ATTR_DIMMED, 0);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_size, ATTR_DIMMED, 0);  
					
						//deactivate step number because it is equal to g_nFrameNumber
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_number, ATTR_DIMMED, 1);

						
						//deactivate imaging mode
						SetCtrlAttribute(TabPanelHandle, setScanTAB_TEXTMSG_2, ATTR_DIMMED, 1);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_speed, ATTR_DIMMED, 1); 
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_stroke, ATTR_DIMMED, 1); 
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Frames, ATTR_DIMMED, 1);
						break;
					case 1:		   //imaging mode
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, "Imaging mode"); 
					
						//deactivate spectrograph mode
						SetCtrlAttribute(TabPanelHandle, setScanTAB_TEXTMSG_1, ATTR_DIMMED, 1);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_duration, ATTR_DIMMED, 1);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_size, ATTR_DIMMED, 1);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Step_number, ATTR_DIMMED, 1);  
					
						//activate imaging mode
						SetCtrlAttribute(TabPanelHandle, setScanTAB_TEXTMSG_2, ATTR_DIMMED, 0);  
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_speed, ATTR_DIMMED, 0); 
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_stroke, ATTR_DIMMED, 0); 
					
						//deactivate camera exposures because it is equal to g_nFrameNumber1
						SetCtrlAttribute(TabPanelHandle, setScanTAB_Scan_Frames, ATTR_DIMMED, 1);
					
						break;
				}				
				////

			break;
	}
	return 0;
}

int CVICALLBACK CCD_setBinning (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int n;
	switch (event)
	{
		case EVENT_COMMIT:
			
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle);
				GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setBinning, &n);
				if (n==4)
				{
					SetCtrlAttribute(TabPanelHandle, setCCDTAB_CCD_setHBin, ATTR_DIMMED, 0);	//Hbin Էâ Ȱȭ
					SetCtrlAttribute(TabPanelHandle, setCCDTAB_CCD_setVBin, ATTR_DIMMED, 0);   //VBin Էâ Ȱȭ
				}
				else
				{
					SetCtrlAttribute(TabPanelHandle, setCCDTAB_CCD_setHBin, ATTR_DIMMED, 1);
					SetCtrlAttribute(TabPanelHandle, setCCDTAB_CCD_setVBin, ATTR_DIMMED, 1);
				}			

			break;
	}
	return 0;
}



//******************************************************************************************************************
//****************************************************************************************************************** 
//******************************************************************************************************************
//******************************************************************************************************************









//******************************************************************************************
//******************************************************************************************
//*************************|  Viewer Pannel and Callback Function  |************************
//******************************************************************************************
//******************************************************************************************

int CVICALLBACK SetSelectFrame (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int frames, axisvalue;
	signed short*	psFitsData;
	int				nStartPoint;
	
	unsigned short	nMinValue, nMaxValue;
	int				i,j,k;
	int				nIndex1, nIndex2;
	char		temp[10];
	int			k1,k2;
	int			viewccd1,viewccd2;

	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(mainPanel, PANEL_set_Select_Frame, &frames);
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);	   //read radio group index(0-based)  
			
			GetCtrlVal(mainPanel, PANEL_viewCCD1,&viewccd1);
			GetCtrlVal(mainPanel, PANEL_viewCCD2,&viewccd2);
			

//			if(planeData)
//			{
//				free(planeData);
//				planeData=NULL;
//			}
			
			if(planeDataCCD)
			{
				free(planeDataCCD);
				planeDataCCD=NULL;
			}
			
			
			if(DataSource ==0 )  	//fits file ͸ о Ѹ 
			{
				Display3DFits(axisvalue, frames, &nMinValue, &nMaxValue);
			}
			
			if(DataSource == 1) 	//CCD  ͸ ȭ鿡 Ѹ 
			{
//				if(ccd_camera!=1)	//ccd1
//				{
//					Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle1);
//				}
//				else  //ccd2
//				{
//					Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle2);
//				}
				
				if(viewccd1==1 && viewccd2==0)  //ccd1
					Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle1); 
				if(viewccd1==0 && viewccd2==1)  //ccd2
					Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle2); 
					
			}
			
			sprintf(temp, "%.2f", mean);
			SetCtrlVal(mainPanel, PANEL_datamean, temp);
			sprintf(temp, "%.2f", stdev);
			SetCtrlVal(mainPanel, PANEL_datastdev, temp);			


			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MIN_VALUE, nMinValue);
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MAX_VALUE, nMaxValue);
			
			if(nMinValue>(int)(mean-3*stdev))
				k1=nMinValue;
			else
				k1=(int)(mean-3*stdev);
			SetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, k1); 	
			
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MIN_VALUE, nMinValue);
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MAX_VALUE, nMaxValue);
			
			if(nMaxValue<(int)(mean+3*stdev))
				k2=nMaxValue;
			else
				k2=(int)(mean+3*stdev);
			SetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, k2);
			break;
	}
	return 0;
}


int CVICALLBACK SetBytsclMin (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int minvalue, maxvalue;
	int axisvalue;
	//int ccd_camera;
	int viewccd1, viewccd2;

	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, &minvalue);
			GetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, &maxvalue);	
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);	   //read radio group index(0-based)  
			GetCtrlVal(mainPanel, PANEL_viewCCD1, &viewccd1);
			GetCtrlVal(mainPanel, PANEL_viewCCD2, &viewccd2);
			
			
			if(DataSource ==0)		//fits file   ȭ鿡 Ѹ 
			{
				if(FitsHeader.nAxis==2)			  	//Fits  Ͱ 2D  
					ByteDisplay(FitsHeader.nAxis1, FitsHeader.nAxis2, pFitsData, minvalue, maxvalue);  

				if(FitsHeader.nAxis==3)				//Fits  Ͱ 3D  
				{
					if(axisvalue == 0)				//X-Y plane
						ByteDisplay(FitsHeader.nAxis1,FitsHeader.nAxis2,pusFitsData,minvalue,maxvalue);
					if(axisvalue == 1)				//Z-Y plane
						ByteDisplay(FitsHeader.nAxis3,FitsHeader.nAxis2,pusFitsData,minvalue,maxvalue); 
				}
			}
			
			if(DataSource ==1)		//CCD  ͸ ȭ鿡 Ѹ 
			{   
				if(g_nFrameNumber1==1)
				{
//					if(ccd_camera!=1)	//ccd1
//						ByteDisplay(nhDim1,nvDim1,g_pRawData,minvalue,maxvalue); 
//					else  //ccd2
//						ByteDisplay(nhDim2,nvDim2,g_pRawData2,minvalue,maxvalue); 
				
					if(viewccd1==1 && viewccd2==0)
						ByteDisplay(nhDim1,nvDim1,g_pRawData,minvalue,maxvalue);
					if(viewccd1==0 && viewccd2==1)
						ByteDisplay(nhDim2,nvDim2,g_pRawData2,minvalue,maxvalue);
				}
				
				if(g_nFrameNumber1>1)
				{
					Radio_GetMarkedOption(mainPanel,PANEL_SelectAxis,&axisvalue);
					
					if(axisvalue == 0)				//X-Y plane
					{
//						if(ccd_camera!=1) //ccd1
//							ByteDisplay(nhDim1,nvDim1,planeDataCCD,minvalue,maxvalue); 
//						else  //ccd2
//							ByteDisplay(nhDim2,nvDim2,planeDataCCD,minvalue,maxvalue);
						
						if(viewccd1==1 && viewccd2==0)
							ByteDisplay(nhDim1,nvDim1,planeDataCCD,minvalue,maxvalue);  
						if(viewccd1==0 && viewccd2==1)
							ByteDisplay(nhDim2,nvDim2,planeDataCCD,minvalue,maxvalue); 
							
					}
					if(axisvalue == 1)				//Z-Y plane
					{
//						if(ccd_camera!=1)	//ccd1  
//							ByteDisplay(g_nFrameNumber1,nvDim1,planeDataCCD,minvalue,maxvalue); 
//						else //ccd2
//							ByteDisplay(g_nFrameNumber1,nvDim2,planeDataCCD,minvalue,maxvalue); 
						if(viewccd1==1 && viewccd2==0)
							ByteDisplay(g_nFrameNumber1,nvDim1,planeDataCCD,minvalue,maxvalue);    
						if(viewccd1==0 && viewccd2==1)
							ByteDisplay(g_nFrameNumber1,nvDim2,planeDataCCD,minvalue,maxvalue); 
					}
				}
			}
			break;
	}
	return 0;
}


int CVICALLBACK SetBytsclMax (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			SetBytsclMin(0, 0, EVENT_COMMIT, NULL, 0, 0);

			break;
	}
	return 0;
}


int CVICALLBACK setFrameAxis (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int axisvalue, frames;
	int i, j, k, nStartPoint, nIndex1, nIndex2;
	signed short* psFitsData;
	unsigned short nMinValue, nMaxValue;
	int	k1,k2;
	char temp[10];
	int  viewccd1,viewccd2;

	
//	Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);	   //read radio group index(0-based)  
//	GetCtrlVal(mainPanel, PANEL_set_Select_Frame, &frames);   
	
//	GetCtrlVal(mainPanel, PANEL_viewCCD1,&viewccd1);
//	GetCtrlVal(mainPanel, PANEL_viewCCD2,&viewccd2);
	
	switch (event)
	{
		case EVENT_COMMIT:
			
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);	   //read radio group index(0-based)  
			GetCtrlVal(mainPanel, PANEL_set_Select_Frame, &frames);   
	
			GetCtrlVal(mainPanel, PANEL_viewCCD1,&viewccd1);
			GetCtrlVal(mainPanel, PANEL_viewCCD2,&viewccd2);			
			

			if(DataSource == 0 ) //fits file о Ѹ 
			{
				if(pusFitsData)
				{
					free(pusFitsData);
					pusFitsData=NULL;
				}				
				
				if(axisvalue == 0)		//X-Y plane
				{
					if(frames>FitsHeader.nAxis3)
						frames=FitsHeader.nAxis3-1;
					
					
					if(FitsHeader.nAxis1<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis1>512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+FitsHeader.nAxis1-512); 
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2>512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+FitsHeader.nAxis2-512);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}					
	
					Display3DFits(axisvalue, frames, &nMinValue, &nMaxValue);	 // ϸ ʿ min, max  .

					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, FitsHeader.nAxis3-1);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, frames);				
				}

				if(axisvalue == 1)				//Z-Y plane
				{
					if(frames>FitsHeader.nAxis1)
						frames=FitsHeader.nAxis1-1;
					
					if(FitsHeader.nAxis3<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis3>512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+FitsHeader.nAxis3-512);
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);						
					}
					
					if(FitsHeader.nAxis2>512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+FitsHeader.nAxis2-512);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);						
					}
					
					Display3DFits(axisvalue, frames, &nMinValue, &nMaxValue);   // ϸ ʿ min, max  . 

					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, FitsHeader.nAxis1-1);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, frames);								
				}
			}
			
			
			
			if(DataSource == 1)	//CCD  о Ѹ 
			{
				if(planeDataCCD)
				{
					free(planeDataCCD);
					planeDataCCD=NULL;
				}				

				if(axisvalue == 0 )		//X-Y plane
				{
					if(frames>g_nFrameNumber1)
						frames=g_nFrameNumber1-1;
					
//					if(ccd_camera!=1) //ccd1
					if(viewccd1==1 && viewccd2==0) //ccd1
					{
						if(nhDim1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(nhDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+nhDim1-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim1-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}


						Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue, nCameraHandle1);						
					}

//					else //ccd2
					if(viewccd1==0 && viewccd2==1)
					{
						if(nhDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);      							
						}
						if(nvDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(nhDim2>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+nhDim2-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim2-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}

						Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue, nCameraHandle2);
					}

					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, g_nFrameNumber1-1);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, frames);								
				}
				
				if(axisvalue == 1)				//Z-Y plane
				{
//					if(ccd_camera!=1)  //ccd1
					if(viewccd1==1 && viewccd2==0)
					{
						if(frames>nhDim1)
							frames=nhDim1-1;
						
						if(g_nFrameNumber1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(g_nFrameNumber1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+g_nFrameNumber1-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim1-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}						

						Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue, nCameraHandle1);   // ϸ ʿ min, max  . 
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, nhDim1-1);
					}
					
//					else  //ccd2
					if(viewccd1==0 && viewccd2==1)
					{
						if(frames>nhDim2)
							frames=nhDim2-1;
						
						if(g_nFrameNumber1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(g_nFrameNumber1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+g_nFrameNumber1-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim2>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim2-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}						

						Display3D_CCD(axisvalue, frames, &nMinValue, &nMaxValue,  nCameraHandle2);   // ϸ ʿ min, max  . 
						SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, nhDim2-1);
					}
					
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, frames);								
				}				
			}
			
			
			sprintf(temp, "%.2f", mean);
			SetCtrlVal(mainPanel, PANEL_datamean, temp);
			sprintf(temp, "%.2f", stdev);
			SetCtrlVal(mainPanel, PANEL_datastdev, temp);						

			//Display3DFits()  min, max  Ϲٿ 
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MIN_VALUE, nMinValue);
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MAX_VALUE, nMaxValue);
			
			if(nMinValue>(int)(mean-3*stdev))
				k1=nMinValue;
			else
				k1=(int)(mean-3*stdev);
			SetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, k1); 	
			
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MIN_VALUE, nMinValue);
			SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MAX_VALUE, nMaxValue);
			
			if(nMaxValue<(int)(mean+3*stdev))
				k2=nMaxValue;
			else
				k2=(int)(mean+3*stdev);
			SetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, k2);

			break;
	}
	return 0;
}




///Picture Window  Լ

int CVICALLBACK pic_window (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int x;
	int y;
	int axis;
	int picTop, picLeft;
	long camera;
	char temp[10];
	unsigned short	nMinValue, nMaxValue;   
	int	k1,k2;
	
	//int onhist, onprofile;  //radio button value
	GetCtrlAttribute(mainPanel,PANEL_PIC_WINDOW,ATTR_TOP,&picTop);  //y-position
	GetCtrlAttribute(mainPanel,PANEL_PIC_WINDOW,ATTR_LEFT,&picLeft); //x-position
	
	switch(event)
	{													  
		case EVENT_MOUSE_POINTER_MOVE:
			//SetMouseCursor(VAL_CROSS_HAIR_CURSOR);

			if (threadparam==0) goto endingline;
			x=eventData2-picLeft;// 147;
			y=eventData1-picTop;//41;

			sprintf(temp,"%d",x);
			SetCtrlVal(mainPanel, PANEL_xpos,temp);
			sprintf(temp,"%d",y);
			SetCtrlVal(mainPanel, PANEL_ypos,temp);
			

			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axis);	   //read radio group index(0-based)
			

			if(DataSource==0)	 //display data come from Fits file
			{
				if( (FitsHeader.nAxis==2) && (axis == 0 ))  //2D, x-y axis
					Display_Line_Profile(x, y, FitsHeader.nAxis1, FitsHeader.nAxis2, pFitsData, 0);				
				if( (FitsHeader.nAxis==3) && (axis == 0 ))  //3D, x-y axis
					Display_Line_Profile(x, y, FitsHeader.nAxis1, FitsHeader.nAxis2, pusFitsData, 0);
				if( (FitsHeader.nAxis==3) && (axis == 1 ))  //3D, z-y axis
				{
					Display_Line_Profile(x, y, FitsHeader.nAxis3, FitsHeader.nAxis2, pusFitsData, 0);
				}
			}
			
			if(DataSource==1)	 //display data come from CCD memory
			{
				if( (g_nFrameNumber1<=1) && (axis == 0 ))  //2D, x-y axis
				{
					if(ccd_camera!=1)		  //ccd1
						Display_Line_Profile(x, y, nhDim1, nvDim1, planeDataCCD, 0);
						//Display_Line_Profile(x, y, nhDim1, nvDim1, g_pRawData, 0);
					else					 //ccd2
						Display_Line_Profile(x, y, nhDim2, nvDim2, planeDataCCD, 0);
						//Display_Line_Profile(x, y, nhDim2, nvDim2, g_pRawData2, 0); 
				}
				
				if( (g_nFrameNumber1>1) && (axis == 0 ))  //3D, x-y axis
				{
					if(ccd_camera!=1)
						Display_Line_Profile(x, y, nhDim1, nvDim1, planeDataCCD, 0);										

					else
						Display_Line_Profile(x, y, nhDim2, nvDim2, planeDataCCD, 0);
				}
				
				if( (g_nFrameNumber1>1) && (axis == 1 ))  //3D, z-y axis
				{
					if(ccd_camera!=1)
						Display_Line_Profile(x, y, g_nFrameNumber1, nvDim1, planeDataCCD, 0);
					
					else
						Display_Line_Profile(x, y, g_nFrameNumber1, nvDim2, planeDataCCD, 0);				
				}
			}
			break;	
			
	case EVENT_LEFT_CLICK:
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axis);	   //read radio group index(0-based)  
			x=eventData2-picLeft;// 147; 

			if(DataSource==0)		 //display from fits file
			{
				if( (FitsHeader.nAxis==3) && (axis == 1 ))  //3D, z-y axis
				{
					
					if(FitsHeader.nAxis1<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis2<=512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);
					}
					
					if(FitsHeader.nAxis1>512)
					{
						SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+FitsHeader.nAxis1-512);
						SetPanelAttribute(mainPanel, ATTR_LEFT,VAL_AUTO_CENTER);						
					}
					
					if(FitsHeader.nAxis2>512)
					{
						SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+FitsHeader.nAxis2-512);
						SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);						
					}										

					Display3DFits(0, x, &nMinValue, &nMaxValue); 
					
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, FitsHeader.nAxis3-1);					
				
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MIN_VALUE, nMinValue);
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MAX_VALUE, nMaxValue);
			
					if(nMinValue>(int)(mean-3*stdev))
						k1=nMinValue;
					else
						k1=(int)(mean-3*stdev);
					SetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, k1); 	
			
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MIN_VALUE, nMinValue);
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MAX_VALUE, nMaxValue);
			
					if(nMaxValue<(int)(mean+3*stdev))
						k2=nMaxValue;
					else
						k2=(int)(mean+3*stdev);
					SetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, k2);
			
					Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);	   //read radio group index(0-based)  
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, x);
				}
								
			}
			if(DataSource==1)		 //display from ccd
			{
				if( (g_nFrameNumber1>1) && (axis == 1 ))  //3D, z-y axis    				
				{
					if(ccd_camera!=1) //camera1
					{
						if(g_nFrameNumber1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(g_nFrameNumber1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+g_nFrameNumber1-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim1-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}						
						
						Display3D_CCD(0, x, &nMinValue, &nMaxValue, nCameraHandle1); 									
					}
					
					else   //ccd2
					{
						if(nhDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim2<=512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}
						if(nhDim2>512)
						{
							SetPanelAttribute(mainPanel, ATTR_WIDTH, panelwidth+nhDim2-512);
							SetPanelAttribute(mainPanel, ATTR_LEFT, VAL_AUTO_CENTER);							
						}
						if(nvDim1>512)
						{
							SetPanelAttribute(mainPanel, ATTR_HEIGHT, panelheight+nvDim2-512);
							SetPanelAttribute(mainPanel, ATTR_TOP, VAL_AUTO_CENTER);							
						}						

						Display3D_CCD(0, x, &nMinValue, &nMaxValue, nCameraHandle2); 
					}
					
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MIN_VALUE, 0);
					SetCtrlAttribute(mainPanel, PANEL_set_Select_Frame, ATTR_MAX_VALUE, g_nFrameNumber1-1);										
					
					
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MIN_VALUE, nMinValue);
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MIN, ATTR_MAX_VALUE, nMaxValue);
			
					if(nMinValue>(int)(mean-3*stdev))
						k1=nMinValue;
					else
						k1=(int)(mean-3*stdev);
					SetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, k1); 	
			
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MIN_VALUE, nMinValue);
					SetCtrlAttribute(mainPanel, PANEL_BYTSCL_MAX, ATTR_MAX_VALUE, nMaxValue);
			
					if(nMaxValue<(int)(mean+3*stdev))
						k2=nMaxValue;
					else
						k2=(int)(mean+3*stdev);
					SetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, k2);
					
					Radio_SetMarkedOption(mainPanel, PANEL_SelectAxis, 0);	   //read radio group index(0-based)  
					SetCtrlVal(mainPanel, PANEL_set_Select_Frame, x); 
				}
			}

			break; 
			
	}
	endingline:
	//SetMouseCursor(VAL_DEFAULT_CURSOR);

	return 0;
}



//******************************************************************************************
//******************************************************************************************
//******************************************************************************************
//******************************************************************************************

 





//******************************************************************************************************************
//******************************************************************************************************************
//********************************Test Panel Callback Functions ****************************************************
//******************************************************************************************************************
//******************************************************************************************************************


// 2. Scanner 
int CVICALLBACK SlitStepDecrease (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char target[50];
	char strSend[30];
	int	 stepsize;
	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel, test_panel_SlitStepSize, &stepsize); 
			stepsize=stepsize*10;
			zerostep+=stepsize;
			sprintf(target,"#1J=%d",zerostep);
			getresponse(target);
			
			break;
	}
	return 0;
}

int CVICALLBACK SlitStepIncrease (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char target[50];
	char strSend[30];
	int  stepsize;

	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel, test_panel_SlitStepSize, &stepsize);
			stepsize=stepsize*10;
			zerostep-=stepsize;
			sprintf(target,"#1J=%d",zerostep);
			getresponse(target);

			break;
	}
	return 0;
}

int CVICALLBACK SetZero (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			zerostep=0;
			getresponse("HMZ");

			break;
	}
	return 0;
}


int CVICALLBACK upload_data (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			UploadQuickGather(1); // '0' for avoiding file saving temporarily______________      
			break;
	}
	return 0;
}






// 3. Grating Motor/ CCD Motor 

int CVICALLBACK Motor_Stop (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	char motor_str[256];
	switch (event)
	{
		case EVENT_COMMIT:
			sprintf(motor_str,"!S:");    
			Write_6KE(motor_str);
			sprintf(motor_str,"MC0000:");  			
			Write_6KE(motor_str);       			

			break;
	}
	return 0;
}

int CVICALLBACK motor_device_select (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel, test_panel_Motor_Device_Select, &SelectMotor);

			break;
	}
	return 0;
}

int CVICALLBACK motor_step_increase (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int motor_step;
		
	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel,test_panel_Motor_Moving_Distance, &motor_step);
			MotorMove(1, motor_step);
			
			break;
	}
	return 0;
}

int CVICALLBACK motor_step_decrease (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int motor_step;
	
	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal(testpanel,test_panel_Motor_Moving_Distance, &motor_step);
			MotorMove(2, motor_step);			

			break;
	}
	return 0;
}





// / κ
int CVICALLBACK WvListBoxF (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int CIndex;
	switch (event)
	{
		case EVENT_LEFT_DOUBLE_CLICK:
			GetCtrlIndex(testpanel, test_panel_WVLISTBOX, &CIndex);
			if(CIndex	!=	-1)
				PrintWvStepAngle(CIndex);
		
			break;
	}
	return 0;
}

int CVICALLBACK InsertBTNF (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			ResetPanel();
			InsertData();
			WriteFileF(FP);
			InitPanel();			

			break;
	}
	return 0;
}

int CVICALLBACK DelBTNF (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		int CIndex;
		case EVENT_COMMIT:
			GetCtrlIndex(testpanel, test_panel_WVLISTBOX, &CIndex);
			DelData();
			WriteFileF(FP);
			ResetPanel();
			InitPanel();
			break;
	}
	return 0;
}




// 4. Scanner, Grating/CCD Motor Command input window 
int CVICALLBACK radio_scan (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:

			SetCtrlVal(testpanel, test_panel_radio_scan,1);
			SetCtrlVal(testpanel, test_panel_radio_motor,0);			
			break;
	}
	return 0;
}

int CVICALLBACK radio_motor (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlVal(testpanel, test_panel_radio_scan,0);
			SetCtrlVal(testpanel, test_panel_radio_motor,1);
			break;
	}
	return 0;
}


int CVICALLBACK STR_Command (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int ch;
	char command[30];
	char cmdline[100];
	static lamp=0;
	int radio_scan, radio_motor;
	
	
	long numchar;
	char motorResponse[1024];
	
	memset(cmdline, 0,sizeof(char)*100);
	
	switch (event)
	{
		//case EVENT_COMMIT:
		//	break;
			
		case EVENT_KEYPRESS:
			ch=GetKeyPressEventVirtualKey(eventData2);
			if(ch==VAL_ENTER_VKEY)
			{
				GetCtrlVal(testpanel, test_panel_radio_scan, &radio_scan);
				GetCtrlVal(testpanel, test_panel_radio_motor,&radio_motor);				
				GetCtrlVal(testpanel, test_panel_STR_Command, command);
				SetCtrlVal(testpanel, test_panel_STR_Command, "");
				
				
				if((radio_scan==1) && (radio_motor==0))		//choose scanner command mode
				{
					strcat(cmdline,"Scanner> ");
					strcat(cmdline, command);
					strcat(cmdline,"\n");
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, cmdline);					
					
					getresponse(command); 
				}
				
				if((radio_scan==0) && (radio_motor==1))		//choose Motor command mode
				{
					strcat(cmdline,"6K_Motor> ");
					strcat(cmdline, command);
					strcat(cmdline,"\n");
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, cmdline);					
					 
					numchar=Write_6KE(command);
					Delay(0.05);
					Read_HS(motorResponse);
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, motorResponse);
					SetCtrlVal(testpanel, test_panel_TB_Text_Monitor, "\n");
				}
			}
			break;
			
	}
	return 0;
}

//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************
//****************************************************************************************************************** 





//******************************************************************************************************************
//******************************************************************************************************************
//********************************Information Panel Callback Functions *********************************************
//******************************************************************************************************************
//******************************************************************************************************************
int CVICALLBACK InfoPanel_proc (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			HidePanel(aboutPanel);

			break;
	}
	return 0;
}
//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************






//******************************************************************************************************************
//******************************************************************************************************************
//*************************************Menu Bar Callback Functions *************************************************
//******************************************************************************************************************
//******************************************************************************************************************

void CVICALLBACK mnuOpen (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	cmdOpen(0,0,EVENT_COMMIT,NULL, 0, 0);
}

void CVICALLBACK mnuSave (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	char Buff[MAX_PATHNAME_LEN];
	int ret;
	int axisvalue, minvalue, maxvalue;
	
	GetCtrlVal(mainPanel, PANEL_BYTSCL_MIN, &minvalue);
	GetCtrlVal(mainPanel, PANEL_BYTSCL_MAX, &maxvalue);	
	Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axisvalue);   

	ret=FileSelectPopup("","*.bmp","*.fts;*.bmp;*.fit;*.fits","Save As BMP File",VAL_SAVE_BUTTON,0,0,1,0,Buff);
	if(ret>0)
	{
		if(DataSource==0) //from fits file
		{
			if(FitsHeader.nAxis==2)					//2d data
			{
				SaveBitmap(FitsHeader.nAxis1,FitsHeader.nAxis2,pFitsData, Buff, minvalue, maxvalue);
			}
			if(FitsHeader.nAxis==3 && axisvalue==0) //3d data and x-y plane
			{
				SaveBitmap(FitsHeader.nAxis1,FitsHeader.nAxis2,pusFitsData, Buff, minvalue, maxvalue);
			}
			if(FitsHeader.nAxis==3 && axisvalue==1) //3d data and z-y plane
			{
				SaveBitmap(FitsHeader.nAxis3,FitsHeader.nAxis2,pusFitsData, Buff, minvalue, maxvalue);
			}
		}
		else	//from CCD data
		{
			if(g_nFrameNumber1<=1)					//2d data
			{
				SaveBitmap(nhDim, nvDim, planeDataCCD, Buff, minvalue, maxvalue);
			}
			if(g_nFrameNumber1>1 && axisvalue==0)	//3d data and x-y plane
			{
				SaveBitmap(nhDim, nvDim, planeDataCCD, Buff, minvalue, maxvalue);
			}
			if(g_nFrameNumber1>1 && axisvalue==1)
			{
				SaveBitmap(g_nFrameNumber1, nvDim, planeDataCCD, Buff, minvalue, maxvalue);
			}
		}
	}

	
}

void CVICALLBACK mnuExit (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	QuitCallback (0, 0, EVENT_COMMIT, NULL, 0, 0);
}

void CVICALLBACK mnuSetup (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	Set_FISS_parameter(0,0,EVENT_COMMIT,NULL,0,0);
	SetMenuBarAttribute(menubar,MENUBAR_Test,ATTR_DIMMED, 0); 
	SetMenuBarAttribute(menubar,MENUBAR_About,ATTR_DIMMED, 0); 
	SetMenuBarAttribute(menubar,MENUBAR_About_About,ATTR_DIMMED, 0);  
}

void CVICALLBACK mnuTest (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	Obs_Test(0,0,EVENT_COMMIT,NULL,0,0);
}

void CVICALLBACK mnuAbout (int menuBar, int menuItem, void *callbackData,
		int panel)
{
	char InfoArray[4096];   
	DisplayPanel(aboutPanel);
	SetCurrentCamera(nCameraHandle1);
	GetCameraInfo(InfoArray);
	SetCtrlVal(aboutPanel, InfoPanel_textBox, "============CCD1===========\n");
	SetCtrlVal(aboutPanel, InfoPanel_textBox, InfoArray);
	SetCurrentCamera(nCameraHandle2);
	GetCameraInfo(InfoArray);
	SetCtrlVal(aboutPanel, InfoPanel_textBox, "============CCD2===========\n");
	SetCtrlVal(aboutPanel, InfoPanel_textBox, InfoArray);

	//SetCtrlVal(aboutPanel, InfoPanel_textBox, "umhahahahah\n");
}

//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************
//******************************************************************************************************************



int CVICALLBACK drawHistogram (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int hist_array[100];
	double xarray[100];
	double* hist_data;
	unsigned short* imsi;

	int i;	
	int axis;	//the parameter which read select axis(X-Y or Z-Y)
				//-1 means we can think default data is 2 D.
	
	unsigned short minvalue, maxvalue;
	int length;

	switch (event)
	{
		case EVENT_LEFT_CLICK:

//			GetCtrlVal(mainPanel, PANEL_SelectAxis, &axis); //if undimming, it read axis either 4 or 5. 
//															//otherwise axis=0
			Radio_GetMarkedOption(mainPanel, PANEL_SelectAxis, &axis);   

			if(DataSource==0)	//Reading Fits File
			{
				if( (FitsHeader.nAxis==2) && (axis==0))  //2D data, X-Y plane
				{
					length=FitsHeader.nAxis1*FitsHeader.nAxis2;
					hist_data=malloc(length*sizeof(double));
					GetMinMax(pFitsData, length, &minvalue, &maxvalue);
					imsi=(unsigned short*)pFitsData;
					for(i=0;i<length;i++) hist_data[i]=imsi[i];
				}				

				if( (FitsHeader.nAxis==3) &&  (axis == 0)) //3D data, X-Y plane
				{
					length=FitsHeader.nAxis1*FitsHeader.nAxis2;
					hist_data=malloc(length*sizeof(double));
					GetMinMax(pusFitsData, length, &minvalue, &maxvalue);
					for (i=0;i<length;i++) hist_data[i]=pusFitsData[i];					
				}
				
				if( (FitsHeader.nAxis==3) && (axis == 1)) //3D data, Z-Y plane
				{
					length=FitsHeader.nAxis3*FitsHeader.nAxis2;
					hist_data=malloc(length*sizeof(double)); 
					GetMinMax(pusFitsData, length, &minvalue, &maxvalue);
					for (i=0;i<length;i++) hist_data[i]=pusFitsData[i];					
				}

				//GetMinMax(pusFitsData, length, &minvalue, &maxvalue);
				//for (i=0;i<length;i++) hist_data[i]=pusFitsData[i];
			}
				
			
			
			if(DataSource==1) //reading CCD memory
			{
				GetCurrentCamera(&nUnknownCameraHandle);
				if( (g_nFrameNumber1<=1) && (axis == 0 ) )//2D data, X-Y plane
				{
					if(nUnknownCameraHandle==nCameraHandle1)
						length=nhDim1*nvDim1;
					if(nUnknownCameraHandle==nCameraHandle2)
						length=nhDim2*nvDim2;
					
					hist_data=malloc(length*sizeof(double));
				}				
				if( (g_nFrameNumber1>1) && (axis == 0 ) )//3D data, X-Y plane
				{
					if(nUnknownCameraHandle==nCameraHandle1)
						length=nhDim1*nvDim1;
					if(nUnknownCameraHandle==nCameraHandle2)
						length=nhDim2*nvDim2;					
					
					hist_data=malloc(length*sizeof(double));
				}
				
				if( (g_nFrameNumber1>1) && (axis == 1)) //3D data, Z-Y plane
				{
					if(nUnknownCameraHandle==nCameraHandle1)
						length=g_nFrameNumber1*nvDim1;
					if(nUnknownCameraHandle==nCameraHandle2)
						length=g_nFrameNumber1*nvDim2;					
					
					hist_data=malloc(length*sizeof(double));
				}				

				GetMinMax(planeDataCCD, length, &minvalue, &maxvalue);
				for (i=0;i<length;i++) hist_data[i]=planeDataCCD[i];
			}

			
			Histogram(hist_data, length, minvalue, maxvalue, hist_array, xarray, 100);							
			if(plotHandle)
				DeleteGraphPlot(mainPanel, PANEL_GRAPH, plotHandle, VAL_IMMEDIATE_DRAW);
			plotHandle=PlotXY(mainPanel, PANEL_GRAPH, xarray, hist_array, 100, VAL_DOUBLE, VAL_INTEGER, VAL_VERTICAL_BAR, VAL_EMPTY_SQUARE, VAL_SOLID, 1, VAL_BLUE);
			
			free(hist_data);
			break;
	}
	return 0;
}


int CVICALLBACK viewCCD1 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlVal(mainPanel, PANEL_viewCCD1,1);
			SetCtrlVal(mainPanel, PANEL_viewCCD2,0);	
			DisplayCCDImage(nhDim1, nvDim1, g_nFrameNumber1, nCameraHandle1);

			break;
	}
	return 0;
}

int CVICALLBACK viewCCD2 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			SetCtrlVal(mainPanel, PANEL_viewCCD1,0);
			SetCtrlVal(mainPanel, PANEL_viewCCD2,1);					
			DisplayCCDImage(nhDim2, nvDim2, g_nFrameNumber1, nCameraHandle2);   
			break;
	}
	return 0;
}

int CVICALLBACK make_foldert_arget (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int value;
	switch (event)
	{
		case EVENT_COMMIT:

			GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 3, &TabPanelHandle);         
			GetCtrlVal(TabPanelHandle, setMISC_MISC_TargetRing, &value);			
			
			if(value==8)
				SetCtrlAttribute(TabPanelHandle,setMISC_MISC_Target,ATTR_DIMMED,0);
			else
				SetCtrlAttribute(TabPanelHandle,setMISC_MISC_Target,ATTR_DIMMED,1);
			
			if(value==3)
				SetCtrlAttribute(TabPanelHandle,setMISC_MISC_ARNumber,ATTR_DIMMED,0);
			else
				SetCtrlAttribute(TabPanelHandle,setMISC_MISC_ARNumber,ATTR_DIMMED,1);
			

			break;
	}
	return 0;
}

int CVICALLBACK CCD_setCamera (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int tabpanel;
	switch (event)
	{
		case EVENT_COMMIT:
			GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 0, &TabPanelHandle);
			GetCtrlVal(TabPanelHandle, setCCDTAB_CCD_setCamera, &ccd_camera);			
			
			
			
			if(ccd_camera== 4) //flat fielding mode
			{
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 3, &tabpanel);         
				SetCtrlVal(tabpanel,setMISC_MISC_TargetRing, -1); 
				SetCtrlAttribute(tabpanel,setMISC_MISC_TargetRing,ATTR_DIMMED,1);		
			}
			else
			{
				GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 3, &tabpanel);         				
				//SetCtrlVal(tabpanel,setMISC_MISC_TargetRing, -1); 
				SetCtrlAttribute(tabpanel,setMISC_MISC_TargetRing,ATTR_DIMMED,0);						
			}

			break;
	}
	return 0;
}
