#include <utility.h>
#include <ansi_c.h>
#include "grating_focus.h"
#include "DLL6K.h"  
#include "FISS.h" 

extern int mainPanel;
extern int TabPanelHandle;
extern int FISSpanelSetting; 
extern int testpanel;



char motor_str[256];  
short M_Open_status, M_Init_status;			 //uses those in MotorConnect(),MotorDisconnect();
float DelayTime = 0.05;


/////////////////
int SelectMotor=0;
int MotorPos1E, MotorPos1E_Pre; 
						// use only InitWvRing()




int GratingLimitCurrentState[2];

//=========================================================================================
//define parameter to read/write wv.ini file

FILE* FP;
int CurrentSelectWV_FileIO;
int StartPosition_FileIO;
int nWV_FileIO;

WvSet Data[50];
float stoa=182.041667;//step to angle

//=========================================================================================

/////////////////
int Motor_status=-1;	//-1:not operate, 1:turn on, 2:turn off
///////////////






//ArpSetF is called by Connect6KE function. 
//This function sets the IP-Mac matching & returns the 6K IP address for calls the Open6KE functions in DLL6K.
char * ArpSetF(void)
{
	char m_str6KMac[32];
	char m_strMyIP[32];
	char * m_str6KIP;
	char m_strPrint[128];
	FILE*	pFile;

	m_str6KIP=(char*)malloc(32);
    
	pFile=fopen("IPaddr.ini", "rb");
	if(pFile==NULL)
	{
		MessagePopup("Error","IPaddr.ini file is not exist.\n Please Set the IP address and Mac address.");
		fclose(pFile);
	}
	else 
	{
		char buff[32];
		fscanf(pFile, "%s\n",buff);
		strcpy(m_str6KIP,buff);
		fscanf(pFile, "%s\n",buff);
		strcpy(m_str6KMac,buff);
		fscanf(pFile, "%s\n",buff);
		strcpy(m_strMyIP,buff);
		fclose(pFile);

		///
		pFile=fopen("IPaddr.bat", "wb");
		fprintf(pFile, "arp -s %s %s %s",m_str6KIP,m_str6KMac, m_strMyIP);
		fclose(pFile);
		LaunchExecutableEx("IPaddr.bat", LE_HIDE, NULL);
		Delay(DelayTime);		
	}
	return m_str6KIP;
}


int DriveEnable(void)			 //subroutine of MotorConnect();
{
	char strCmd[250];

	sprintf(strCmd,"DRIVE1111:");
	Write_6KE(strCmd);
	Delay(DelayTime);
	return 1;	

}



int DriveDisable(void)
{
	char strCmd[250];

	sprintf(strCmd,"DRIVE0000:");
	Write_6KE(strCmd);
	Delay(DelayTime);
	return 1;
}




int InitMotor(void)				  //subroutine of MotorConnect
{
	char str[250];

	sprintf(str,"SETUP:");  
	Write_6KE(str);
	Delay(DelayTime*20);
	
	
	sprintf(str,"HOMING:");
	Write_6KE(str);
	Delay(5);
 
	
	sprintf(str, "PSET0,0,0,0:");
	Write_6KE(str);
	sprintf(str, "PESET0,0,0,0:");
	Write_6KE(str);
	MotorPos1E=0;
	MotorPos1E_Pre=0;	
	SelectMotor =1;
	//Gratingtracking(2, Wv1[CurrentSelect_Wv].Step);		  //this line move from this to FISS_SetOK() on FISS.c
	return 1;
}




int MotorConnect(void)
{
	char strCmd[250];  
	char * strIP;
	
	strIP=ArpSetF();
	M_Open_status= Open_6KE(strIP); 
			
			
	if(M_Open_status)
			{
				sprintf(motor_str,"\n------------Connected------------\n"); 
				SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, motor_str);
			
				M_Init_status = Initialize_6KE(); 
			
				if(M_Init_status)
				{
						sprintf(motor_str,"Initialized  \n"); 
						SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, motor_str);
				}	
				

				DriveEnable();  
				InitWvRing();			  //read wavelength, step information from Wv.ini file
				InitMotor(); 			  //move grating to home positon
				SlitHatchOpen();
				
//				LimitIndicate(1);
//				SetCtrlAttribute(mainPanel, PANEL_CCD1ONOFF, ATTR_ON_COLOR,VAL_RED); 
//				SetCtrlVal(mainPanel, PANEL_CCD1ONOFF, 1);
//				SetCtrlAttribute(mainPanel, PANEL_GRATINGONOFF, ATTR_ON_COLOR,VAL_RED);  
//				SetCtrlVal(mainPanel, PANEL_GRATINGONOFF, 1);
//				SetCtrlAttribute(mainPanel, PANEL_CCD2ONOFF, ATTR_ON_COLOR,VAL_RED); 
//				SetCtrlVal(mainPanel, PANEL_CCD2ONOFF, 1);

				////unDimming
//				SetCtrlAttribute(mainPanel, PANEL_CCD1ONOFF,			ATTR_DIMMED, 	0);
//				SetCtrlAttribute(mainPanel, PANEL_GRATINGONOFF, 		ATTR_DIMMED,	0);
//				SetCtrlAttribute(mainPanel, PANEL_CCD2ONOFF, 			ATTR_DIMMED, 	0);  
//				SetCtrlAttribute(mainPanel, PANEL_MotorStepDecrease ,	ATTR_DIMMED, 	0);   
//				SetCtrlAttribute(mainPanel, PANEL_MotorStop , 			ATTR_DIMMED, 	0); 
//				SetCtrlAttribute(mainPanel, PANEL_MotorStepIncrease , 	ATTR_DIMMED, 	0); 
//				SetCtrlAttribute(mainPanel, PANEL_MOTORSTEP_NRING , 	ATTR_DIMMED, 	0);  
//				SetCtrlAttribute(mainPanel, PANEL_MOTORPOS1_E   , 		ATTR_DIMMED, 	0);   
//				SetCtrlAttribute(mainPanel, PANEL_RING_WV ,				ATTR_DIMMED, 	0);   
//				SetCtrlAttribute(mainPanel, PANEL_TRACKINGONOFF , 		ATTR_DIMMED, 	0);   
//				SetCtrlAttribute(mainPanel, PANEL_UPLIMITINDICATOR , 	ATTR_DIMMED, 	0); 
//				SetCtrlAttribute(mainPanel, PANEL_DNLIMITINDICATOR , 	ATTR_DIMMED, 	0); 

			}
	else return 0;
			return 1;
}

int MotorDisconnect(void)
{
	int closestatus;  
	if(!M_Open_status)return 0;
			//motor smoothed landing.	
			
			SlitHatchClose();
	
			sprintf(motor_str,"!S:");    
			Write_6KE(motor_str);
			Gratingtracking(1, -50000);
			
			DriveDisable();
			closestatus=Close_6KE();
		
			if(closestatus)
			{
				sprintf(motor_str,"-----------Disconnected-----------\n"); 
				SetCtrlVal(mainPanel, PANEL_TB_Text_Monitor, motor_str);  
				M_Open_status=0;
				M_Init_status=0; 
			}
	return 1;
}



int Gratingtracking(int Mode, int MovingDistance)						//using this function into FISS_SetOK()
{
	int ErrDistance;
	char strCmd[250];
	char strResponse[1024];
	int CurrentState1;
	int RefEncoderPos;
	char str[250];
	char printMessage[1024];

	switch(Mode)
	{
		case 1:
			RefEncoderPos=MotorPos1E_Pre+MovingDistance;
			break;
		case 2:
			RefEncoderPos=MovingDistance;
			break;
	}
	
	LimitIndicate(1); 	//limitindicate Ȯؼ gratinglimitcurrentstate ش. 
						//1: Grating control, allocate two value to GratingLimitCurrentState[2] & Position Check
	do{	
			ErrDistance=RefEncoderPos-MotorPos1E; 
			
			if(		(GratingLimitCurrentState[0] && (ErrDistance>0))	||	(GratingLimitCurrentState[1] && (ErrDistance<0))		)  break;   
						   //High Limit value//								  //Low Limit Value//
			if((ErrDistance < 1)&&(ErrDistance > -1)) break;
			
			sprintf(str,"1D%d:",ErrDistance); 	
			Write_6KE(str); 
			sprintf(str,"1GO:"); 				
			Write_6KE(str);

			//delay time variation  //
			//̰ ؼ Ÿ  delaytimeȭ ־Ѵ.
			while(MotorMovingCheck()) Delay(DelayTime);

			
			LimitIndicate(1);  
	}while(0);			
	
	MotorPos1E_Pre=MotorPos1E; 
	return 1;	
	
}


int LimitIndicate(int SelectedMotor)
{
	
	char strCmd[250];
	char strResponse[1024];
	int CurrentState1_LowLimit, CurrentState2_LowLimit, CurrentState3_LowLimit,CurrentState4_LowLimit;
	int CurrentState1_HiLimit, CurrentState2_HiLimit, CurrentState3_HiLimit,CurrentState4_HiLimit; 
	int CurrentState_Axis1, CurrentState_Axis2, CurrentState_Axis3, CurrentState_Axis4; 	

	char TPEStr[12];
	int i_previous,i,j;
	
	
	CurrentState1_LowLimit	=	CurrentState2_LowLimit	=	CurrentState3_LowLimit	=	CurrentState4_LowLimit	=	0;
	CurrentState1_HiLimit	=	CurrentState2_HiLimit	=	CurrentState3_HiLimit	=	CurrentState4_HiLimit	=	0; 
	
	switch(SelectedMotor){
		case 1: {
					sprintf(strCmd,"!1TAS:");
					Write_6KE(strCmd);
					Delay(DelayTime);
					Read_HS(strResponse);
					CurrentState_Axis1=(int)strResponse[15]-48;
					CurrentState1_HiLimit=(int)strResponse[17]-48; 
					CurrentState1_LowLimit=(int)strResponse[18]-48;
					break;
					
				}
  		case 2: {
					sprintf(strCmd,"!2TAS:");
					Write_6KE(strCmd);
					Delay(DelayTime);
					Read_HS(strResponse);
					CurrentState_Axis2=(int)strResponse[15]-48;
					CurrentState2_HiLimit=(int)strResponse[17]-48;
					CurrentState2_LowLimit=(int)strResponse[18]-48;
					break;
				}
		
		case 3: {
					sprintf(strCmd,"!3TAS:");
					Write_6KE(strCmd);
					Delay(DelayTime);
					Read_HS(strResponse);
					CurrentState_Axis3=(int)strResponse[15]-48;   //13bit <- Axis lock/unlock statement 0000_0000_0000_1000_0000 : Like this. so 13bit have 15field position
					CurrentState3_HiLimit=(int)strResponse[17]-48;   //15bit <-Positiove Hardware Limit Hit 
					CurrentState3_LowLimit=(int)strResponse[18]-48;  //16bit <Negative Hardware Limit Hit
					break;
				}
		case 4: {
					sprintf(strCmd,"!4TAS:");
					Write_6KE(strCmd);
					Delay(DelayTime);
					Read_HS(strResponse);
					CurrentState_Axis4=(int)strResponse[15]-48;   //13bit <- Axis lock/unlock statement 0000_0000_0000_1000_0000 : Like this. so 13bit have 15field position
					CurrentState4_HiLimit=(int)strResponse[17]-48;   //15bit <-Positiove Hardware Limit Hit 
					CurrentState4_LowLimit=(int)strResponse[18]-48;  //16bit <Negative Hardware Limit Hit
					break;
				}
					
	}//End of switch statement	

	
 	//gratingƮŷ ϱ    
	GratingLimitCurrentState[1]=CurrentState1_LowLimit; 
	GratingLimitCurrentState[0]=CurrentState1_HiLimit; 

	GratingMotorPosCheck();  		 //show Motor Position

	return 1;
}
 





//read motor position information from Wv.ini and insert those values into listbox
int InitWvRing(void)				//subroutine of MotorConnect()
{
//////////////////////////////////////////////////////////////////////////////////////////////////////
//    int i;
//	char WvHeader[1000];
//	char strCard[100];
//	FILE * FP2;
//	char str[20];
//	FP2=fopen("Wv.ini","rb");
//	if(FP2==NULL){
//		MessagePopup("Error", "Cannot open file Wv.ini.");
//		fclose(FP2);
//		return 0;
//	}
//	fread(WvHeader,sizeof(char),1000,FP2);
//	for(i=0;i<10;i++){
//		strncpy(strCard, WvHeader+100*i,100);
//		if(strncmp(strCard,		 "NUMBER OF WV    =", 17)==0)sscanf(strCard+17,		"%d",		&nWV);
//		else if(strncmp(strCard, "CURRENT_SELECT  =", 17)==0)sscanf(strCard+17,		"%d",		&CurrentSelect_Wv);
//	}
//	fread(Wv1, sizeof(WvSet), nWV, FP2);
//	fclose(FP2);
//	GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 2, &TabPanelHandle);
//	DeleteListItem(TabPanelHandle, setMotoTAB_Motor_Wavelength, 0, -1);
//	for(i=0;	 i<nWV;	 	i++){
//		sprintf(str, "%f", Wv1[i].Wv);
//		InsertListItem(TabPanelHandle, setMotoTAB_Motor_Wavelength, -1,str, i);
//	}
//	SetCtrlAttribute(TabPanelHandle, setMotoTAB_Motor_Wavelength, ATTR_DFLT_INDEX, CurrentSelect_Wv);
//	return 1;
/////////////////////////////////////////////////////////////////////////////////////////////////////////
	int i,line_no;

	char buff[100];
	char str[20];

	
	OpenFileF(FP);
	ResetPanel();
	InitPanel();

	
	return 1;
}


int MotorMovingCheck(void){
	char strCmd[250];
	char strResponse[1024];	

	sprintf(strCmd,"!1TAS.1:");
	Write_6KE(strCmd);
	Delay(DelayTime); 
	Read_HS(strResponse);
	
	
	switch(strResponse[0]){
		case '1' : 	return 1; 
					break;
		case '0' : 	return 0;
					break;

	}
	return 1;
	
	
}


int MotorMove(int MotorIncDec, int MotorStep){
	
	//MotorIncDec=1 : increasing step.  MotorIncDec=2:Decreasing step.		
	switch(MotorIncDec){
		case 1:	
			sprintf(motor_str,"!S:");    
			Write_6KE(motor_str);			  
		    
 
			if(SelectMotor ==1)Gratingtracking(1, MotorStep);
			else if(SelectMotor ==2)
			{
				sprintf(motor_str,"2D%d :",MotorStep); 	
				Write_6KE(motor_str); 
				sprintf(motor_str,"2GO:"); 				
				Write_6KE(motor_str);
			}
			else if(SelectMotor ==3)
			{
				sprintf(motor_str,"3D%d :", MotorStep); 	
				Write_6KE(motor_str); 
				sprintf(motor_str,"3GO:"); 				
				Write_6KE(motor_str);
			}
			else if(SelectMotor ==4)
			{
				sprintf(motor_str,"4D%d :", MotorStep); 	
				Write_6KE(motor_str); 
				sprintf(motor_str,"4GO:"); 				
				Write_6KE(motor_str);
			}			
			
			LimitIndicate(SelectMotor);
			break;
		
		case 2:
			sprintf(motor_str,"!S:");    
			Write_6KE(motor_str);			  

			if(SelectMotor ==1)Gratingtracking(1, -MotorStep);
			else if(SelectMotor ==2)
			{
				
				sprintf(motor_str,"2D-%d :",MotorStep); 	
				Write_6KE(motor_str); 
				sprintf(motor_str,"2GO:"); 				
				Write_6KE(motor_str);
			}
			else if(SelectMotor ==3)
			{
				sprintf(motor_str,"3D-%d :",MotorStep); 	
				Write_6KE(motor_str); 
				sprintf(motor_str,"3GO:"); 				
				Write_6KE(motor_str);
			}
			else if(SelectMotor ==4)
			{
				sprintf(motor_str,"4D-%d :",MotorStep); 	
				Write_6KE(motor_str); 
				sprintf(motor_str,"4GO:"); 				
				Write_6KE(motor_str);
			}			
			
			LimitIndicate(SelectMotor);  
		    break;
	}//end of switch statement
	return 1;
}



int GratingMotorPosCheck(void)
{
	
	char strCmd[250];
	char strResponse[1024];
	int CurrentState1;
	char TPEStr[12];
	int i_previous,i,j;	

	//encodervalue
	sprintf(strCmd,"!1TPE:");
	Write_6KE(strCmd);
	Delay(DelayTime);
	Read_HS(strResponse);


		//[+522231456827,+284757,-287328,-245]. All data contain like this.
		for(i=0;i<11;i++)if(strResponse[i] == '\n')break;
		
		strncpy(TPEStr,&strResponse[0],i);
		TPEStr[i]=NULL;
		SetCtrlVal(testpanel, test_panel_Motor_Position, TPEStr);   
		sscanf(TPEStr, "%d", &MotorPos1E);
		
	return 1;
}





///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////FILE I/O, Make Wavelength List///////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////






////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///start from FIO.c
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int OpenFileF(FILE * FP)
{

	
	char str[20];
	//nRow returns number of saved wavelength;
	FP=fopen("Wv.ini","rb");
	if(FP==NULL){
		MessagePopup("Error", "Cannot open file Wv.ini");
		fclose(FP);
		return 0;
	}
	else{
		if(ReadHeader(FP))fread(Data, sizeof(WvSet), nWV_FileIO, FP);
		
		return 1;
	}

}



int ReadHeader(FILE * FP)
{
	int i;
	char WvHeader[2000];
	char strCard[100];
	fread(WvHeader,sizeof(char),2000,FP);
	for(i=0;i<10;i++)
	{
		strncpy(strCard, WvHeader+100*i,100);
		if(strncmp(strCard,		 "NUMBER OF WV    =", 17)==0)sscanf(strCard+17,		"%d",		&nWV_FileIO);
		else if(strncmp(strCard, "CURRENT_SELECT  =", 17)==0)sscanf(strCard+17,		"%d",		&CurrentSelectWV_FileIO);
//		else if(strncmp(strCard, "STARTING POS    =", 17)==0)sscanf(strCard+17,		"%d",		&HalphaStep);
	}

	return 1;
}



int WriteFileF(FILE * FP)
{
/////////////////////////////////////////////////////	
//	if(FP)fclose(FP);
//	FP=fopen("Wv.ini","wb");
//	if(FP==NULL)
//	{
//		MessagePopup("Error", "Cannot open file Wv.ini");
//		fclose(FP);
//		return 0;
//	}
//	else
//	{
//		if(WriteHeader(FP))fwrite(Data,sizeof(WvSet), nWV_FileIO, FP);
//		fclose(FP);
//		return 1;
//	}
/////////////////////////////////////////////////////
	int i;
	if(FP) fclose(FP);
	
	if(NULL==(FP=fopen("Wv.ini","w")))
	{
		MessagePopup("info","Fail to write file\n");
		fclose(FP);
		return 0;
	}
	else
	{
//		MessagePopup("Success","File open to write\n");
		fprintf(FP,  "NUMBER OF WV    = %d\r\n", nWV_FileIO);
		fprintf(FP,  "CURRENT_SELECT  = %d\r\n", CurrentSelectWV_FileIO); 
		fprintf(FP,  "STARTING POS    = %d\r\n", StartPosition_FileIO); 
		fputs("                     \r\n",FP);
		fputs("No  Wave     Pos   Angle\r\n",FP);
		
		for(i=0;i<nWV_FileIO;i++)
		{
			fprintf(FP,"%2d  %.2f  %d  %.2f\r\n", i+1, Data[i].Wv, Data[i].Step, Data[i].Angle);
		}
		
		fclose(FP);
		return 1;
	}	
}



int WriteHeader(FILE * FP)
{
//	char WvHeader[1000];
//	sprintf(&WvHeader[0],   "NUMBER OF WV    = %d", nWV_FileIO);
//	sprintf(&WvHeader[100], "CURRENT_SELECT  = %d", CurrentSelectWV_FileIO);
//	sprintf(&WvHeader[200], "STARTING POS    = %d", StartPosition_FileIO);
//	//writing Header
//	fwrite(WvHeader, sizeof(char), 1000, FP);
	
	return 1;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///finish from FIO.c
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///start from WVOper.c
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int ResetPanel(void){

	GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 2, &TabPanelHandle);
	DeleteListItem(TabPanelHandle, setMotoTAB_Motor_Wavelength, 0, -1);
	return 1;
}


int InitPanel(void){
	int i;
	char str[20];
	GetPanelHandleFromTabPage(FISSpanelSetting, SetFISS_setTAB, 2, &TabPanelHandle);   
	
	for(i=0;	 i<nWV_FileIO;	 	i++)
	{
		sprintf(str, "%f", Data[i].Wv);
		InsertListItem(TabPanelHandle, setMotoTAB_Motor_Wavelength, -1,str, i);
	}
	SetCtrlAttribute(TabPanelHandle, setMotoTAB_Motor_Wavelength, ATTR_DFLT_INDEX, CurrentSelectWV_FileIO);

	DefaultCtrl(TabPanelHandle, setMotoTAB_Motor_Wavelength);

	
	return 1;
}







////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///finish from WVOper.c
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
///SLIT HATCH OPERATION
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


int SlitHatchOpen(){
	char strCmd[256];
	
	sprintf(strCmd,"OUT0010:");
	Write_6KE(strCmd);
	Delay(DelayTime);
    return 1;
}
int SlitHatchClose(){
	char strCmd[256];
	
	sprintf(strCmd,"OUT0001:");
	Write_6KE(strCmd);
	Delay(DelayTime);
    return 1;
}


int ConfirmSlitHatchLimit(int PortNum){
	int inputport;
	char strCmd[256], strResponse[1024];
	
	
	sprintf(strCmd,"TIN:");
	Delay(DelayTime);
	Read_HS(strResponse);
	if(PortNum == 5)		inputport=(int)strResponse[8]-48;
	else if(PortNum ==6) 	inputport=(int)strResponse[7]-48;
	else return 100;
	return inputport;
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
///END OF SLIT HATCH OPERATION
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
