#ifndef _IDL_H
#define _IDL_H

#if defined(INCLUDE_AFTER_WINDOWS_H) && !defined(_INC_WINDOWS)
#error  This header must be included before utility.h and formatio.h
#error  because it includes cviauto.h which includes Windows SDK headers.
#endif /* INCLUDE_AFTER_WINDOWS_H */

#include <cviauto.h>

#ifdef __cplusplus
    extern "C" {
#endif
/* NICDBLD_BEGIN> Type Library Specific Types */

typedef long IDLType_OLE_HANDLE;
typedef unsigned long IDLType_OLE_COLOR;
typedef long IDLType_OLE_XPOS_PIXELS;
typedef long IDLType_OLE_YPOS_PIXELS;
typedef HRESULT (CVICALLBACK *_DIDLDrawX3EventsRegOnReadyStateChange_CallbackType) (CAObjHandle caServerObjHandle,
                                                                                    void *caCallbackData);
typedef HRESULT (CVICALLBACK *_DIDLDrawX3EventsRegOnDblClick_CallbackType) (CAObjHandle caServerObjHandle,
                                                                            void *caCallbackData);
typedef HRESULT (CVICALLBACK *_DIDLDrawX3EventsRegOnKeyDown_CallbackType) (CAObjHandle caServerObjHandle,
                                                                           void *caCallbackData,
                                                                           short *keyCode,
                                                                           short  shift);
typedef HRESULT (CVICALLBACK *_DIDLDrawX3EventsRegOnClick_CallbackType) (CAObjHandle caServerObjHandle,
                                                                         void *caCallbackData);
typedef HRESULT (CVICALLBACK *_DIDLDrawX3EventsRegOnKeyPress_CallbackType) (CAObjHandle caServerObjHandle,
                                                                            void *caCallbackData,
                                                                            short *keyAscii);
typedef HRESULT (CVICALLBACK *_DIDLDrawX3EventsRegOnMouseDown_CallbackType) (CAObjHandle caServerObjHandle,
                                                                             void *caCallbackData,
                                                                             short  button,
                                                                             short  shift,
                                                                             IDLType_OLE_XPOS_PIXELS  x,
                                                                             IDLType_OLE_YPOS_PIXELS  y);
typedef HRESULT (CVICALLBACK *_DIDLDrawX3EventsRegOnMouseMove_CallbackType) (CAObjHandle caServerObjHandle,
                                                                             void *caCallbackData,
                                                                             short  button,
                                                                             short  shift,
                                                                             IDLType_OLE_XPOS_PIXELS  x,
                                                                             IDLType_OLE_YPOS_PIXELS  y);
typedef HRESULT (CVICALLBACK *_DIDLDrawX3EventsRegOnMouseUp_CallbackType) (CAObjHandle caServerObjHandle,
                                                                           void *caCallbackData,
                                                                           short  button,
                                                                           short  shift,
                                                                           IDLType_OLE_XPOS_PIXELS  x,
                                                                           IDLType_OLE_YPOS_PIXELS  y);
/* NICDBLD_END> Type Library Specific Types */

extern const IID IDL_IID__DIDLDrawX3;
extern const IID IDL_IID_IIDLDrawX3;
extern const IID IDL_IID__DIDLDrawX3Events;

HRESULT CVIFUNC IDL_New_DIDLDrawX3 (int panel, const char *label, int top,
                                    int left, int *controlID, int *UILError);

HRESULT CVIFUNC IDL_Open_DIDLDrawX3 (const char *fileName, int panel,
                                     const char *label, int top, int left,
                                     int *controlID, int *UILError);

HRESULT CVIFUNC IDL__DIDLDrawX3InitIDL (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long hWndMain,
                                        long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetOutputWnd (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo, long hWndLog,
                                             long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetNamedData (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             const char *strName,
                                             VARIANT *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3ExecuteStr (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *strCommand,
                                           long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3CreateDrawWidget (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetNamedData (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             const char *strName, VARIANT vData,
                                             short *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetNamedArray (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *strName, VARIANT vData,
                                              VBOOL bDestroyOnFree,
                                              short *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3DoExit (CAObjHandle objectHandle,
                                       ERRORINFO *errorInfo);

HRESULT CVIFUNC IDL__DIDLDrawX3DestroyDrawWidget (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo);

HRESULT CVIFUNC IDL__DIDLDrawX3DoButtonPress (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              short nButton, short x, short y);

HRESULT CVIFUNC IDL__DIDLDrawX3DoButtonRelease (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                short nButton, short x, short y);

HRESULT CVIFUNC IDL__DIDLDrawX3DoMotion (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, short nButton,
                                         short x, short y);

HRESULT CVIFUNC IDL__DIDLDrawX3DoExpose (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo);

HRESULT CVIFUNC IDL__DIDLDrawX3RegisterForEvents (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  long lEvents,
                                                  VBOOL *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3CopyNamedArray (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               const char *strName,
                                               VARIANT *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3CopyWindow (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           VBOOL *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3Print (CAObjHandle objectHandle,
                                      ERRORINFO *errorInfo, long lXoffset,
                                      long lYoffset, long lWidth, long lHeight,
                                      VBOOL *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3PrintPreview (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             VBOOL *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3InitStringInfo (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               const char *strInfo);

HRESULT CVIFUNC IDL__DIDLDrawX3VariableExists (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               const char *strVarName,
                                               VBOOL *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3InitIDLEx (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long hWndMain,
                                          long lFlags, long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3Refresh (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo);

HRESULT CVIFUNC IDL__DIDLDrawX3AboutBox (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo);

HRESULT CVIFUNC IDL__DIDLDrawX3GetReadyState (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GethWnd (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo,
                                        IDLType_OLE_HANDLE *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SethWnd (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo,
                                        IDLType_OLE_HANDLE newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefhWnd (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             IDLType_OLE_HANDLE *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetBorderStyle (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               short *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetBorderStyle (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               short newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBorderStyle (CAObjHandle objectHandle,
                                                    ERRORINFO *errorInfo,
                                                    short *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetBackColor (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             IDLType_OLE_COLOR *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetBackColor (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             IDLType_OLE_COLOR newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBackColor (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  IDLType_OLE_COLOR *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetEnabled (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           VBOOL *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetEnabled (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, VBOOL newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefEnabled (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                VBOOL *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnButtonPress (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnButtonPress (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnButtonPress (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnButtonRelease (CAObjHandle objectHandle,
                                                   ERRORINFO *errorInfo,
                                                   char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnButtonRelease (CAObjHandle objectHandle,
                                                   ERRORINFO *errorInfo,
                                                   const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnButtonRelease (CAObjHandle objectHandle,
                                                        ERRORINFO *errorInfo,
                                                        char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnMotion (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnMotion (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnMotion (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnInit (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnInit (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnInit (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnExpose (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnExpose (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnExpose (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetBaseName (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetBaseName (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBaseName (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetDrawWidgetName (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetDrawWidgetName (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefDrawWidgetName (CAObjHandle objectHandle,
                                                       ERRORINFO *errorInfo,
                                                       char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetGetValueName (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetGetValueName (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefGetValueName (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetXsize (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetXsize (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefXsize (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              long *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetYsize (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetYsize (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefYsize (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              long *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetXoffset (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetXoffset (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, long newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefXoffset (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                long *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetYoffset (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetYoffset (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, long newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefYoffset (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                long *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetScroll (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          VBOOL *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetScroll (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, VBOOL newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefScroll (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               VBOOL *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetRetain (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          short *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetRetain (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, short newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefRetain (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               short *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetGraphicsLevel (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 short *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetGraphicsLevel (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 short newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefGraphicsLevel (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      short *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetDrawId (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetDrawId (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefDrawId (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               long *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetBaseId (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetBaseId (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBaseId (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               long *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetOnDblClick (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetOnDblClick (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefOnDblClick (CAObjHandle objectHandle,
                                                   ERRORINFO *errorInfo,
                                                   char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetIdlPath (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetIdlPath (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefIdlPath (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetXviewport (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetXviewport (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo, long newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefXviewport (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  long *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetYviewport (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetYviewport (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo, long newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefYviewport (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  long *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetVisible (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           VBOOL *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetVisible (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, VBOOL newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefVisible (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                VBOOL *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetRenderer (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            short *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetRenderer (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, short newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefRenderer (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 short *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetLastIdlError (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                char **returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetLastIdlError (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                const char *newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefLastIdlError (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     char **newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3GetBufferId (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            long *returnValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetBufferId (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, long newValue);

HRESULT CVIFUNC IDL__DIDLDrawX3SetByRefBufferId (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 long *newValue);

HRESULT CVIFUNC IDL_NewIIDLDrawX3 (int panel, const char *label, int top,
                                   int left, int *controlID, int *UILError);

HRESULT CVIFUNC IDL_OpenIIDLDrawX3 (const char *fileName, int panel,
                                    const char *label, int top, int left,
                                    int *controlID, int *UILError);

HRESULT CVIFUNC IDL_IIDLDrawX3GetReadyState (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             long *lReadyState);

HRESULT CVIFUNC IDL_IIDLDrawX3GethWnd (CAObjHandle objectHandle,
                                       ERRORINFO *errorInfo,
                                       IDLType_OLE_HANDLE *ohhWnd);

HRESULT CVIFUNC IDL_IIDLDrawX3SetBorderStyle (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              short sBorderStyle);

HRESULT CVIFUNC IDL_IIDLDrawX3GetBorderStyle (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              short *sBorderStyle);

HRESULT CVIFUNC IDL_IIDLDrawX3SetBackColor (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            IDLType_OLE_COLOR pocColor);

HRESULT CVIFUNC IDL_IIDLDrawX3GetBackColor (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            IDLType_OLE_COLOR *pocColor);

HRESULT CVIFUNC IDL_IIDLDrawX3SetEnable (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, VBOOL pbEnable);

HRESULT CVIFUNC IDL_IIDLDrawX3GetEnable (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, VBOOL *pbEnable);

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnButtonPress (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                const char *bstOnButtonPress);

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnButtonPress (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                char **bstOnButtonPress);

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnButtonRelease (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  const char *bstOnButtonRelease);

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnButtonRelease (CAObjHandle objectHandle,
                                                  ERRORINFO *errorInfo,
                                                  char **bstOnButtonRelease);

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnMotion (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *bstOnMotion);

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnMotion (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           char **bstOnMotion);

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnInit (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo,
                                         const char *bstOnInit);

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnInit (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, char **bstOnInit);

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnExpose (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *bstOnExpose);

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnExpose (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           char **bstOnExpose);

HRESULT CVIFUNC IDL_IIDLDrawX3SetBaseName (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           const char *bstBaseName);

HRESULT CVIFUNC IDL_IIDLDrawX3GetBaseName (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           char **bstBaseName);

HRESULT CVIFUNC IDL_IIDLDrawX3SetDrawWidgetName (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 const char *bstDrawWidgetName);

HRESULT CVIFUNC IDL_IIDLDrawX3GetDrawWidgetName (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 char **bstDrawWidgetName);

HRESULT CVIFUNC IDL_IIDLDrawX3SetGetValueName (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               const char *bstGetValueName);

HRESULT CVIFUNC IDL_IIDLDrawX3GetGetValueName (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               char **bstGetValueName);

HRESULT CVIFUNC IDL_IIDLDrawX3SetXsize (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long lXsize);

HRESULT CVIFUNC IDL_IIDLDrawX3GetXsize (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long *lXsize);

HRESULT CVIFUNC IDL_IIDLDrawX3SetYsize (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long lYsize);

HRESULT CVIFUNC IDL_IIDLDrawX3GetYsize (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, long *lYsize);

HRESULT CVIFUNC IDL_IIDLDrawX3SetXoffset (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long lXoffset);

HRESULT CVIFUNC IDL_IIDLDrawX3GetXoffset (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long *lXoffset);

HRESULT CVIFUNC IDL_IIDLDrawX3SetYoffset (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long lYoffset);

HRESULT CVIFUNC IDL_IIDLDrawX3GetYoffset (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, long *lYoffset);

HRESULT CVIFUNC IDL_IIDLDrawX3SetScroll (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, VBOOL bScroll);

HRESULT CVIFUNC IDL_IIDLDrawX3GetScroll (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, VBOOL *bScroll);

HRESULT CVIFUNC IDL_IIDLDrawX3SetRetain (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, short sRetain);

HRESULT CVIFUNC IDL_IIDLDrawX3GetRetain (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, short *sRetain);

HRESULT CVIFUNC IDL_IIDLDrawX3SetGraphicsLevel (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                short sGraphicsLevel);

HRESULT CVIFUNC IDL_IIDLDrawX3GetGraphicsLevel (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                short *sGraphicsLevel);

HRESULT CVIFUNC IDL_IIDLDrawX3GetDrawId (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long *lDrawId);

HRESULT CVIFUNC IDL_IIDLDrawX3GetBaseId (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long *lBaseId);

HRESULT CVIFUNC IDL_IIDLDrawX3SetOnDblClick (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             const char *bstOnDblClick);

HRESULT CVIFUNC IDL_IIDLDrawX3GetOnDblClick (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             char **bstOnDblClick);

HRESULT CVIFUNC IDL_IIDLDrawX3SetIdlPath (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          const char *bstIdlPath);

HRESULT CVIFUNC IDL_IIDLDrawX3GetIdlPath (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          char **bstIdlPath);

HRESULT CVIFUNC IDL_IIDLDrawX3SetXviewport (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, long xviewport);

HRESULT CVIFUNC IDL_IIDLDrawX3GetXviewport (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            long *xviewport);

HRESULT CVIFUNC IDL_IIDLDrawX3SetYviewport (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, long yviewport);

HRESULT CVIFUNC IDL_IIDLDrawX3GetYviewport (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            long *yviewport);

HRESULT CVIFUNC IDL_IIDLDrawX3SetVisible (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, VBOOL bVisible);

HRESULT CVIFUNC IDL_IIDLDrawX3GetVisible (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, VBOOL *bVisible);

HRESULT CVIFUNC IDL_IIDLDrawX3SetRenderer (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, short sRenderer);

HRESULT CVIFUNC IDL_IIDLDrawX3GetRenderer (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           short *sRenderer);

HRESULT CVIFUNC IDL_IIDLDrawX3GetLastIdlError (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               char **bstError);

HRESULT CVIFUNC IDL_IIDLDrawX3SetBufferId (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, long plBuffId);

HRESULT CVIFUNC IDL_IIDLDrawX3GetBufferId (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, long *plBuffId);

HRESULT CVIFUNC IDL_IIDLDrawX3InitIDL (CAObjHandle objectHandle,
                                       ERRORINFO *errorInfo, long hWndMain,
                                       long *lInited);

HRESULT CVIFUNC IDL_IIDLDrawX3SetOutputWnd (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, long hWndLog,
                                            long *lRet);

HRESULT CVIFUNC IDL_IIDLDrawX3GetNamedData (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *strName, VARIANT *vREt);

HRESULT CVIFUNC IDL_IIDLDrawX3ExecuteStr (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo,
                                          const char *strCommand, long *lErr);

HRESULT CVIFUNC IDL_IIDLDrawX3CreateDrawWidget (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo,
                                                long *lDrawId);

HRESULT CVIFUNC IDL_IIDLDrawX3SetNamedData (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            const char *strName, VARIANT vData,
                                            short *sRet);

HRESULT CVIFUNC IDL_IIDLDrawX3SetNamedArray (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             const char *strName, VARIANT vData,
                                             VBOOL bDestroyOnFree, short *sRet);

HRESULT CVIFUNC IDL_IIDLDrawX3DoExit (CAObjHandle objectHandle,
                                      ERRORINFO *errorInfo);

HRESULT CVIFUNC IDL_IIDLDrawX3DestroyDrawWidget (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo);

HRESULT CVIFUNC IDL_IIDLDrawX3DoButtonPress (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo, short nButton,
                                             short x, short y);

HRESULT CVIFUNC IDL_IIDLDrawX3DoButtonRelease (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               short nButton, short x, short y);

HRESULT CVIFUNC IDL_IIDLDrawX3DoMotion (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, short nButton,
                                        short x, short y);

HRESULT CVIFUNC IDL_IIDLDrawX3DoExpose (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo);

HRESULT CVIFUNC IDL_IIDLDrawX3RegisterForEvents (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 long lEvents, VBOOL *bVal);

HRESULT CVIFUNC IDL_IIDLDrawX3CopyNamedArray (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *strName,
                                              VARIANT *vArray);

HRESULT CVIFUNC IDL_IIDLDrawX3CopyWindow (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, VBOOL *bCopied);

HRESULT CVIFUNC IDL_IIDLDrawX3Print (CAObjHandle objectHandle,
                                     ERRORINFO *errorInfo, long lXoffset,
                                     long lYoffset, long lWidth, long lHeight,
                                     VBOOL *bPrinted);

HRESULT CVIFUNC IDL_IIDLDrawX3PrintPreview (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            VBOOL *bPrinted);

HRESULT CVIFUNC IDL_IIDLDrawX3InitStringInfo (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *strInfo);

HRESULT CVIFUNC IDL_IIDLDrawX3VariableExists (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              const char *strName,
                                              VBOOL *bExists);

HRESULT CVIFUNC IDL_IIDLDrawX3InitIDLEx (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, long hWndMain,
                                         long lFlags, long *lInited);

HRESULT CVIFUNC IDL_IIDLDrawX3Refresh (CAObjHandle objectHandle,
                                       ERRORINFO *errorInfo);

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnReadyStateChange (CAObjHandle serverObject,
                                                            _DIDLDrawX3EventsRegOnReadyStateChange_CallbackType callbackFunction,
                                                            void *callbackData,
                                                            int enableCallbacks,
                                                            int *callbackId);

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnDblClick (CAObjHandle serverObject,
                                                    _DIDLDrawX3EventsRegOnDblClick_CallbackType callbackFunction,
                                                    void *callbackData,
                                                    int enableCallbacks,
                                                    int *callbackId);

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnKeyDown (CAObjHandle serverObject,
                                                   _DIDLDrawX3EventsRegOnKeyDown_CallbackType callbackFunction,
                                                   void *callbackData,
                                                   int enableCallbacks,
                                                   int *callbackId);

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnClick (CAObjHandle serverObject,
                                                 _DIDLDrawX3EventsRegOnClick_CallbackType callbackFunction,
                                                 void *callbackData,
                                                 int enableCallbacks,
                                                 int *callbackId);

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnKeyPress (CAObjHandle serverObject,
                                                    _DIDLDrawX3EventsRegOnKeyPress_CallbackType callbackFunction,
                                                    void *callbackData,
                                                    int enableCallbacks,
                                                    int *callbackId);

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnMouseDown (CAObjHandle serverObject,
                                                     _DIDLDrawX3EventsRegOnMouseDown_CallbackType callbackFunction,
                                                     void *callbackData,
                                                     int enableCallbacks,
                                                     int *callbackId);

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnMouseMove (CAObjHandle serverObject,
                                                     _DIDLDrawX3EventsRegOnMouseMove_CallbackType callbackFunction,
                                                     void *callbackData,
                                                     int enableCallbacks,
                                                     int *callbackId);

HRESULT CVIFUNC IDL__DIDLDrawX3EventsRegOnMouseUp (CAObjHandle serverObject,
                                                   _DIDLDrawX3EventsRegOnMouseUp_CallbackType callbackFunction,
                                                   void *callbackData,
                                                   int enableCallbacks,
                                                   int *callbackId);
#ifdef __cplusplus
    }
#endif
#endif /* _IDL_H */
